////////////////////////////////////////////////////////////////////////////////
/*! @file RigakuAPRI.h   Drivers for XRD Rigaku with APRI ML-327.
- Part of RigakuAPRI - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef RigakuAPRI_H
#define RigakuAPRI_H
#include "RAPlugins.h"
namespace RA {
//------------------------------------------------------------------------------

#if defined(RigakuAPRI_PLUGIN_BUILD)
    #define RigakuAPRI_EXPORT Q_DECL_EXPORT
#elif defined(RigakuAPRI_PLUGIN_USE)
    #define RigakuAPRI_EXPORT Q_DECL_IMPORT
#else
    #define RigakuAPRI_EXPORT
#endif

//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sRigakuAPRI)

//------------------------------------------------------------------------------

class sRigakuAPRI : public QObject ,public sInstrumentalPackage
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "BursianSoft.RA.sInstrumentalPackage")
    Q_INTERFACES(RA::sInstrumentalPackage)
    ADAM(sRigakuAPRI)

  public:
    virtual sVersion          Version ();
    virtual sVersion          CoreVersionUsed ();
    virtual sVersion          CoreVersionMin ();
    virtual QString           UserFriendlyName ();
    virtual QString           About ();
    virtual bool              HasDefaults ()
                                { return true; }
    virtual void              InstallDefaults (sPtr<sFolderNode>  DeviceList);
                              sRigakuAPRI ();
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
