////////////////////////////////////////////////////////////////////////////////
/*! @file DistWizard.h   Мастер формирования составного дистрибутива.
- Uses  RAGUI - Research Assistant Graphical User Interface Library.
- Uses  RANet - Research Assistant Net Library.
- Uses  Qt v.5  -  http://qt-project.org/
- Copyright(C) 2011-2015, Viktor E. Bursian, St.Petersburg, Russia.
                          VBursian@gmail.com
*///////////////////////////////////////////////////////////////////////////////
#ifndef DistWizard_H
#define DistWizard_H
#include "DistribJob.h"
#include <QWizard>
#include <QDir>
#include <QSignalMapper>
#include <QLineEdit>
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sDistWizard)
ANNOUNCE_CLASS(sSelectPage)
ANNOUNCE_CLASS(sMakePage)

//-------------------------------------------------------------- sDistWizard ---

class  sDistWizard : public QWizard
{
  Q_OBJECT
  public:
                              sDistWizard (bool  testing);
  public:
    enum                      {SelectPage
                              ,MakePage
                              };

  private://fields
    psDistribJob              Job;
};

//-------------------------------------------------------------- sSelectPage ---

class  sSelectPage : public sExecutivePage
{
  Q_OBJECT
  public:
                              sSelectPage (psDistribJob);
  public:
    virtual bool              isComplete () const;

//  signals:
//    void                      TranslateRequested (const QString &  name);

  private slots:
    void                      UpdateTrInfo (const QString &  name);
    void                      Translate (const QString &  name);

  protected:

  private://fields
    psDistribJob              Job;
    QLineEdit *               PluginSetName;
    QSignalMapper *           TranslateRequestMapper;
};

//---------------------------------------------------------------- sMakePage ---

class  sMakePage : public sDoItPage
{
  Q_OBJECT
  public:
                              sMakePage (psDistribJob);

  protected:
    virtual bool              DoIt ();

  private: //reimplementing inherited:
    virtual void              initializePage ();

  private://fields
    psDistribJob              Job;
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
