////////////////////////////////////////////////////////////////////////////////
/*! @file DistribJob.h
- Uses  RAGUI - Research Assistant Graphical User Interface Library.
- Uses  RANet - Research Assistant Net Library.
- Uses  Qt v.5  -  http://qt-project.org/
- Copyright(C) 2011-2015, Viktor E. Bursian, St.Petersburg, Russia.
                          VBursian@gmail.com
*///////////////////////////////////////////////////////////////////////////////
#ifndef DistribJob_H
#define DistribJob_H
#include "CommonDist.h"
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sDistribJob)

//------------------------------------------------------------- sDistribJob ---

class sDistribJob : public sApplicationJob
{
  public://static const
    static const QStringList  CoreFiles4unix;
    static const QStringList  CoreFiles4win32;
    static const QStringList  CoreFiles4all;
    static const QStringList  CoreSources;
    static const QStringList  PluginFiles4unix;
    static const QStringList  PluginFiles4win32;
    static const QStringList  PluginFiles4all;
    static const QStringList  PluginSources;
    static const QStringList  QtBinaries4RA_unix;
    static const QStringList  QtBinaries4RA_win32;
    static const QStringList  QtLibraries4RA_unix;
    static const QStringList  QtPlugins4install;
    static const QStringList  QtPlugins4RA;

  public:
                              sDistribJob (bool  testing);
    bool                      AnalizeProject ();
    bool                      MakeDirs (bool  this_is_a_release);
    bool                      MakeIt (bool  this_is_a_release);
    bool                      GenerateDox ();
    bool                      CompileHelp ();
    bool                      MakeCoreDist ();
    bool                      PackCoreSrc ();
    bool                      MakePluginDist (QString  plugin);
    bool                      PackPluginSrc (QString  plugin);
    bool                      MakeQtFiles ();
    bool                      CopyFiles4Install (bool  this_is_a_release);
    bool                      CopyFonts ();
    bool                      Copy3dPartySrcZips ();
    bool                      WrapIntoSFX ();

  public://fields
    QDir                      RADir;
    QDir                      BinDir;
    QDir                      ThirdPartyDir;
    QDir                      DistributivesDir;
    QDir                      DistDir;
    QString                   DistBasename;
    QString                   DistBasenameWithVersion;
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
