////////////////////////////////////////////////////////////////////////////////
/*! @file AboutRA.cpp   Вывод справки о программе.
- Part of RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#include "AboutRA.h"
#include "Version.h"
#include "Environment.h"
#include "Net.h"
#include "StringsAndQStrings.h"
#include "Helper.h"
namespace RA {
//------------------------------------------------------------------------------

sAboutRA::sAboutRA (QWidget *  parent)
    :QDialog(parent)
{
  setObjectName(QString::fromUtf8("sAboutRA"));
  setWindowTitle(tr("About RA"));
  resize(289, 332);
  resize(200, 200);
  VerticalLayout = new QVBoxLayout(this);
  VerticalLayout->setObjectName(QString::fromUtf8("verticalLayout_2"));
  HorizontalLayout_1 = new QHBoxLayout();
  HorizontalLayout_1->setObjectName(QString::fromUtf8("horizontalLayout_2"));

  label_pic = new QLabel(this);
  label_pic->setObjectName(QString::fromUtf8("label_pic"));
  label_pic->setPixmap(QPixmap(":/RAGUI/images/aboutra.png"));
  label_pic->setText(QString());
  HorizontalLayout_1->addWidget(label_pic);

  InfoLayout = new QVBoxLayout();
  InfoLayout->setObjectName(QString::fromUtf8("verticalLayout"));
  InfoLayout->setMargin(0);

  label_R = new QLabel(this);
  label_R->setObjectName(QString::fromUtf8("label_R"));
  label_R->setText(tr("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\" \"http://www.w3.org/TR/REC-html40/strict.dtd\">\n"
"<html><head><meta name=\"qrichtext\" content=\"1\" /><style type=\"text/css\">\n"
"p, li { white-space: pre-wrap; }\n"
"</style></head><body style=\" font-family:'Sans'; font-size:10pt; font-weight:400; font-style:normal;\">\n"
"<p style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:36pt; font-style:italic;\">R</span><span style=\" font-size:24pt; font-style:italic; vertical-align:super;\">esearch</span></p></body></html>"));
  InfoLayout->addWidget(label_R);

  label_A = new QLabel(this);
  label_A->setObjectName(QString::fromUtf8("label_A"));
  label_A->setText(tr("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\" \"http://www.w3.org/TR/REC-html40/strict.dtd\">\n"
"<html><head><meta name=\"qrichtext\" content=\"1\" /><style type=\"text/css\">\n"
"p, li { white-space: pre-wrap; }\n"
"</style></head><body style=\" font-family:'Sans'; font-size:10pt; font-weight:400; font-style:normal;\">\n"
"<p style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" font-size:36pt; font-style:italic;\">  A</span><span style=\" font-size:24pt; font-style:italic; vertical-align:super;\">ssistant</span></p></body></html>"));
  InfoLayout->addWidget(label_A);

//-------------------------------
//  label_R->setText(tr("<i><font size=+20>"
//                      "<sup>R</sup><sub>A</sub>"
//                      "</font><font size=+3>"
//                      "<sup>e</sup><sub>s</sub>"
//                      "<sup>s</sup><sub>s</sub>"
//                      "<sup>e</sup><sub>i</sub>"
//                      "<sup>a</sup><sub>s</sub>"
//                      "<sup>r</sup><sub>t</sub>"
//                      "<sup>c</sup><sub>a</sub>"
//                      "<sup>h</sup><sub>n</sub>"
//                      "<sup> </sup><sub>t</sub>"
//                      ));
//-------------------------------
//  label_R->setText(QString::fromUtf8("<i><font color=chocolate>"
//      "<font size=36>R</font><font size=+3><sup>esearch"));
//  label_A->setText(QString::fromUtf8("<i><font color=chocolate>"
//      "<font size=36>&nbsp;&nbsp;A</font><font size=+3><sup>ssistant"));
//-------------------------------

  label_by = new QLabel(this);
  label_by->setObjectName(QString::fromUtf8("label_by"));
  label_by->setAlignment(Qt::AlignCenter);
  label_by->setText(tr("<br>by<br><font size=+1>Viktor E. Bursian</font><br>"
                       "<font size=-1>and</font><br>"
                       "Dmitry K. Nelson"
                       ));
  InfoLayout->addWidget(label_by);

  HorizontalLayout_1->addLayout(InfoLayout);

  VerticalLayout->addLayout(HorizontalLayout_1);

  formLayout = new QFormLayout();
  formLayout->setObjectName(QString::fromUtf8("formLayout"));
  formLayout->setLabelAlignment(Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter);

  label_Version = new QLabel(this);
  label_Version->setObjectName(QString::fromUtf8("label_Version"));
  label_Version->setText(tr("Version:"));
  formLayout->setWidget(0, QFormLayout::LabelRole, label_Version);


  field_Version = new QLabel(this);
  field_Version->setObjectName(QString::fromUtf8("field_Version"));
  field_Version->setText(ToQString(RANet::Version.Text()));
  formLayout->setWidget(0, QFormLayout::FieldRole, field_Version);

//  label_RANetId = new QLabel(this);
//  label_RANetId->setObjectName(QString::fromUtf8("label_RANetId"));
//  label_RANetId->setText(tr("RANet Id:"));
//  formLayout->setWidget(3, QFormLayout::LabelRole, label_RANetId);

//  sString                     V;
//  V = sNet::Manager->Owner;
//  V += '.';
//  V << sNet::Manager->Copy;

//  field_Datanet = new QLabel(this);
//  field_Datanet->setObjectName(QString::fromUtf8("field_RANetId"));
//  field_Datanet->setText(ToQString(V));
//  formLayout->setWidget(3, QFormLayout::FieldRole, field_Datanet);

  VerticalLayout->addLayout(formLayout);

  VerticalSpacer = new QSpacerItem(20, 40, QSizePolicy::Minimum, QSizePolicy::Expanding);
  VerticalLayout->addItem(VerticalSpacer);

  ButtonLayout = new QHBoxLayout();
  ButtonLayout->setObjectName("ButtonLayout");

  BtnDetails = new QPushButton(tr("Details"),this);
  BtnDetails->setObjectName("BtnDetails");
  connect(BtnDetails,SIGNAL(clicked()),this,SLOT(ShowDetails()));
  ButtonLayout->addWidget(BtnDetails);

  BtnClose = new QPushButton(tr("Close"),this);
  BtnClose->setObjectName("BtnClose");
  connect(BtnClose,SIGNAL(clicked()),this,SLOT(close()));
  ButtonLayout->addWidget(BtnClose);

  VerticalLayout->addLayout(ButtonLayout);
}


void  sAboutRA::ShowDetails ()
{
  sHelper::ShowKeyId("sAboutRA");
}

//------------------------------------------------------------------------------
} //namespace RA



