////////////////////////////////////////////////////////////////////////////////
/*! @file AboutRA.h   Вывод справки о программе.
- Part of RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef AboutRA_H
#define AboutRA_H
#include "RAGUI_global.h"
#include <QDialog>
#include <QFormLayout>
#include <QHBoxLayout>
#include <QVBoxLayout>
#include <QLabel>
#include <QPushButton>
namespace RA {
//------------------------------------------------------------------------------

class RAGUI_EXPORT  sAboutRA : public QDialog
{
  Q_OBJECT
  public:
                              sAboutRA (QWidget *  parent = NULL);

  private slots:
    void                      ShowDetails ();

  private:
    QVBoxLayout *             VerticalLayout;
    QHBoxLayout *             HorizontalLayout_1;
    QHBoxLayout *             ButtonLayout;
    QLabel *                  label_pic;
    QVBoxLayout *             InfoLayout;
    QLabel *                  label_R;
    QLabel *                  label_A;
    QLabel *                  label_by;
    QFormLayout *             formLayout;
    QLabel *                  label_Version;
    QLabel *                  field_Version;
    QLabel *                  label_Customization;
    QLabel *                  field_Customization;
    QLabel *                  label_Release;
    QLabel *                  field_Release;
    QLabel *                  label_RANetId;
    QLabel *                  field_Datanet;
    QSpacerItem *             VerticalSpacer;
    QPushButton *             BtnDetails;
    QPushButton *             BtnClose;
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
