////////////////////////////////////////////////////////////////////////////////
/*! @file ActionSignallingText.cpp   Полезный вид QAction.
- Part of RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#include "ActionSignallingText.h"
namespace RA {
//------------------------------------------------------------------------------
//---------------------------------------------------- sActionSignallingText ---

sActionSignallingText::~sActionSignallingText ()
{
  disconnect();
}

sActionSignallingText::sActionSignallingText (QObject *        parent)
    :QAction(parent)
{
  connect(this,SIGNAL(triggered()) ,this,SLOT(EmitSignals()));
}


sActionSignallingText::sActionSignallingText (const QString &  text
                                             ,QObject *        parent)
    :QAction(text,parent)
{
  connect(this,SIGNAL(triggered()) ,this,SLOT(EmitSignals()));
}


sActionSignallingText::sActionSignallingText (const QIcon &    icon
                                             ,const QString &  text
                                             ,QObject *        parent)
    :QAction(icon,text,parent)
{
  connect(this,SIGNAL(triggered()) ,this,SLOT(EmitSignals()));
}


void  sActionSignallingText::EmitSignals ()
{
  emit TitleSignal(text());
  emit DataStringSignal(TheDataString);
}

//------------------------------------------------------------------------------
} //namespace RA
