////////////////////////////////////////////////////////////////////////////////
/*! @file ActionSignallingText.h   Полезный вид QAction.
- Part of RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef ActionSignallingText_H
#define ActionSignallingText_H
#include "RAGUI_global.h"
#include <QString>
#include <QAction>

namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sActionSignallingText)

//---------------------------------------------------- sActionSignallingText ---

class RAGUI_EXPORT  sActionSignallingText : public QAction
{
  Q_OBJECT
  public:
    virtual                   ~sActionSignallingText ();
                              sActionSignallingText
                                        (QObject *        parent = NULL);
                              sActionSignallingText
                                        (const QString &  text
                                        ,QObject *        parent = NULL);
                              sActionSignallingText
                                        (const QIcon &    icon
                                        ,const QString &  text
                                        ,QObject *        parent = NULL);
    QString                   DataString () const
                                { return TheDataString; }
    void                      SetDataString (QString  S)
                                { TheDataString = S; }
  signals:
    void                      TitleSignal (QString);
    void                      DataStringSignal (QString);
  private slots:
    void                      EmitSignals ();

  private://fields
    QString                   TheDataString;
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
