////////////////////////////////////////////////////////////////////////////////
/*! @file AttrDlg.h   Class sAttrDlg.
- Part of RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef AttrDlg_H
#define AttrDlg_H
#include "RAGUI_global.h"
#include "AttrName.h"
#include <QDialog>
#include <QVBoxLayout>
#include <QFrame>
#include <QHBoxLayout>
#include <QGroupBox>
#include <QGridLayout>
#include <QRadioButton>
#include <QLabel>
#include <QSpinBox>
#include <QLineEdit>
#include <QSpacerItem>
#include <QDialogButtonBox>
namespace RA {
//------------------------------------------------------------------------------

class RAGUI_EXPORT  sAttrDlg : public QDialog
{
  Q_OBJECT
  public://static
    static const QString &    ErrorMsgOnAddAttr ();

  public:
    virtual                   ~sAttrDlg ();
    explicit                  sAttrDlg (QWidget *  parent = 0);
    void                      SetAttrName (sAttrName);
    void                      SetAttrNameEnabled (bool);
    sAttrName                 AttrName ()
                                { return TheAttrName; }

  public slots:
    virtual void              OnOK ();
    virtual void              ShowHelp ();

  public:
    QGridLayout *             ValueSpace;

  protected:
    virtual bool              Validate (); //true on success
    virtual void              Retranslate ();

  protected://inherited
    virtual void              changeEvent (QEvent *);

  private://fields
    sAttrName                 TheAttrName;
    QVBoxLayout *             Layout;
    QFrame *                  areaAttrName;
    QHBoxLayout *             horizontalLayout;
    QGroupBox *               groupBox;
    QGridLayout *             gridLayout;
  protected://fields
    QRadioButton *            btnNameless;
    QRadioButton *            btnAtomic;
    QLabel *                  fldAtomId;
    QRadioButton *            btnNumeric;
    QSpinBox *                fldNumber;
    QRadioButton *            btnSymbolic;
    QLineEdit *               fldSymbolicName;
    QSpacerItem *             verticalSpacer;
    QDialogButtonBox *        buttonBox;
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
