////////////////////////////////////////////////////////////////////////////////
/*! @file BasicNodesUI.h   Функционал навигатора, специфичный для
                           базовых типов терминальных объектов сети.
- Part of RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef BasicNodesUI_H
#define BasicNodesUI_H
#include "NetView.h"
namespace RA {
//------------------------------------------------------------------------------
//-------------------------------------------------------------- sTextNodeUI ---

class sTextNodeUI
{
  public:
                              sTextNodeUI ();
    static void               MenuGenerator (psNetViewMenu
                                            ,sNet2TreeEvolution::pcsItem);
    static void               EditValue (sNet2TreeEvolution::pcsItem ,sPoint);
    static void               AddNew (sNet2TreeEvolution::pcsItem ,sPoint);
    static void               InsertNew (sNet2TreeEvolution::pcsItem ,sPoint);
};

//----------------------------------------------------------- sIntegerNodeUI ---

class sIntegerNodeUI
{
  public:
                              sIntegerNodeUI ();
    static void               MenuGenerator (psNetViewMenu
                                            ,sNet2TreeEvolution::pcsItem);
    static void               EditValue (sNet2TreeEvolution::pcsItem ,sPoint);
    static void               AddNew (sNet2TreeEvolution::pcsItem ,sPoint);
    static void               InsertNew (sNet2TreeEvolution::pcsItem ,sPoint);
};

//----------------------------------------------------------- sBooleanNodeUI ---

class sBooleanNodeUI : public QObject
{
  Q_OBJECT
  public:
                              sBooleanNodeUI ();
    static void               MenuGenerator (psNetViewMenu
                                            ,sNet2TreeEvolution::pcsItem);
    static void               EditValue (sNet2TreeEvolution::pcsItem ,sPoint);
    static void               AddNew (sNet2TreeEvolution::pcsItem ,sPoint);
    static void               InsertNew (sNet2TreeEvolution::pcsItem ,sPoint);
};

//--------------------------------------------------------- sPhysValueNodeUI ---

class sPhysValueNodeUI
{
  public:
                              sPhysValueNodeUI ();
    static void               MenuGenerator (psNetViewMenu
                                            ,sNet2TreeEvolution::pcsItem);
    static void               EditValue (sNet2TreeEvolution::pcsItem ,sPoint);
    static void               AddNew (sNet2TreeEvolution::pcsItem ,sPoint);
    static void               InsertNew (sNet2TreeEvolution::pcsItem ,sPoint);
};

//--------------------------------------------------------- sPhysRangeNodeUI ---

class sPhysRangeNodeUI
{
  public:
                              sPhysRangeNodeUI ();
    static void               MenuGenerator (psNetViewMenu
                                            ,sNet2TreeEvolution::pcsItem);
    static void               EditValue (sNet2TreeEvolution::pcsItem ,sPoint);
    static void               AddNew (sNet2TreeEvolution::pcsItem ,sPoint);
    static void               InsertNew (sNet2TreeEvolution::pcsItem ,sPoint);
};

//------------------------------------------------------------------------------
}; //namespace RA
#endif // BasicNodesUI_H
