////////////////////////////////////////////////////////////////////////////////
/*! @file ByeScreen.cpp Bye-bye screen shown while quitting RA.
- Part of RAGUI - Research Assistant Graphical User Interface Library.
- Uses  Qt v.5.0.2  - http://qt-project.org/
- Uses  RANet - Research Assistant Net Library.
- Copyright(C) 2014, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#include "ByeScreen.h"
#include "Log.h"
#include <QVBoxLayout>
#include <QLabel>
#include <QTimer>
#include <QCoreApplication>
namespace RA {
//------------------------------------------------------------------------------
//--------------------------------------------------------------- sByeScreen ---

sByeScreen::~sByeScreen()
{
  RANet::Log.Put(sLog::Debug,"Quitting","sByeScreen destructor");
  QTimer::singleShot(TIME_LAG_FOR_sByeScreen,qApp,SLOT(quit()));
}

sByeScreen::sByeScreen (psNet  net) 
    :QWidget(NULL)
    ,Net(net)
{
  setAttribute(Qt::WA_DeleteOnClose);
//  setWindowFlags(Qt::Dialog & ~Qt::WindowCloseButtonHint);
//  setWindowFlags(Qt::SplashScreen | Qt::WindowStaysOnTopHint);
//  setWindowFlags(Qt::Popup | Qt::WindowStaysOnTopHint);
  setWindowFlags(Qt::Window | Qt::FramelessWindowHint
                            | Qt::WindowStaysOnTopHint);

  QVBoxLayout *               Layout = new QVBoxLayout(this);
  
  QLabel *                    Picture = new QLabel(this);
  Picture->setPixmap(QPixmap(":/RAGUI/images/aboutra.png"));
  Layout->addWidget(Picture);
  
  Layout->addWidget(new QLabel("<i><font size=+1>Storing...</font></i>",this));
  Layout->addWidget(new QLabel("<i><font size=+2>Please,</font></i>",this));
  Layout->addWidget(new QLabel("<i><font size=+4>wait!</font></i>",this));
}


void  sByeScreen::closeEvent (QCloseEvent *  event)
{
  RANet::Log.Put(sLog::Debug,"Quitting","sByeScreen::closeEvent");
  
//  DoDummyJob(10000);
  
  if( Net )
    Net->Close();
  RANet::Log.Put(sLog::Debug,"Quitting","sByeScreen::closeEvent:  Net closed");
  event->accept();
}

//------------------------------------------------------------------------------
} //namespace RA
