////////////////////////////////////////////////////////////////////////////////
/*! @file ByeScreen.h   Bye-bye screen shown while quitting RA.
- Part of RAGUI - Research Assistant Graphical User Interface Library.
- Uses  Qt v.5.0.2  - http://qt-project.org/
- Uses  RANet - Research Assistant Net Library.
- Copyright(C) 2014, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef ByeScreen_H
#define ByeScreen_H
#include "RAGUI_global.h"
#include "Net.h"
#include <QWidget>
#include <QCloseEvent>
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sByeScreen)

//--------------------------------------------------------------- sByeScreen ---
/*! Bye-bye screen shown while quitting RA.
*/
//class RAGUI_EXPORT  sByeScreen : public QDockWidget
class RAGUI_EXPORT  sByeScreen : public QWidget
{
  Q_OBJECT
  public:
    virtual                   ~sByeScreen ();
    explicit                  sByeScreen (psNet  net);
    
  signals:
    void                      QuittingIsAllowed ();
    
  protected://inherited
    virtual void              closeEvent (QCloseEvent *);
    
  private:
    psNet                     Net;
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
