////////////////////////////////////////////////////////////////////////////////
/*! @file CSVImportDialog.h   CSV-file import as a sDataListFolder.
- Part of RAGUI - Research Assistant Graphical User Interface.
- Uses  Qt v.5  - http://qt.io/
- Uses  RANet - Research Assistant Net Library.
- Copyright(C) 2017, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef CSVImportDialog_H
#define CSVImportDialog_H
#include "EditDocketDialog.h"
#include "DataListFolder.h"
#include <QFile>
#include <QCheckBox>
#include <QSpinBox>
#include <QLineEdit>
#include <QComboBox>
#include <QTextEdit>
namespace RA {
//------------------------------------------------------------------------------

class sCSVImportDialog : public sEditDocketDialog
{
  Q_OBJECT
  public:
    virtual                   ~sCSVImportDialog ();
    explicit                  sCSVImportDialog (QString    file_path
                                               ,QWidget *  parent = 0);

  public://fields
    sPtr<sDataListFolder>     Value;

  protected://reimplementing inherited
    virtual bool              Validate (); //true on success

  protected slots:
    virtual void              OnEditReadUnitsChkBox ();
    virtual void              OnEditUnitsLineField ();
    virtual void              OnEditValuesFirstLineField ();
    bool                      ParseOnly ()
                                { return Parse(false); }

  protected:
    bool                      ParseAndCreate ()
                                { return Parse(true); }
    virtual bool              Parse (bool  create_record);
    void                      RestoreSettings ();
    virtual void              StoreSettings ();

  protected://fields
    QFile *                   File;
    QLabel *                  DelimiterLabel;
    QComboBox *               DelimiterField;
    QLabel *                  XColumnLabel;
    QSpinBox *                XColumnField;
    QLabel *                  YColumnLabel;
    QSpinBox *                YColumnField;
    QCheckBox *               ReadUnitsChkBox;
    QSpinBox *                UnitsLineField;
    QLabel *                  AbscissaUnitsLabel;
    QLineEdit *               AbscissaUnitsField;
    QLabel *                  OrdinateUnitsLabel;
    QLineEdit *               OrdinateUnitsField;
    QLabel *                  ValuesFirstLineLabel;
    QSpinBox *                ValuesFirstLineField;
    QLabel *                  HeaderLabel;
    QTextEdit *               HeaderText;
    QLabel *                  InfoLabel;
    QLabel *                  FooterLabel;
    QTextEdit *               FooterText;
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
