////////////////////////////////////////////////////////////////////////////////
/*! @file ColorDialog.h   Color Select Dialog with custom colors that are
                          stored in the net.
- Part of RAGUI - Research Assistant Graphical User Interface.
- Uses  RANet - Research Assistant Net Library.
- Copyright(C) 2016, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor_dot_Bursian_at_mail_dot_ioffe_dot_ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef ColorDialog_H
#define ColorDialog_H
#include "RAGUI_global.h"
#include "Color.h"
#include <QColorDialog>
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sColorSetView)

//------------------------------------------------------------- sColorDialog ---
/*! Color select dialog with custom colors that are stored in the net.

*/
class RAGUI_EXPORT  sColorDialog : public QColorDialog
{
  Q_OBJECT
  public:
                              sColorDialog (QWidget *  parent = 0);
                              sColorDialog (rcsColor   current_color
                                           ,QWidget *  parent = 0);
    virtual void              SetCurrentColor (rcsColor  current_color)
                                {
                                  setCurrentColor(QColor(current_color.Red()
                                                        ,current_color.Green()
                                                        ,current_color.Blue()
                                                        ,current_color.Alpha()
                                                        ));
                                }
    virtual sColor            SelectedColor ()
                                {
                                  return sColor(selectedColor().red()
                                               ,selectedColor().green()
                                               ,selectedColor().blue()
                                               ,selectedColor().alpha() );
                                }

  public slots:
    virtual int               exec ();
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
