////////////////////////////////////////////////////////////////////////////////
/*! @file DataFunctionUI.cpp Функционалы навигатора и окна графика,
                       специфичные для кривых.
- Part of RAGUI - Research Assistant Graphical User Interface.
- Uses  Qt v.5  -  http://qt.io/
- Uses  RANet - Research Assistant Net Library.
- Copyright(C) 2010-2017, Viktor E. Bursian, St.Petersburg, Russia.
                          Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#include "DataFunctionUI.h"
#include "Navigator.h"
#include "Functions.h"
#include "ExportDataDialog.h"
#include <QMessageBox>
namespace RA {
//------------------------------------------------------------------------------
//---------------------------------------------------------- sDataFunctionUI ---

sDataFunctionUI::sDataFunctionUI()
{
  sNavigatorViewport::MenuGenerators.push_front(&MenuGenerator);
}


void  sDataFunctionUI::MenuGenerator (psNetViewMenu                context_menu
                                     ,sNet2TreeEvolution::pcsItem  tree_item)
{
  if( sDataFunction::Type()->CanCast(tree_item->AttrValue().operator ->()) ){
    context_menu->Insert( new sNetViewAction
        (context_menu->parentWidget()
        ,&Export  ,/*checkable*/false ,/*checked*/false
        ,sNetViewMenu::tr("Export")
        ,sNetViewMenu::tr("Export the curve into a separate, "
                          "portable format file")
        ));
  }
}


void  sDataFunctionUI::Export (sNet2TreeEvolution::pcsItem  tree_item
                              ,sPoint                       /*pos*/)
{
  try{
    sExportDataDialog           D(tree_item->AttrName().Text()
                                 ,tree_item->AttrValue());
    D.exec();
  }catch(...){
    QMessageBox::critical(NULL,"Export","Error");
  }
}

//------------------------------------------------------------------------------
} //namespace RA
