////////////////////////////////////////////////////////////////////////////////
/*! @file EditDocketDialog.cpp   Редактирование этикетки кластера.
- Part of RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#include "EditDocketDialog.h"
#include "StringsAndQStrings.h"
namespace RA {
//------------------------------------------------------------------------------

sEditDocketDialog::sEditDocketDialog (QWidget *parent)
  :sAttrDlg(parent)
{
  lblDocket = new QLabel(this);
  lblDocket->setObjectName(QString::fromUtf8("lblDocket"));
  lblDocket->setText(tr("Docket:"));
  ValueSpace->addWidget(lblDocket,0,0,1,1/*,Qt::Alignment*/);

  fldDocket = new QLineEdit(this);
  fldDocket->setObjectName(QString::fromUtf8("fldDocket"));
  ValueSpace->addWidget(fldDocket,1,0,1,1/*,Qt::Alignment*/);
}


void  sEditDocketDialog::SetDocket (rcsString  value)
{
  fldDocket->setText(ToQString(value));
  fldDocket->setFocus();
}


bool  sEditDocketDialog::Validate ()
{
  TheDocket=FromQString(fldDocket->text());
  return sAttrDlg::Validate();
}

//------------------------------------------------------------------------------
} //namespace RA
