////////////////////////////////////////////////////////////////////////////////
/*! @file EditIntDialog.cpp   Редактирование целого атрибута.
- Part of RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#include "EditIntDialog.h"
namespace RA {
//------------------------------------------------------------------------------

sEditIntDialog::~sEditIntDialog ()
{
};


sEditIntDialog::sEditIntDialog (QWidget *  parent)
  :sAttrDlg(parent)
{
  lblValue = new QLabel(this);
  lblValue->setObjectName(QString::fromUtf8("lblValue"));
  lblValue->setText(tr("Value:"));
  ValueSpace->addWidget(lblValue,0,0,1,1/*,Qt::Alignment*/);

  fldValue = new QSpinBox(this);
  fldValue->setObjectName(QString::fromUtf8("fldValue"));
  fldValue->setRange(std::numeric_limits<int>::min()
                    ,std::numeric_limits<int>::max());
  ValueSpace->addWidget(fldValue,0,1,1,1/*,Qt::Alignment*/);

  btnSymbolic->setChecked(true);
  fldSymbolicName->setFocus();
};


void  sEditIntDialog::SetValue (long int  value)
{
  fldValue->setValue(value);
  fldValue->setFocus();
};


bool  sEditIntDialog::Validate ()
{
  TheValue=fldValue->value();
  return sAttrDlg::Validate();
};

//------------------------------------------------------------------------------
}; //namespace RA


