////////////////////////////////////////////////////////////////////////////////
/*! @file EditIntDialog.h   Редактирование целого атрибута.
- Part of RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef EditIntDialog_H
#define EditIntDialog_H
#include "AttrDlg.h"
#include <QFormLayout>
#include <QLabel>
#include <QSpinBox>
namespace RA {
//------------------------------------------------------------------------------

class sEditIntDialog : public sAttrDlg
{
  Q_OBJECT
  public:
    virtual                   ~sEditIntDialog ();
    explicit                  sEditIntDialog (QWidget *  parent = 0);
    void                      SetValue (long int);
    long int                  Value ()
                                { return TheValue; }

  protected:
    virtual bool              Validate (); //true on success

  private://fields
    long int                  TheValue;
    QFormLayout *             layoutValue;
    QLabel *                  lblValue;
    QSpinBox *                fldValue;
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
