////////////////////////////////////////////////////////////////////////////////
/*! @file EditNoteDialog.h   Редактирование текстового атрибута.
- Part of RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef EditNoteDialog_H
#define EditNoteDialog_H
#include "AttrDlg.h"
#include "Strings.h"
#include <QLabel>
#include <QTextEdit>
namespace RA {
//------------------------------------------------------------------------------

class sEditNoteDialog : public sAttrDlg
{
  Q_OBJECT
  public:
    virtual                   ~sEditNoteDialog ();
    explicit                  sEditNoteDialog (QWidget *  parent = 0);
    void                      SetValue (rcsString);
    sString                   Value ()
                                { return TheValue; }

  public slots:
    void                      UpdatePlain ();
    void                      UpdateHTML ();
  protected:
    virtual bool              Validate (); //true on success

  private://fields
    sString                   TheValue;
    bool                      PreventCycling;
    QLabel *                  lblValue;
    QLabel *                  lblValueHTML;
    QTextEdit *               fldValuePlain;
    QTextEdit *               fldValueHTML;
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
