////////////////////////////////////////////////////////////////////////////////
/*! @file EditPhysRangeDialog.cpp Редактирование атрибута со значением вида
                              диапазон изменения физвеличины.
- Part of RAGUI - Research Assistant Graphical User Interface Library.
- Uses  Qt v.5.0.2  - http://qt-project.org/
- Uses  RANet - Research Assistant Net Library.
- Copyright(C) 2010-2015, Viktor E. Bursian, St.Petersburg, Russia.
                          Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#include "EditPhysRangeDialog.h"
namespace RA {
//------------------------------------------------------------------------------

sEditPhysRangeDialog::~sEditPhysRangeDialog ()
{
}


sEditPhysRangeDialog::sEditPhysRangeDialog (QWidget *  parent)
  :sAttrDlg(parent)
{
  lblValue = new QLabel(this);
  lblValue->setObjectName(QString::fromUtf8("lblValue"));
  lblValue->setText(tr("Value:"));
  ValueSpace->addWidget(lblValue,0,0,1,1/*,Qt::Alignment*/);

  fldValue = new sPhysRangeField(this,sPhysRange(),true);
  ValueSpace->addWidget(fldValue,0,1,1,1,Qt::AlignLeft);

  btnSymbolic->setChecked(true);
  fldSymbolicName->setFocus();
}


void  sEditPhysRangeDialog::SetValue (rcsPhysRange  value)
{
  fldValue->SetValue(value);
  fldValue->setFocus();
}


bool  sEditPhysRangeDialog::Validate ()
{
  TheValue=fldValue->Value();
  return sAttrDlg::Validate();
}

//------------------------------------------------------------------------------
} //namespace RA


