////////////////////////////////////////////////////////////////////////////////
/*! @file EditPhysRangeDialog.h   Редактирование атрибута со значением вида
                              диапазон изменения физвеличины.
- Part of RAGUI - Research Assistant Graphical User Interface Library.
- Uses  Qt v.5.0.2  - http://qt-project.org/
- Uses  RANet - Research Assistant Net Library.
- Copyright(C) 2010-2015, Viktor E. Bursian, St.Petersburg, Russia.
                          Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef EditPhysRangeDialog_H
#define EditPhysRangeDialog_H
#include "AttrDlg.h"
#include "Ranges.h"
#include "PhysRangeField.h"
namespace RA {
//------------------------------------------------------------------------------

class sEditPhysRangeDialog : public sAttrDlg
{
  Q_OBJECT
  public:
    virtual                   ~sEditPhysRangeDialog ();
    explicit                  sEditPhysRangeDialog (QWidget *  parent = 0);
    void                      SetValue (rcsPhysRange);
    sPhysRange                Value ()
                                { return TheValue; }

  protected:
    virtual bool              Validate (); //true on success

  private://fields
    sPhysRange                TheValue;
    QLabel *                  lblValue;
    psPhysRangeField          fldValue;
};

//------------------------------------------------------------------------------
} //namespace RA
#endif // EditPhysRangeDialog_H
