////////////////////////////////////////////////////////////////////////////////
/*! @file EditPhysValueDialog.cpp Редактирование атрибута со значением вида
                               физвеличина.
- Part of RAGUI - Research Assistant Graphical User Interface Library.
- Uses  Qt v.5.0.2  - http://qt-project.org/
- Uses  RANet - Research Assistant Net Library.
- Copyright(C) 2010-2015, Viktor E. Bursian, St.Petersburg, Russia.
                          Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#include "EditPhysValueDialog.h"
namespace RA {
//------------------------------------------------------------------------------

sEditPhysValueDialog::~sEditPhysValueDialog ()
{
}


sEditPhysValueDialog::sEditPhysValueDialog (sPhysValue  value
                                           ,QWidget *   parent)
    :sAttrDlg(parent)
    ,TheValue(value)
{
  lblValue = new QLabel(this);
  lblValue->setObjectName(QString::fromUtf8("lblValue"));
  lblValue->setText(tr("Value:"));
  ValueSpace->addWidget(lblValue,0,0,1,1/*,Qt::Alignment*/);

  fldValue = new sPhysValueField(this,TheValue
                                , ! TheValue.UnitsAreFixed()
                                ,true,true);
  //! @todo{PhysValues} погрешность всегда видна и error_depends_on_value_digits

  ValueSpace->addWidget(fldValue,0,1,1,1,Qt::AlignLeft);

  btnSymbolic->setChecked(true);
  fldSymbolicName->setFocus();
}


void  sEditPhysValueDialog::SetValue (rcsPhysValue  value)
{
  fldValue->SetValue(value);
  fldValue->setFocus();
}


bool  sEditPhysValueDialog::Validate ()
{
  TheValue=fldValue->Value();
  return sAttrDlg::Validate();
}

//------------------------------------------------------------------------------
} //namespace RA


