////////////////////////////////////////////////////////////////////////////////
/*! @file EditPhysValueDialog.h   Редактирование атрибута со значением вида
                              физвеличина.
- Part of RAGUI - Research Assistant Graphical User Interface Library.
- Uses  Qt v.5.0.2  - http://qt-project.org/
- Uses  RANet - Research Assistant Net Library.
- Copyright(C) 2010-2015, Viktor E. Bursian, St.Petersburg, Russia.
                          Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef EditPhysValueDialog_H
#define EditPhysValueDialog_H
#include "AttrDlg.h"
#include "PhysValue.h"
#include "PhysValueField.h"
namespace RA {
//------------------------------------------------------------------------------

class sEditPhysValueDialog : public sAttrDlg
{
  Q_OBJECT
  public:
    virtual                   ~sEditPhysValueDialog ();
    explicit                  sEditPhysValueDialog (sPhysValue
                                                ,QWidget *  parent = 0);
    void                      SetValue (rcsPhysValue);
    sPhysValue                Value ()
                                { return TheValue; }

  protected:
    virtual bool              Validate (); //true on success

  private://fields
    sPhysValue                TheValue;
    QLabel *                  lblValue;
    psPhysValueField          fldValue;
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
