////////////////////////////////////////////////////////////////////////////////
/*! @file EditScalesDialog.cpp   Редактирование шкал графика.
- Part of RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#include "EditScalesDialog.h"
#include "Units.h"
#include <QVBoxLayout>
#include <QFormLayout>
#include <QLabel>
#include <QDialogButtonBox>
namespace RA {
//------------------------------------------------------------------------------

sEditScalesDialog::sEditScalesDialog (QWidget *  parent)
    :QDialog(parent)
{
//  resize(200,100);
  setWindowTitle(tr("Set plot scales"));
  QVBoxLayout *       Layout = new QVBoxLayout();
  setLayout(Layout);

  Layout->addWidget(new QLabel(tr("<b><u>Absciss")));

  QFormLayout *       ALayout = new QFormLayout();
  Layout->addLayout(ALayout);

  ALayout->setWidget(0,QFormLayout::LabelRole,new QLabel(tr("title")));
  fldAbscissVariableName = new QLineEdit(this);
  ALayout->setWidget(0,QFormLayout::FieldRole,fldAbscissVariableName);

  fldAbscissRange = new sPhysRangeField(this,"range",sPhysRange(),true);
  Layout->addWidget(fldAbscissRange,0,Qt::AlignLeft);

  Layout->addWidget(new QLabel("   "));

  Layout->addWidget(new QLabel(tr("<b><u>Ordinate")));

  QFormLayout *       OLayout = new QFormLayout();
  Layout->addLayout(OLayout);

  OLayout->setWidget(0,QFormLayout::LabelRole,new QLabel(tr("title")));
  fldOrdinateVariableName = new QLineEdit(this);
  OLayout->setWidget(0,QFormLayout::FieldRole,fldOrdinateVariableName);

  fldOrdinateRange = new sPhysRangeField(this,"range",sPhysRange(),true);
  Layout->addWidget(fldOrdinateRange,0,Qt::AlignLeft);

  QDialogButtonBox *  buttonBox = new QDialogButtonBox(this);
  buttonBox->setObjectName(QString::fromUtf8("buttonBox"));
  buttonBox->setOrientation(Qt::Horizontal);
  buttonBox->setStandardButtons(QDialogButtonBox::Cancel|QDialogButtonBox::Ok);

  Layout->addWidget(buttonBox);

  connect(buttonBox, SIGNAL(accepted()), this, SLOT(accept()));
//  connect(buttonBox, SIGNAL(accepted()), this, SLOT(OnOK()));
  connect(buttonBox, SIGNAL(rejected()), this, SLOT(reject()));
}

//------------------------------------------------------------------------------
} //namespace RA


