/*! @file ExportDataDialog.h   Class sExportDataDialog.
- Part of RAGUI - Research Assistant Graphical User Interface.
- Uses  Qt v.5  -  http://qt.io/
- Uses  RANet - Research Assistant Net Library.
- Copyright(C) 2017, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef ExportDataDialog_H
#define ExportDataDialog_H
#include "Functions.h"
#include "ExpressionNode.h"
#include "FlexibleFields.h"
#include <QFileDialog>
#include <QVBoxLayout>
#include <QLineEdit>
#include <QComboBox>
#include <QCheckBox>
#include <QPushButton>
namespace RA {
//------------------------------------------------------------------------------
//-------------------------------------------------------- sExportDataDialog ---

class  sExportDataDialog : public QFileDialog
{
  Q_OBJECT
  public:
                              sExportDataDialog (sString         attr_name
                                                ,sNodePtr        node
                                                ,QWidget *       parent = 0);

  protected slots:
    virtual void              Export ();
    virtual void              UpdateSaveButton ();
    virtual void              OnUnitsChanged ();
    virtual void              OnDelimiterChanged ();
//    virtual void              OnFilterChange ();
    virtual void              CheckFileName ();

  protected:
    virtual void              ValidateFileName (rsString);

  protected:
    sNodePtr                  Node;
    psDataFunction            DataFunction;
    sPtr<sExpressionNode>     ExpressionNode;
    sString                   SuggestedFileName;
    sString                   AttrNameAndNodeText;
    sString                   XHeader;
    sString                   YHeader;
    sUnits                    XNativeUnits;
    sUnits                    YNativeUnits;
    sUnits                    XUnits;
    sUnits                    YUnits;
    QString                   Delimiter;
    QStringList               Filters;
    bool                      ValidFileName;

    QLineEdit *               FileNameField;
    QPushButton *             SaveButton;

    QVBoxLayout *             SideLayout;
    psTextField               XUnitsField;
    psTextField               YUnitsField;
    QComboBox *               DelimiterField;
    QCheckBox *               InsertHeaderField;
    psTextField               XHeaderField;
    psTextField               YHeaderField;
    QCheckBox *               InsertUnitsField;
    QCheckBox *               AppendAttrsField;
    QComboBox *               AttrsAsideField;
    QCheckBox *               AppendSubAttrsField;
    QCheckBox *               AppendSubSubAttrsField;
    QComboBox *               EOLField;
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
