////////////////////////////////////////////////////////////////////////////////
/*! @file ExpressionNodeUI.h   Add-ons to the navigator functionality.
- Part of RAGUI - Research Assistant Graphical User Interface Library.
- Uses  RANet - Research Assistant Net Library.
- Copyright(C) 2014, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef ExpressionNodeUI_H
#define ExpressionNodeUI_H
#include "NetView.h"
#include "Chart.h"
#include <QPainter>
namespace RA {
//------------------------------------------------------------------------------

class sExpressionNodeUI
{
  public:
                              sExpressionNodeUI ();
    static bool               Draw (QPainter *       painter
                                   ,psChartViewport  viewport
                                   ,psGraphObject    object
                                   ,pcsAppearance    appearance);
    static void               MenuGenerator (psNetViewMenu
                                            ,sNet2TreeEvolution::pcsItem);
    static void               EditValue (sNet2TreeEvolution::pcsItem ,sPoint);
    static void               AddNew (sNet2TreeEvolution::pcsItem ,sPoint);
    static void               InsertNew (sNet2TreeEvolution::pcsItem ,sPoint);
    static void               EditCurveAppearance (sNet2TreeEvolution::pcsItem
                                                  ,sPoint);
    static void               Export (sNet2TreeEvolution::pcsItem ,sPoint);
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
