////////////////////////////////////////////////////////////////////////////////
/*! @file Globals.cpp Global attribute names.
- Part of RAGUI - Research Assistant Graphical User Interface.
- Uses  RANet - Research Assistant Net Library.
- Uses  Qt v.5.0  -  http://qt-project.org/
- Copyright(C) 2013, Viktor E. Bursian, St.Petersburg, Russia.
                     VBursian@gmail.com
*///////////////////////////////////////////////////////////////////////////////
#include "Globals.h"
namespace RA {
//------------------------------------------------------------------------------

namespace GlobalAttr {
//------------------------------------------------------------------------------

const sAttrName          Desktop             ("Desktop");
const sAttrName          Data                ("Data");
const sAttrName          Plugins             ("Plugins");
const sAttrName          Devices             ("Devices");
const sAttrName          FontFamily          ("Font Family");
const sAttrName          FontSize            ("Font Size");
const sAttrName          Styles              ("Styles");
const sAttrName          LineColorSet        ("Basic Line Color Set");
const sAttrName          CustomColors        ("Custom Colors");
const sAttrName          Language            ("Language");
const sAttrName          UnitSystem          ("Unit System");
const sAttrName          RecordNumbering     ("Record Numbering Data");
const sAttrName          RecordHistory       ("Record History");
const sAttrName          RecordsToBrowse     ("Records To Browse");
const sAttrName          Samples             ("Samples");
const sAttrName          Topics              ("Topics");
const sAttrName          CSVExportSettings   ("CSV Export Settings");
const sAttrName          CSVImportSettings   ("CSV Import Settings");
const sAttrName          SOSImportSettings   ("SOS Import Settings");

//------------------------------------------------------------------------------
} //namespace GlobalAttr

namespace RAGUI {
//------------------------------------------------------------------------------

bool                          NightRegime = false;

sPtr<RA::sColorSetNode>       LineColorSet;

sPtr<RA::sColorSetNode>       CustomColors;

sPtr<RA::sFolderNode>         CSVExportSettings;

sPtr<RA::sFolderNode>         CSVImportSettings;

sPtr<RA::sFolderNode>         SOSImportSettings;

//------------------------------------------------------------------------------
} //namespace RAGUI

//------------------------------------------------------------------------------
} //namespace RA
