////////////////////////////////////////////////////////////////////////////////
/*! @file Helper.h   Организация справки (Help'а).
- Part of RAGUI - Research Assistant Graphical User Interface Library.
- Uses  RANet - Research Assistant Net Library.
- Uses  Qt v.5  -  http://qt-project.org/
- Copyright(C) 2010-2014, Viktor E. Bursian, St.Petersburg, Russia.
                          VBursian@gmail.com
*///////////////////////////////////////////////////////////////////////////////
#ifndef Helper_H
#define Helper_H
#include "RAGUI_global.h"
#include <QProcess>
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sHelper)

//------------------------------------------------------------------ sHelper ---

class RAGUI_EXPORT  sHelper : public QObject
{
  Q_OBJECT
  public: //static
    static void               Initiate (sString  collection_file
                                       ,sString  namespace_prefix
                                                  =sString("research-assistant")
                                       ,sString  virtual_folder
                                                   =sString("help")
                                       );
    static void               Terminate ();
    static void               ShowIndex ();
    static void               ShowKeyId (sString  key_id);
    static void               ShowKeyword (sString  keyword);
    static void               ShowRelativeURL (sString  reference
                                               //!< like "../Rigaku/Rigaku.html"
                                              );
    static void               ShowQtHelpSchemeURL
                                  (sString  reference
                                            //!< path inside part
                                  ,sString  part
                                            //!< "core" or plugin name
                                            =sString("core")
                                  );

  private:
    virtual                   ~sHelper ();
                              sHelper (sString  collection_file
                                      ,sString  namespace_prefix
                                      ,sString  virtual_folder
                                      );

  private:
    bool                      Start ();
    void                      PostponedSend (sString  Command);
    sString                   PrependSettings ();

  private slots:
    void                      Send ();
    void                      Sync ();

  private: //static fields
    static psHelper           TheHelper;
    static const int          LongDelay;
    static const int          ShortDelay;

  private: //fields
    sString                   TheFileName;
    sString                   TheNamespace;
    sString                   TheVirtualFolder;
    bool                      HideBookmarks;
    bool                      HideSearch;
    bool                      BookmarksAreHidden;
    bool                      SearchIsHidden;
    QProcess *                TheProcess;
    bool                      JustStarted;
    sString                   Cmd;
    int                       Delay;
};

//------------------------------------------------------------------------------
} //namespace RA
#endif //Helper_H
