////////////////////////////////////////////////////////////////////////////////
/*! @file InstrumentWindow.cpp Class sInstrumentWindow.
- Part of RAGUI - Research Assistant Graphical User Interface Library.
- Uses  Qt v.5.0.2  - http://qt-project.org/
- Uses  RANet - Research Assistant Net Library.
- Copyright(C) 2010-2014, Viktor E. Bursian, St.Petersburg, Russia.
                          Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#include "InstrumentWindow.h"
#include "FolderNode.h"
#include "BasicNodes.h"
#include "Net.h"
namespace RA {
//------------------------------------------------------------------------------
//-------------------------------------------------------- sInstrumentWindow ---

sInstrumentWindow::sInstrumentWindow (sNodePtr   widget_cfg
                                     ,QWidget *  parent    )
    :sInstrument()
    ,sWindow(widget_cfg,"",parent)
{
  sPtr<sTextNode>             Id (widget_cfg>>"Title");
  ASSERT( Id.IsCorrect() );
}


const QIcon &  sInstrumentWindow::Icon ()
{
  static QIcon *  MyIcon = new QIcon(":/RAGUI/icons/instrument.png");
  return *MyIcon;
}

//------------------------------------------------------------------------------
} //namespace RA


