////////////////////////////////////////////////////////////////////////////////
/*! @file InstrumentWindow.h   Class sInstrumentWindow.
- Part of RAGUI - Research Assistant Graphical User Interface Library.
- Uses  Qt v.5.0.2  - http://qt-project.org/
- Uses  RANet - Research Assistant Net Library.
- Copyright(C) 2010-2014, Viktor E. Bursian, St.Petersburg, Russia.
                          Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef InstrumentWindow_H
#define InstrumentWindow_H
#include "Window.h"
#include "Instrument.h"
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_ABSTRACT_CLASS(sInstrumentWindow)

//-------------------------------------------------------- sInstrumentWindow ---
/*! Абстрактный базовый класс для подключаемого (из плагина) инструмента
    с оконным интерфейсом.

*/
class RAGUI_EXPORT  sInstrumentWindow : public sWindow
                                      , virtual public sInstrument
{
  Q_OBJECT
  ADAM(sInstrumentWindow)
  
  public:
    virtual const QIcon &     Icon ();

  protected:
                              sInstrumentWindow (sNodePtr   widget_cfg
                                                ,QWidget *  parent    );
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
