////////////////////////////////////////////////////////////////////////////////
/*! @file MarksUI.h   Функционалы навигатора и окна графика,
                       специфичные для разметки.
- Part of RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef MarksUI_H
#define MarksUI_H
#include "NetView.h"
#include "Chart.h"
#include "Marks.h"
#include "CurvesUI.h"
#include <QPainter>
#include <QComboBox>
#include <QSpinBox>
namespace RA {
//------------------------------------------------------------------------------

//---------------------------------------------------------- sPositionMarkUI ---

class sPositionMarkUI : public QObject
{
  Q_OBJECT
  public:
                              sPositionMarkUI ();
    static void               MenuGenerator (psNetViewMenu
                                            ,sNet2TreeEvolution::pcsItem);
    static void               EditAppearance (sNet2TreeEvolution::pcsItem
                                             ,sPoint);
};

//----------------------------------------------------------------- sXMarkUI ---

class sXMarkUI : public QObject
{
  Q_OBJECT
  public:
                              sXMarkUI ();
    static bool               Draw (QPainter *       painter
                                   ,psChartViewport  viewport
                                   ,psGraphObject    object
                                   ,pcsAppearance    appearance);
    static void               MenuGenerator (psNetViewMenu
                                            ,sNet2TreeEvolution::pcsItem);
    static void               AddNew (sNet2TreeEvolution::pcsItem ,sPoint);
};

//----------------------------------------------------------------- sYMarkUI ---

class sYMarkUI : public QObject
{
  Q_OBJECT
  public:
                              sYMarkUI ();
    static bool               Draw (QPainter *       painter
                                   ,psChartViewport  viewport
                                   ,psGraphObject    object
                                   ,pcsAppearance    appearance);
    static void               MenuGenerator (psNetViewMenu
                                            ,sNet2TreeEvolution::pcsItem);
    static void               AddNew (sNet2TreeEvolution::pcsItem ,sPoint);
};

//---------------------------------------- sEditPositionMarkAppearanceDialog ---
/*!

*/
class sEditPositionMarkAppearanceDialog : public sEditLineAppearanceDialog
{
  Q_OBJECT
  public:
    explicit                  sEditPositionMarkAppearanceDialog
                                    (psPositionMarkAppearance  appearance
                                    ,bool                      it_is_an_X_mark
                                    ,sColorSet                 color_set
                                    ,sColor                    background
                                    ,QWidget *                 parent = NULL);

  protected slots:
    virtual void              Refresh ();

  protected: //fields
    psPositionMarkAppearance  Appearance;
    QComboBox *               ModeBox;
    QSpinBox *                LengthBox;
    QLabel *                  LengthLabel;
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
