////////////////////////////////////////////////////////////////////////////////
/*! @file NetView.cpp   Прото-виджет просмотра сети.
- Part of RAGUI - Research Assistant Graphical User Interface.
- Uses  RANet - Research Assistant Net Library.
- Uses  Qt v.5  -  http://qt-project.org/
- Copyright(C) 2010-2015, Viktor E. Bursian, St.Petersburg, Russia.
                          Viktor_dot_Bursian_at_mail_dot_ioffe_dot_ru
*///////////////////////////////////////////////////////////////////////////////
#include "NetView.h"
#include "StringsAndQStrings.h"
namespace RA {
//------------------------------------------------------------------------------
//------------------------------------------------------------- sNetViewItem ---

sNetViewItem::sNetViewItem (psNetViewport               /*viewport*/
                           ,sNet2TreeEvolution::psItem  tree_item)
  :/*Viewport(viewport),*/TreeItem(tree_item)
{
//  ASSERT(Viewport);
  ASSERT(TreeItem);
}

//------------------------------------------------------------- sNetViewMenu ---

sNetViewMenu::~sNetViewMenu ()
{
  if( AddNew ){ delete AddNew; AddNew=NULL; };
  if( InsertNew ){ delete InsertNew; InsertNew=NULL; };
  if( HeaderLabel ){ delete HeaderLabel; HeaderLabel=NULL; };
  if( HeaderAction ){ delete HeaderAction; HeaderAction=NULL; };
}


sNetViewMenu::sNetViewMenu (psNetViewport                viewport
                           ,sNet2TreeEvolution::pcsItem  /*tree_item*/)
  :QMenu(viewport)
  ,AddNew(NULL),InsertNew(NULL)
  ,InsertionPoint(NULL)
  ,HeaderLabel(NULL),HeaderAction(NULL)
{
  HeaderLabel=new QLabel(this);//! @todo{?} this or parent?
  HeaderLabel->setObjectName("ContextMenuHeader");  //used in styles
  HeaderLabel->setFrameShape(QFrame::StyledPanel);
  HeaderLabel->setFrameShadow(QFrame::Raised);

  HeaderAction=new QWidgetAction(this);
  HeaderAction->setDefaultWidget(HeaderLabel);
        //! @todo{?} Про setDefaultWidget написаны какие-то непонятные тонкости, разобраться бы
  HeaderAction->setEnabled(false);
  addAction(HeaderAction);
  InsertionPoint=addSeparator();
  AddNew=addMenu(tr("Add new"));
  InsertNew=addMenu(tr("Insert new"));
}


void  sNetViewMenu::SetHeader (rcsString  header)
{
  if( header.Empty() ){
    HeaderLabel->setText("");
//    HeaderAction->setVisible(false);
  }else{
    HeaderLabel->setText(ToQString(header));
//    HeaderAction->setVisible(true);
  }
}


void  sNetViewMenu::Insert (QAction * A)
{
  insertAction(InsertionPoint,A);
}


//----------------------------------------------------------- sNetViewAction ---

sNetViewAction::sNetViewAction (QObject*                   Parent
                               ,pfNetViewActionHandler     Handler
                               ,bool                       /*Checkable*/
                               ,bool                       /*Checked*/
                               ,QString                    Name
                               ,QString                    Hint
                               )
  :QAction(Name,Parent)
  ,DoIt(Handler)
{
  setToolTip(Hint);
}

//------------------------------------------------------------- sNetViewport ---

sNetViewport::~sNetViewport ()
{
}


sNetViewport::sNetViewport(psNet2TreeEvolution  evolution
                          ,QWidget *            parent)
//  :QWidget(parent)
  :QFrame(parent)
  ,Evolution(evolution)
{
  ASSERT(Evolution);
}

//------------------------------------------------------------------------------
} //namespace RA
