////////////////////////////////////////////////////////////////////////////////
/*! @file RAGUI_global.cpp Управление компиляцией и инициализация ресурсов.
- Part of RAGUI - Research Assistant Graphical User Interface.
- Uses  RANet - Research Assistant Net Library.
- Uses  Qt v.5  -  http://qt-project.org/
- Copyright(C) 2010-2015, Viktor E. Bursian, St.Petersburg, Russia.
                          VBursian@gmail.com
*///////////////////////////////////////////////////////////////////////////////
#include "RAGUI_global.h"
#include <QCoreApplication>

inline void initMyResource() { Q_INIT_RESOURCE(RAGUI); }

namespace RA {
//------------------------------------------------------------------------------

namespace RAGUI {

  RA::sVersion const          Version (RA_VERS_MAJOR
                                      ,RA_VERS_MINOR
                                      ,ZAKAVYCH(RA_VERS_PATCH)
                                      ,__DATE__         );

}

//------------------------------------------------------------------------------

void  InitiateRAGUI ()
{
  if( ! (RAGUI::Version.Valuable() == RANet::Version.Valuable()) ){
    std::terminate();
  };
  initMyResource();
}

//------------------------------------------------------------------------------
} //namespace RA
