////////////////////////////////////////////////////////////////////////////////
/*! @file RAGUI_global.h   Управление компиляцией и инициализация ресурсов.
- Part of RAGUI - Research Assistant Graphical User Interface.
- Uses  RANet - Research Assistant Net Library.
- Uses  Qt v.5  -  http://qt-project.org/
- Copyright(C) 2010-2015, Viktor E. Bursian, St.Petersburg, Russia.
                          VBursian@gmail.com
*///////////////////////////////////////////////////////////////////////////////
#ifndef RAGUI_global_H
#define RAGUI_global_H
#include "RANet_global.h"
#include "Version.h"
#include "ColorNodes.h"
#include <QtCore/qglobal.h>
namespace RA {
//------------------------------------------------------------------------------

#if defined(RAGUI_LIBRARY_BUILD)
    #define RAGUI_EXPORT Q_DECL_EXPORT
#elif defined(RAGUI_LIBRARY_USE)
    #define RAGUI_EXPORT Q_DECL_IMPORT
#else
    #define RAGUI_EXPORT
#endif


/*! Delay (ms) between sByeScreen destruction and application quitting.

*/
#define TIME_LAG_FOR_sByeScreen     100


/*! Period (ms) between checks while closing.

*/
#define TIME_PERIOD_FOR_sRAMainWindow_closing_check     100

//------------------------------------------------------------------------------

namespace RAGUI {

  RAGUI_EXPORT extern RA::sVersion const     Version;

}

//------------------------------------------------------------------------------

RAGUI_EXPORT  void  InitiateRAGUI ();

//------------------------------------------------------------------------------
} //namespace RA
#endif
