////////////////////////////////////////////////////////////////////////////////
/*! @file RAPlugins.h   Интерфейсы plugin-пакетов.
- Part of RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef RAPlugins_H
#define RAPlugins_H
#include "RAGUI_global.h"
#include "Strings.h"
#include "FolderNode.h"
#include <QtPlugin>
#include <QTranslator>
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sInstrumentalPackage)

//----------------------------------------------------- sInstrumentalPackage ---

class RAGUI_EXPORT  sInstrumentalPackage : public virtual sAdam
{
  ADAM(sInstrumentalPackage)
  public:
    virtual                   ~sInstrumentalPackage()
                                {}
                              sInstrumentalPackage ();
    virtual sVersion          Version () = 0;
    virtual sVersion          CoreVersionUsed () = 0;
    virtual sVersion          CoreVersionMin () = 0;
    virtual QString           UserFriendlyName () = 0;
    virtual QString           About () = 0;
    virtual bool              HasDefaults ()
                                { return false; }
    virtual void              InstallDefaults (sPtr<sFolderNode>  /*DeviceList*/)
                                {}
    virtual void              ModifyConfig (sVersion           /*OldVersion*/
                                           ,sPtr<sFolderNode>  /*PluginList*/ )
                                {}
  public: //fields
    QTranslator *             Translator;
};

//------------------------------------------------------------------------------
} //namespace RA

QT_BEGIN_NAMESPACE
Q_DECLARE_INTERFACE(RA::sInstrumentalPackage
                   ,"BursianSoft.RA.sInstrumentalPackage"
                   )
QT_END_NAMESPACE

//------------------------------------------------------------------------------
#endif
