////////////////////////////////////////////////////////////////////////////////
/*! @file Restyling.cpp   RA GUI restyling.
- Part of RAGUI - Research Assistant Graphical User Interface Library.
- Uses  RANet - Research Assistant Net Library.
- Uses  Qt v.5  -  http://qt-project.org/
- Copyright(C) 2015, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor_dot_Bursian_at_mail_dot_ioffe_dot_ru
*///////////////////////////////////////////////////////////////////////////////
#include "Restyling.h"
namespace RA {
//------------------------------------------------------------------------------

namespace CSS {
//------------------------------------------------------------------------------

//------------------------------------------------------------------- Shapes ---
csString                      Shapes(""
//      "#CentralWidget "
//          "{background-image:url(dense6pattern.png); background-repeat: repeat-xy;} "
      "RA--sRADock "
          "{border:3px solid; }"
      "RA--sRADock::title {"
          "padding-left:7px; padding-right:20px; border-style:solid; "
          "border-bottom-width:0px; border-top-width:2px; "
          "border-left-width:2px; border-right-width:2px; "
          "border-top-left-radius:7px; border-top-right-radius:7px; "
          "} "
      "RA--sRADock::close-button {"
          "padding:0px; border:0px; "
          "top:2px; left:-8px; "
          "} "
      "RA--sRADock::float-button {"
          "padding:0px; border:0px; "
          "top:2px; left:-28px; "
          "} "
      "RA--sWindow {"
          "padding-left:3px; padding-right:3px; padding-bottom:3px; "
          "border-style:solid; "
          "border-top-width:0px; border-bottom-width:2px; "
          "border-left-width:2px; border-right-width:2px; "
          "border-bottom-left-radius:7px; border-bottom-right-radius:7px; "
          "} "
//      "RA--sChartViewport {border:0px} "
      "RA--sNavigator {border:0px; padding:0px} "
      "RA--sDropNodeWidget "
          "{border-width:1px; border-style:solid; border-radius:4px; "
          "padding:2px;} "
      "#ContextMenuHeader {"
          "border-width:2px; border-style:solid; "
          "border-radius:4px; padding:2px; "
          "}"
);

//-------------------------------------------------------------- NormalStyle ---
csString                      NormalStyle(""
      "RA--sRAMainWindow {"
          "background:#F2F1F0; "
          "}\n"
      "RA--sRADock {"
          "color:black; "  //title text
          "background:#808080; "   //only when floating affects: corners,
                                   //and splitter(if not changed in >QFrame)
          "border-color:#808080; "   //is shown only when floating
          "}\n"
      "RA--sRADock::title {"
          "background:#D0D0D0; "
          "border-color:#808080; "
          "}\n"
      "RA--sRADock::close-button, RA--sRADock::float-button {"
          "background:#D0D0D0; "
          "}\n"
      "RA--sRADock::close-button:hover, RA--sRADock::float-button:hover {"
          "background:white; "
          "}\n"
      "RA--sWindow {"
          "background:#F2F1F0; "
          "border-color:#808080; "
          "}\n"
      "RA--sWindow > QSplitter {"
          "background:#D0D0D0; "
          "}\n"
      "RA--sChart, RA--sChartViewport {"
          "color:black; "
          "background:white; "
          "}\n"
      "RA--sNavigator {"
          "background:white; "
          "}\n"
      "RA--sNavigatorViewport {"
          "color:#3C3C3C; "
          "background:white; "
          "}\n"
      "RA--sDropNodeWidget {"
          "color:#3C3C3C; "
          "background:white; "
          "}\n"
      "#ContextMenuHeader {"
          "color:black; "
          "border-color:black; "
          "background:white"
          "}\n"
      "QStatusBar {"
          "color:red; "
          "}\n"
);

//--------------------------------------------------------------- NightStyle ---
csString                      NightStyle(""
      "RA--sRAMainWindow {"
          "background:black; "
          "}\n"
      "RA--sRADock {"
          "color:white; "  //title text
          "background:#A0A0A0; "   //only when floating affects: corners,
                                   //and splitter(if not changed in >QFrame)
          "border-color:#A0A0A0; "   //is shown only when floating
          "}\n"
      "RA--sRADock::title {"
          "background:#606060; "
          "border-color:#A0A0A0; "
          "}\n"
      "RA--sRADock::close-button, RA--sRADock::float-button {"
          "background:black; "
          "}\n"
      "RA--sRADock::close-button:hover, RA--sRADock::float-button:hover {"
          "background:white; "
          "}\n"
      "RA--sWindow {"
          "background:#404040; "
          "border-color:#A0A0A0; "
          "}\n"
      "RA--sWindow > QSplitter {"
          "background:#404040; "
          "}\n"
      "RA--sChart, RA--sChartViewport {"
          "color:white; "
          "background:black; "
          "}\n"
      "RA--sNavigator {"
          "background:black; "
          "}\n"
      "RA--sNavigatorViewport {"
          "color:lightgrey; "
          "background:black; "
          "}\n"
      "RA--sDropNodeWidget {"
          "color:lightgrey; "
          "background:black; "
          "}\n"
      "#ContextMenuHeader {"
          "color:white; "
          "border-color:white; "
          "background:black"
          "}"
      "QScrollBar {"
          "color:white; "
          "background:black; "
          "}\n"
      "QLabel {"
          "color:lightgrey; "
          "}\n"
      "QTextEdit, QLineEdit {"
          "color:lightgrey; "
          "background:black; "
          "border-color:black; "
//          "border-color:#808080; "
          "}\n"
      "QStatusBar {"
          "color:red; "
          "background:black; "
          "}\n"
      "QStatusBar QLabel {"
          "color:black; "
          "}\n"
//      "QStatusBar:item {"
//          "border:???; "
//          "}\n"
      "QScrollArea, QDialog, .QFrame {"
          "background-color:#404040; "
          "}\n"
      "QMenu {"
          "color:lightgrey; "
          "background-color:#606060; "
          "}\n"
      "QMenu::item:selected {"
          "color:white; "
          "background-color:brown; "
          "}\n"
      "QMenu::item:disabled {"
          "color:#808080; "
          "}\n"
      "QPushButton {"
          "color:white; "
          "border-width:2px; border-style:solid; border-radius:6px; "
          "padding:2px; "
          "border-color:#8f8f91; "
          "background: qlineargradient(x1:0, y1:0, x2:0, y2:1, "
                                      "stop: 0 #909090, stop: 1 #707070); "
          "}\n"
      "QPushButton:pressed {"
          "padding: 3px 1px 1px 3px; "
          "background: qlineargradient(x1: 0, y1: 0, x2: 0, y2: 1, "
                                      "stop: 0 #707070, stop: 1 #909090); "
          "}\n"
      "QPushButton:default, QPushButton:focus {"
          "background: qlineargradient(x1: 0, y1: 0, x2: 0, y2: 1, "
                                      "stop: 0 #B08060, stop: 1 #A07050); "
          "border-color:#A07050; "
          "}\n"
      "QPushButton:hover {"
          "background: qlineargradient(x1:0, y1:0, x2:0, y2:1, "
                                      "stop: 0 #B0B0B0, stop: 1 #808080); "
          "}\n"
      "QGroupBox {"
          "color:lightgrey; "
          "}\n"
      "QRadioButton:enabled, QCheckBox:enabled {"
          "color:lightgrey; "
          "}\n"
      "QRadioButton:!enabled, QCheckBox:!enabled {"
          "color:#606060; "
          "}\n"
      "QRadioButton::indicator, QCheckBox::indicator {}\n" //идиотизм, но без
                                      //него не работают предыдущие установки
      "QSpinBox {"
          "background: qlineargradient(x1:0, y1:0, x2:0, y2:1, "
                                      "stop: 0 #202020, stop: 1 #101010); "
          "color:lightgrey; "
          "}\n"
//      "QSpinBox::down-arrow {}\n"
      "QComboBox {"
          "background: qlineargradient(x1:0, y1:0, x2:0, y2:1, "
                                      "stop: 0 #202020, stop: 1 #101010); "
          "color:lightgrey; "
          "}\n"
      "QComboBox QAbstractItemView {"
          "background:black; "
          "color:lime; "
//          "color:lightgrey; "
//          "background-color:#606060; "
//          "border-color:black; "
          "}\n"
      "QComboBox QAbstractLineEdit {"
          "background:black; "
          "color:lime; "
//          "color:lightgrey; "
//          "background-color:#606060; "
//          "border-color:black; "
          "}\n"
);

//------------------------------------------------------------------------------
} //namespace Styles

//------------------------------------------------------------------------------
} //namespace RA

