////////////////////////////////////////////////////////////////////////////////
/*! @file StaticInitiators.cpp Initiates static members in right order.
- Part of RAGUI - Research Assistant Graphical User Interface.
- Copyright(C) 2013-2015, Viktor E. Bursian, St.Petersburg, Russia.
                          Viktor_dot_Bursian_at_mail_dot_ioffe_dot_ru
*///////////////////////////////////////////////////////////////////////////////
#include "Net2TreeEvolution.h"
#include "Navigator.h"
#include "FolderNodeUI.h"
#include "BasicNodesUI.h"
#include "Chart.h"
#include "ColorsUI.h"
#include "CurvesUI.h"
#include "DataFunctionUI.h"
#include "RecordUI.h"
#include "MarksUI.h"
#include "ExpressionNodeUI.h"
#include "Driver.h"
#include "InstrumentWindow.h"
#include "Console.h"
#include "RAPlugins.h"
namespace RA {
//------------------------------------------------------------------------------

DEFINE_CLASS_TAG(sNet2TreeEvolution)

sNetViewMenuGenerators        sNavigatorViewport::MenuGenerators;
sNetViewMenuGenerators        sChartViewport::MenuGenerators;
std::list<pcfDrawProc>        sChartViewport::DrawProcCollection;

sFolderNodeUI                 FolderNodeUI;
sTextNodeUI                   TextNodeUI;
sIntegerNodeUI                IntegerNodeUI;
sBooleanNodeUI                BooleanNodeUI;
sPhysValueNodeUI              PhysValueNodeUI;
sPhysRangeNodeUI              PhysRangeNodeUI;
sColorsUI                     ColorsUI;
sCurveUI                      CurveUI;
sDataFunctionUI               DataFunctionUI;
sRecordUI                     RecordUI;
sPositionMarkUI               PositionMarkUI;
sYMarkUI                      YMarkUI;
sXMarkUI                      XMarkUI;
sExpressionNodeUI             ExpressionNodeUI;

DEFINE_CLASS_TAG(sDriver)
DEFINE_CLASS_TAG(sInstrumentWindow)
DEFINE_CLASS_TAG(sConsole)
DEFINE_CLASS_TAG(sInstrumentalPackage)

//------------------------------------------------------------------------------
} //namespace RA
