////////////////////////////////////////////////////////////////////////////////
/*! @file SymbolsGUI.h   Predefined symbolic strings for GUI.
- Part of RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 1994-2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef SymbolsGUI_H
#define SymbolsGUI_H
#include "Symbols.h"
namespace RA {
//------------------------------------------------------------------------------

namespace Symbol {
//------------------------------------------------------------------------------

const literal  NotExpandable = "▹";
                              //"▹" = "\342\226\271"
                              //U+25B9 WHITE RIGHT-POINTING SMALL TRIANGLE
                              //UTF-8: 0xE2 0x96 0xB9  UTF-16: 0x25B9

                              //"◌" = "\342\227\214"
                              //U+25CC DOTTED CIRCLE
                              //UTF-8: 0xE2 0x97 0x8C  UTF-16: 0x25CC

const literal  FullyCollapsed = "▷";
                              //"▷" = "\342\226\267"
                              //U+25B7 WHITE RIGHT-POINTING TRIANGLE
                              //UTF-8: 0xE2 0x96 0xB7  UTF-16: 0x25B7

                              //"ᐅ" = "\341\220\205"
                              //U+1405 CANADIAN SYLLABICS O
                              //UTF-8: 0xE1 0x90 0x85  UTF-16: 0x1405

const literal  Inline_OmitRepetitions = "►";
                              //"►" = "\342\226\272"
                              //U+25BA BLACK RIGHT-POINTING POINTER
                              //UTF-8: 0xE2 0x96 0xBA  UTF-16: 0x25BA

                              //"◆" = ""
                              //
                              //

const literal  Inline = "▶";
                              //"▶" = "\342\226\266"
                              //U+25B6 BLACK RIGHT-POINTING TRIANGLE
                              //UTF-8: 0xE2 0x96 0xB6  UTF-16: 0x25B6

const literal  CanonicallyExpanded = "▼";
                              //"▼" = ""
                              //U+25B7 Black Down-Pointing Triangle
                              //
                              //"▼" = ""
                              //
                              //

const literal  DeltaCapital = "\342\210\206";
                              //"∆" = "\342\210\206"
                              //U+2206 INCREMENT
                              //UTF-8: 0xE2 0x88 0x86   UTF-16: 0x2206
                              //"Δ" = "\316\224"
                              //U+0394 GREEK CAPITAL LETTER DELTA
                              //UTF-8: 0xCE 0x94   UTF-16: 0x0394

const literal  Play = "▶";
                              //"▶" = ""
                              //U+25B6 Black Right-Pointing Triangle
                              //

const literal  Stop = "■";
                              //"■" = ""
                              //U+25A0 Black Square
                              //

//const literal   = "";
//                              //"❀" = "\342\235\200"
//                              //U+2740 WHITE FLORETTE
//                              //UTF-8: 0xE2 0x9D 0x80  UTF-16: 0x274  &#10048;

//const literal   = "";
//                              //"" = ""
//                              //
//                              //

//const literal   = "";
//                              //"" = ""
//                              //
//                              //

//------------------------------------------------------------------------------
} //namespace RA::Symbol

//------------------------------------------------------------------------------
} //namespace RA
#endif
