////////////////////////////////////////////////////////////////////////////////
/*! @file Window.h   Прото-виджет для дочерних окон главного окна RA.
- Part of RAGUI - Research Assistant Graphical User Interface Library.
- Uses  RANet - Research Assistant Net Library.
- Uses  Qt v.5  -  http://qt-project.org/
- Copyright(C) 2010-2014, Viktor E. Bursian, St.Petersburg, Russia.
                          VBursian@gmail.com
*///////////////////////////////////////////////////////////////////////////////
#ifndef Window_H
#define Window_H
#include "General.h"
#include "NodePtr.h"
#include "RAGUI_global.h"
//#include "Undo.h"
#include "RAMainWindow.h"
#include <QFrame>
#include <QFocusEvent>
#include <QIcon>
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sWindow)
//ANNOUNCE_CLASS(sUndoDestroyWindow)

//------------------------------------------------------------------ sWindow ---


class RAGUI_EXPORT  sWindow : public QFrame
{
  Q_OBJECT

  public:
    virtual                   ~sWindow ();
    explicit                  sWindow (sNodePtr   config
                                      ,sString    default_title
                                      ,QWidget *  parent       );
    virtual const QIcon &     Icon () =0;
    virtual sString           Title ();
    void                      Predestruct ();
    virtual void              RestoreState ();
    virtual void              StoreState ();
    virtual bool              CanClose ();
    virtual void              DonotClose ();
    virtual void              DoClose ();
    psRAMainWindow            MainWindow ();

  signals: //outgoing
    void                      QuittingIsAllowed ();
  
  signals: /*! @todo{UI} make it work*/
    void                      TitleChanged ();
    void                      FocusReceived (bool);

  signals: //for internal needs
    void                      ClosingRequested ();
    void                      ClosingCanceled ();

  private slots:
//    void virtual              UpdateTitle ();

  protected: //inherited
    virtual void              changeEvent (QEvent *);
    virtual void              focusInEvent (QFocusEvent *);
    virtual void              focusOutEvent (QFocusEvent *);

  protected: 
    virtual void              Retranslate ()
                                {}
  
  public: //fields
//    sNodePtr                  WidgetConfig;
    sPtr<sFolderNode>         WidgetConfig;
    bool                      AutoTitled;
    sString                   TheTitle;
};

//------------------------------------------------------- sUndoDestroyWindow ---

//class sUndoDestroyWindow : public sUndoItem
//{
//  public:
//                              sUndoDestroyWindow (psRAMainWindow  main_window
//                                                    ,sNodePtr        config)
//                                  :MainWindow(main_window),Config(config)
//                                {}
//    virtual void              UndoIt ();
//  protected:
//    psRAMainWindow            MainWindow;
//    sNodePtr                  Config;
//};

//------------------------------------------------------------------------------
} //namespace RA
#endif
