////////////////////////////////////////////////////////////////////////////////
/*! @file Workbook.h    Рабочий журнал экспериментатора.
- Part of RAGUI - Research Assistant Graphical User Interface Library.
- Uses  Qt v.5.0.2  - http://qt-project.org/
- Uses  RANet - Research Assistant Net Library.
- Copyright(C) 2010-2014, Viktor E. Bursian, St.Petersburg, Russia.
                          Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef Workbook_H
#define Workbook_H
#include "Window.h"
#include "Navigator.h"
#include <QTimer>
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sWorkbook)

//---------------------------------------------------------------- sWorkbook ---

class sWorkbook : public sWindow
{
  Q_OBJECT
  public:
    virtual                   ~sWorkbook ();
    explicit                  sWorkbook (sNodePtr   config
                                        ,sString    default_title
                                        ,QWidget *  parent       );
    virtual const QIcon &     Icon ();
    virtual void              RestoreState ();
    virtual void              StoreState ();

  public: //fields
  private: //fields
    psNet2TreeEvolution       Evolution;
    psNavigator               Navigator;
    QTimer *                  UpdatingTimer;
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
