////////////////////////////////////////////////////////////////////////////////
/*! @file InstallJob.h
- Uses selected files from RANet - Research Assistant Net Library.
- Uses  Qt v.5  -  http://qt-project.org/
- Copyright(C) 2011-2015, Viktor E. Bursian, St.Petersburg, Russia.
                          VBursian@gmail.com
*///////////////////////////////////////////////////////////////////////////////
#ifndef InstallJob_H
#define InstallJob_H
#include "CommonDist.h"
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sInstallJob)

//------------------------------------------------------------- sInstallJob ---

class sInstallJob : public sApplicationJob
{
  public:
                              sInstallJob (bool  testing);
    bool                      AnalizeDistributive ();
    QString                   Plan ();
    bool                      MakeDirs ();
    bool                      Install ();
    bool                      InstallProg ();
    bool                      InstallFonts ();
    bool                      InstallSandbox ();
    bool                      InstallLauncher ();
    bool                      InstallSources ();

  public://fields
    bool                      Updating;
    bool                      Install_Prog;
    bool                      Install_Fonts;
    bool                      Install_Sandbox;
    bool                      Install_Launcher;
    bool                      Install_Sources;
    QString                   Resume;
    QString                   ProgDirDefaultLocation;
//    QString                   ProgDirDefaultName;
    QDir                      ProgDir;
    QDir                      FontsDir;
    QDir                      SandboxDir;
    QDir                      SrcCopyDir;
    QString                   FontsZip;
    QStringList               Sources;
    QStringList               OtherProgZips;
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
