////////////////////////////////////////////////////////////////////////////////
/*! @file InstallWizard.h   Мастер установки составного дистрибутива.
- Uses selected files from RANet - Research Assistant Net Library.
- Uses  Qt v.5  -  http://qt-project.org/
- Copyright(C) 2011-2015, Viktor E. Bursian, St.Petersburg, Russia.
                          VBursian@gmail.com
*///////////////////////////////////////////////////////////////////////////////
#ifndef InstallWizard_H
#define InstallWizard_H
#include "InstallJob.h"
#include <QCheckBox>
#include <QLabel>
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sInstallWizard)
ANNOUNCE_CLASS(sIntroPage)
ANNOUNCE_CLASS(sMainSelectionPage)
ANNOUNCE_CLASS(sProgDirPage)
ANNOUNCE_CLASS(sPartsSelectionPage)
ANNOUNCE_CLASS(sLicensePage)
ANNOUNCE_CLASS(sInstallationPage)
ANNOUNCE_CLASS(sConclusionPage)
ANNOUNCE_CLASS(sSorryPage)

//----------------------------------------------------------- sInstallWizard ---

class  sInstallWizard : public QWizard
{
  Q_OBJECT
  public:
                              sInstallWizard (bool  testing);
    enum                      {IntroPage
//                              ,AboutPage
                              ,MainSelectionPage
                              ,ProgDirPage
                              ,PartsSelectionPage
                              ,LicensePage
                              ,InstallationPage
                              ,ConclusionPage
                              ,SorryPage
                              };

  public: //reimplementing inherited:
    virtual int               nextId () const;

  private://fields
    psInstallJob              Job;
};

//--------------------------------------------------------------- sIntroPage ---

class  sIntroPage : public QWizardPage
{
  Q_OBJECT
  public:
                              sIntroPage (psInstallJob);
  private://fields
    psInstallJob              Job;
};

//------------------------------------------------------- sMainSelectionPage ---

class  sMainSelectionPage : public QWizardPage
{
  Q_OBJECT
  public:
                              sMainSelectionPage (psInstallJob);
    virtual bool              isComplete () const;

  private://fields
    psInstallJob              Job;
};

//------------------------------------------------------------- sProgDirPage ---

class  sProgDirPage : public QWizardPage
{
  Q_OBJECT
  public:
                              sProgDirPage (psInstallJob);
    virtual bool              isComplete () const;
  private slots:
    void                      ProgDirBrowse ();
  private:
    bool                      FindPreviousInstallations ();
  private://fields
    psInstallJob              Job;
};

//------------------------------------------------------ sPartsSelectionPage ---

class  sPartsSelectionPage : public QWizardPage
{
  Q_OBJECT
  public:
                              sPartsSelectionPage (psInstallJob);
  private slots:
    void                      Validate (bool);
  private://fields
    psInstallJob              Job;
};

//------------------------------------------------------------- sLicensePage ---

class  sLicensePage : public QWizardPage
{
  Q_OBJECT
  public:
                              sLicensePage (psInstallJob);
    virtual void              initializePage ();
    virtual bool              isComplete () const;
  private slots:
    void                      ShowIntro ();
    void                      ShowGPL ();
    void                      ShowFDL ();
  private://fields
    psInstallJob              Job;
    QTextEdit *               Viewer;
    QPushButton *             btnIntro;
    QPushButton *             btnGPL;
    QPushButton *             btnFDL;
    QCheckBox *               chkboxAgree;
};

//-------------------------------------------------------- sInstallationPage ---

class  sInstallationPage : public sDoItPage
{
  Q_OBJECT
  public:
                              sInstallationPage (psInstallJob);

  protected:
    virtual bool              DoIt ();

  private: //reimplementing inherited:
    virtual void              initializePage ();

  private://fields
    psInstallJob              Job;
};

//---------------------------------------------------------- sConclusionPage ---

class  sConclusionPage : public QWizardPage
{
  Q_OBJECT
  public:
                              sConclusionPage ();
    virtual void              initializePage ();
    QLabel *                  Label;
};

//--------------------------------------------------------------- sSorryPage ---

class  sSorryPage : public QWizardPage
{
  Q_OBJECT
  public:
                              sSorryPage ();
    virtual void              initializePage ();
    QLabel *                  Label;
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
