////////////////////////////////////////////////////////////////////////////////
/*! @file LonelyApplication.h   QApplication subclass, which prevents
                                running of another instance of the same program.
- Uses  Qt v.5  -  http://qt-project.org/
- Copyright(C) 2014, Viktor E. Bursian, St.Petersburg, Russia.
                     VBursian@gmail.com
*///////////////////////////////////////////////////////////////////////////////
#ifndef LonelyApplication_H
#define LonelyApplication_H
#include <QApplication>
#include <QSharedMemory>
//------------------------------------------------------------------------------
//------------------------------------------------------- sLonelyApplication ---
/*! A substitution for QApplication, which prevents running of another instance
    of the same program.
*/
class sLonelyApplication : public QApplication
{
  Q_OBJECT
  public:
    explicit                  sLonelyApplication (int      argc
                                                 ,char *   argv[]
                                                 ,QString  unique_name
                                                 );
    bool                      IsFirstInstance () const
                                { return FirstInstanceFlag; }
  
  private:
    bool                      FirstInstanceFlag;
    QSharedMemory *           SharedMemory;
};

//------------------------------------------------------------------------------
#endif 
