////////////////////////////////////////////////////////////////////////////////
/*! @file Primogeniture.h   Checking primogeniture, in order to prevent
                            running of another instance of the same program.
- Uses  Qt v.5  - http://qt.io/
- Copyright(C) 2020, Viktor E. Bursian, St.Petersburg, Russia.
                     VBursian AT gmail DOT com
*///////////////////////////////////////////////////////////////////////////////
#ifndef Primogeniture_H
#define Primogeniture_H
#include <QString>
namespace RA {
//------------------------------------------------------------------------------

/*! Checks whether or not
    this is the first running instance of the same program.

@param unique_name - can be an executable name or a full name of the program

*/
extern bool  GetPrimogeniture (const QString &  unique_name);

//------------------------------------------------------------------------------
}//namespace RA
#endif
