////////////////////////////////////////////////////////////////////////////////
/*! @file Adam.cpp   Реализация полиморфизма.
- Part of RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 1994-2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#include "Adam.h"
#include "Excepts.h"
//#include "Trace.h"
//#include <utility>
namespace RA {
//------------------------------------------------------------------------------

//--------------------------------------------------------------------- sTag ---

sTag::sTag (literal name)
  :TheName(name)
{
//  TRACE( TheName );
  std::pair<map<sString,pcsTag>::iterator,bool>  P;
  P=TagMapByName.insert(std::pair<sString,pcsTag>(sString(name),this));
  ASSERT(P.second);
}


pcsTag  sTag::ByName (rcsString name)
{
  sTagMapByName::const_iterator   p=TagMapByName.find(name);
  return ( p != sTag::TagMapByName.end()  ?  p->second  :  NULL );
}

//-------------------------------------------------------------------- sAdam ---
/*! @class sAdam
Обеспечивает возможность получить имя класса полиморфного объекта
в виде строки.
@code
  psAdam  PA;
  // ...
  PA = new sDataArrayRecord(...);
  // ...
  cout << PA->TrueType().Name();
@endcode
@sa sTag sStorable
*/

//------------------------------------------------------------------------------
} //namespace RA
