////////////////////////////////////////////////////////////////////////////////
/*! @file BasicNetClassPredeclarations.hpp   Predeclares the following classes:
                           sNodeLocation, sNet, sAttribute, sNode, sFolderNode.
- Part of RANet - Research Assistant Net Library.
- Copyright(C) 1994-2020, Viktor E. Bursian, St.Petersburg, Russia.
                          VBursian@gmail.com
*///////////////////////////////////////////////////////////////////////////////
#ifndef BasicNetClassPredeclarations_HPP
#define BasicNetClassPredeclarations_HPP
#include "General.h"
namespace RA {
//------------------------------------------------------------------------------

//predeclarations:
//N.B.: doxygen does not fully understand macros

//ANNOUNCE_ABSTRACT_CLASS(sNodeLocation)  // declared in NodeLocation.h
class   sNodeLocation;
typedef const sNodeLocation         csNodeLocation;
typedef sNodeLocation &             rsNodeLocation;
typedef const sNodeLocation &       rcsNodeLocation;
typedef sNodeLocation *             psNodeLocation;
typedef const sNodeLocation *       pcsNodeLocation;
typedef const psNodeLocation        cpsNodeLocation;
typedef const pcsNodeLocation       cpcsNodeLocation;

//ANNOUNCE_ABSTRACT_CLASS(sNet)  // declared in Net.h
class   sNet;
typedef const sNet         csNet;
typedef sNet &             rsNet;
typedef const sNet &       rcsNet;
typedef sNet *             psNet;
typedef const sNet *       pcsNet;
typedef const psNet        cpsNet;
typedef const pcsNet       cpcsNet;

ANNOUNCE_CLASS(sAttribute)     // declared in Attribute.h
class   sAttribute;
typedef const sAttribute         csAttribute;
typedef sAttribute &             rsAttribute;
typedef const sAttribute &       rcsAttribute;
typedef sAttribute *             psAttribute;
typedef const sAttribute *       pcsAttribute;
typedef const psAttribute        cpsAttribute;
typedef const pcsAttribute       cpcsAttribute;

ANNOUNCE_ABSTRACT_CLASS(sNode) // declared in Nodes.h
class   sNode;
typedef const sNode         csNode;
typedef sNode &             rsNode;
typedef const sNode &       rcsNode;
typedef sNode *             psNode;
typedef const sNode *       pcsNode;
typedef const psNode        cpsNode;
typedef const pcsNode       cpcsNode;

ANNOUNCE_CLASS(sFolderNode)    // declared in FolderNode.h
class   sFolderNode;
typedef const sFolderNode         csFolderNode;
typedef sFolderNode &             rsFolderNode;
typedef const sFolderNode &       rcsFolderNode;
typedef sFolderNode *             psFolderNode;
typedef const sFolderNode *       pcsFolderNode;
typedef const psFolderNode        cpsFolderNode;
typedef const pcsFolderNode       cpcsFolderNode;



//------------------------------------------------------------------------------
} //namespace RA
#endif


