////////////////////////////////////////////////////////////////////////////////
/*! @file Environment.h   Среда работы программы и глобальные опции.
- Part of RANet - Research Assistant Net Library.
- Copyright(C) 2010-2020, Viktor E. Bursian, St.Petersburg, Russia.
                          VBursian AT gmail DOT com
*///////////////////////////////////////////////////////////////////////////////
#ifndef Environment_H
#define Environment_H
#include "Strings.h"
#include "Files.h"
#include <map>
#include <list>
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sUser)
ANNOUNCE_CLASS(sEnvironment)

//-------------------------------------------------------------------- sUser ---

class RANet_EXPORT  sUser
{
  public: //types
    enum                      eAccessLevel {cNewbie,cExpert,cAdmin};

  public:
                              sUser ()
                                  :AccessLevel(cNewbie)
                                  ,MaxAccessLevel(cExpert)
                                {}

  public: //fields
    eAccessLevel              AccessLevel;
    eAccessLevel              MaxAccessLevel;
};

//------------------------------------------------------------- sEnvironment ---

class RANet_EXPORT  sEnvironment
{
  public: //static
    static bool               BoolOption (sString  ParamName
                                         ,bool     DefaultValue =false);
    static sString            StringOption (sString  ParamName
                                           ,sString  DefaultValue = sString());
    static void               SetStringOption (sString  param_name
                                              ,sString  value);

  public: //static fields
    static sPath              ProgramFilePath;
    static sPath              HelpFilePath;
    static sPath              RADir;
    static sUser              User;
    static std::list<sString> Arguments;

  private: //static fields
    static std::map
            <sString,bool>    BoolOptions;
    static std::map
            <sString,sString> StringOptions;

  public:
                              sEnvironment (int argc ,char * argv[]);
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
