////////////////////////////////////////////////////////////////////////////////
/*! @file Instrument.cpp Инструмент, поставляемый с плагином.
- Part of RANet - Research Assistant Net Library.
- Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#include "Instrument.h"
#include "BasicNodes.h"
namespace RA {
//------------------------------------------------------------------------------

//----------------------------------------------------------- sInstrumentTag ---

sInstrumentTag::sInstrumentTag (literal         classname
                               ,eInstrumentType classtype)
    :sTag(classname)
{
  AvailableClassList[sString(classname)]=classtype;
}

//-------------------------------------------------------------- sInstrument ---
/*! @class sInstrument


@todo{Instruments} Add functionality: принадлежность к пакету

@todo{Instruments} Add functionality: About

*/

bool  sInstrument::Exists (sString  ClassName)
{
  return sInstrumentTag::AvailableClassList.find(ClassName)
      != sInstrumentTag::AvailableClassList.end();
}


bool  sInstrument::IsDriver (sString  ClassName)
{
  return Exists(ClassName)
      && sInstrumentTag::AvailableClassList[ClassName] == cDriver;
}


bool  sInstrument::IsConsole (sString  ClassName)
{
  return Exists(ClassName)
      && sInstrumentTag::AvailableClassList[ClassName] == cConsole;
}


bool  sInstrument::IsGadget (sString  ClassName)
{
  return Exists(ClassName)
      && sInstrumentTag::AvailableClassList[ClassName] == cGadget;
}


sInstrument::~sInstrument ()
{
}

sInstrument::sInstrument ()
{
}

//------------------------------------------------------------------------------
} //namespace RA
