################################################################################
#
################################################################################
LICENSE = LGPLv2

TEMPLATE = lib
CONFIG += dll
CONFIG -= debug_and_release
#QT -= gui
#QT *= core
QT += widgets sql

include( ../RA_common_prefix.pri )

TARGET = RANet
DEFINES += RANET_LIBRARY_BUILD
VER_PAT = $${CORE_VER_PAT}

include( $${RADIR}RA_common_suffix.pri )
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#___________________________sources_to_be_built_into_this_plugin___
HEADERS += RANet_global.h
#-------------------------------------------------
HEADERS += attr.h
HEADERS += StringsAndQStrings.h
HEADERS += QtSQLWrapper.hpp
#-------------------------------------------------
HEADERS += General.h
SOURCES += General.cpp
HEADERS += Symbols.h
HEADERS += Excepts.h
SOURCES += Excepts.cpp
HEADERS += Strings.h
SOURCES += Strings.cpp
HEADERS += Version.h
SOURCES += Version.cpp

HEADERS += Trace.h
SOURCES += Trace.cpp
HEADERS += Files.h
SOURCES += Files.cpp
HEADERS += Adam.h
SOURCES += Adam.cpp
HEADERS += Storable.h
SOURCES += Storable.cpp
HEADERS += Time.h
SOURCES += Time.cpp
HEADERS += Log.h
SOURCES += Log.cpp
HEADERS += Undo.h
#SOURCES += Undo.cpp
HEADERS += Environment.h
SOURCES += Environment.cpp

HEADERS += AttrName.h
SOURCES += AttrName.cpp
HEADERS += BasicNetClassPredeclarations.hpp
HEADERS += NodeLocation.h
HEADERS += NodePtr.h
SOURCES += NodePtr.cpp
HEADERS += Attribute.h
SOURCES += Attribute.cpp
HEADERS += Net.h
SOURCES += Net.cpp
HEADERS += Nodes.h
SOURCES += Nodes.cpp
HEADERS += FolderNode.h
SOURCES += FolderNode.cpp
HEADERS += NetExceptions.h
SOURCES += NetExceptions.cpp

HEADERS += Units.h
SOURCES += Units.cpp
HEADERS += PhysValue.h
SOURCES += PhysValue.cpp
HEADERS += Ranges.h
SOURCES += Ranges.cpp
HEADERS += BasicNodes.h
SOURCES += BasicNodes.cpp
HEADERS += FileNode.h
SOURCES += FileNode.cpp

HEADERS += UnitSystemIO.h
SOURCES += UnitSystemIO.cpp
HEADERS += Color.h
SOURCES += Color.cpp
HEADERS += ColorNodes.h
SOURCES += ColorNodes.cpp
HEADERS += Graphicals.h
SOURCES += Graphicals.cpp
HEADERS += Record.h
SOURCES += Record.cpp
HEADERS += Curves.h
SOURCES += Curves.cpp
HEADERS += Marks.h
SOURCES += Marks.cpp
HEADERS += Functions.h
SOURCES += Functions.cpp
HEADERS += ArrayDataFunction.h
SOURCES += ArrayDataFunction.cpp
HEADERS += ListDataFunction.h
SOURCES += ListDataFunction.cpp
HEADERS += TableDataFunction.h
SOURCES += TableDataFunction.cpp
HEADERS += DataArrayFolder.h
SOURCES += DataArrayFolder.cpp
HEADERS += DataListFolder.h
SOURCES += DataListFolder.cpp
HEADERS += DataTableFolder.h
SOURCES += DataTableFolder.cpp
HEADERS += DataArrayRecord.h
SOURCES += DataArrayRecord.cpp
HEADERS += DataListRecord.h
SOURCES += DataListRecord.cpp
HEADERS += DataTableRecord.h
SOURCES += DataTableRecord.cpp

HEADERS += BasicMath.h
SOURCES += BasicMath.cpp
HEADERS += PhysMath.h
SOURCES += PhysMath.cpp
HEADERS += NetMath.h
SOURCES += NetMath.cpp
HEADERS += ExpressionNode.h
SOURCES += ExpressionNode.cpp

#HEADERS += ProtoNet.h
#SOURCES += ProtoNet.cpp
#HEADERS += SingleFileNet.h
#SOURCES += SingleFileNet.cpp
#HEADERS += BasicNet.h
#SOURCES += BasicNet.cpp
HEADERS += DB_Link.h
SOURCES += DB_Link.cpp
HEADERS += Database.h
SOURCES += Database.cpp
HEADERS += DB_SQL_Net.h
SOURCES += DB_SQL_Net.cpp

HEADERS += Instrument.h
SOURCES += Instrument.cpp
HEADERS += Device.h
SOURCES += Device.cpp

HEADERS += TestMemUsage.h
SOURCES += TestMemUsage.cpp

SOURCES += StaticInitiators.cpp

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#                               что бы это значило?
DISTFILES += RANetURI_syntax.txt

#^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

