////////////////////////////////////////////////////////////////////////////////
/*! @file Symbols.h   Predefined symbolic strings.
- Part of RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 1994-2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef Symbols_H
#define Symbols_H
#include "General.h"
namespace RA {
//------------------------------------------------------------------------------

//! @todo{elegancy} подменить везде
namespace Symbol {
//------------------------------------------------------------------------------

//const literal  Unit_1 = "{1}";
const literal  Unit_1 = "\342\221\240";
                              //"①" = "\342\221\240"
                              //U+2460 CIRCLED DIGIT ONE
                              //UTF-8: 0xE2 0x91 0xA0  UTF-16: 0x2460
                              //"𝟙" = "\360\235\237\231"
                              //U+1D7D9 MATHEMATICAL DOUBLE-STRUCK DIGIT ONE
                              //UTF-8: 0xF0 0x9D 0x9F 0x99 UTF-16: 0xD835 0xDFD9

const literal  Micro = "\302\265";
                              //"µ" = "\302\265"
                              //U+00B5 MICRO SIGN
                              //UTF-8: 0xC2 0xB5  UTF-16: 0x00B5
                              //******* не путать с:
                              //"μ" = "\316\274"
                              //U+03BC GREEK SMALL LETTER MU
                              //UTF-8: 0xCE 0xBC  UTF-16: 0x03BC

const literal  CurveIcon = "\342\210\277";
                              //"∿" = "\342\210\277"
                              //U+223F SINE WAVE
                              //UTF-8: 0xE2 0x88 0xBF   UTF-16: 0x223F

const literal  MarkIcon = "\342\206\226";
                              //"↖" = "\342\206\226"
                              //U+2196 NORTH WEST ARROW
                              //UTF-8: 0xE2 0x86 0x96   UTF-16: 0x2196

const literal  BinaryData = "⏥";
                              //"⏥" = ""
                              //
                              //

const literal  Plus = "＋";
                              //"＋" = ""
                              //
                              //

const literal  Minus = "－";
                              //"－" = ""
                              //
                              //

const literal  IdenticalTo = "≡";
                              //"≡" = "\342\211\241"
                              //U+2261 IDENTICAL TO
                              //UTF-8: 0xE2 0x89 0xA1  UTF-16: 0x2261   &#8801;

const literal  Multiplication = "×";
                              //"×" = ""
                              //U+00D7 MULTIPLICATION SIGN
                              //

const literal  MiddleDot = "·";
                              //"·" = ""
                              //U+00B7 MIDDLE DOT
                              //

const literal  PlusMinus = "±";
                              //"±" = ""
                              //U+00B1 PLUS-MINUS SIGN
                              //

const literal  Infinity = "∞";
                              //"∞" = ""
                              //U+221E INFINITY
                              //

const literal  NaN = "¿";
                              //"¿" = ""
                              //U+00BF INVERTED QUESTION MARK
                              //

const literal  Ellipsis = "…";
                              //"…" = ""
                              //U+2026 HORIZONTAL ELLIPSIS = three dot leader
                              //

const literal  RangeDelimiter = "…";
                              //"…" = ""
                              //U+2026 HORIZONTAL ELLIPSIS = three dot leader
                              //

const literal  Degree = "\302\260";
                              //"°" = "\302\260"
                              //U+00B0 DEGREE SIGN
                              //

const literal  CelsiusDegree = "\342\204\203";
                              //"℃" = "\342\204\203"
                              //U+2103 DEGREE CELSIUS
                              //UTF-8: 0xE2 0x84 0x83  UTF-16: 0x2103

const literal  Ohm = "\342\204\246";
                              //"Ω" = "\342\204\246"
                              //U+2126 OHM SIGN
                              //UTF-8: 0xE2 0x84 0xA6  UTF-16: 0x2126

const literal  PhotonUnit = "\342\204\231";
                              //"ℙ" = "\342\204\231"
                              //U+2119 DOUBLE-STRUCK CAPITAL P
                              //UTF-8: 0xE2 0x84 0x99  UTF-16: 0x2119   &#8473;

//const literal  SpinUnit = "\342\204\277";
//                              //"ℿ" = "\342\204\277"
//                              //U+213F DOUBLE-STRUCK CAPITAL PI
//                              //UTF-8: 0xE2 0x84 0xBF  UTF-16: 0x213F   &#8511;
//                              //

const literal  SpinUnit = "⇈";
                              //"⇈" = ""
                              //U+21C8 Upwards Paired Arrows
                              //UTF-8:   UTF-16: 0x21C8
                              //

//const literal   = "";
//                              //"" = ""
//                              //
//                              //

//const literal   = "";
//                              //"" = ""
//                              //
//                              //


//------------------------------------------------------------------------------
} //namespace RA::Symbol

//------------------------------------------------------------------------------
} //namespace RA
#endif
