////////////////////////////////////////////////////////////////////////////////
/*! @file TestMemUsage.cpp Трассировка числа элементов сети.
- Part of RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 1994-2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#include "TestMemUsage.h"
#include "Log.h"
#include "Attribute.h"
#include "Nodes.h"
namespace RA {
//------------------------------------------------------------------------------

#ifdef RANET_DEBUG

void  TestMemoryUsage (literal   test_memory_usage______comment
                      ,long int  attr_names_expected
                      ,long int  attrs_expected
                      ,long int  ptrs_expected
                      ,long int  nodes_expected
                      )
{
  sString                     T;
  T += test_memory_usage______comment;
  if( sAttrName::Counter != attr_names_expected )
    T += sString("\n\t\t\t\t   sAttrName::Counter=")
        +sString::FromInteger(sAttrName::Counter);
  if( sAttribute::Counter != attrs_expected )
    T += sString("\n\t\t\t\t   sAttribute::Counter=")
        +sString::FromInteger(sAttribute::Counter);
  if( sNodePtr::Counter != ptrs_expected )
    T += sString("\n\t\t\t\t   sNodePtr::Counter=")
        +sString::FromInteger(sNodePtr::Counter);
                               /* NullNode.Redirector
                                 ,NullNodePtr
                                 ,sNet::Manager->Root */
  if( sNode::Counter != nodes_expected )
    T += sString("\n\t\t\t\t   sNode::Counter=")
        +sString::FromInteger(sNode::Counter);
  RANet::Log.Put(sLog::Debug,"MemoryUsage",T);
}

#else

void  TestMemoryUsage (literal
                      ,long int
                      ,long int
                      ,long int
                      ,long int
                      )
{
}

#endif

//------------------------------------------------------------------------------
} //namespace RA
