////////////////////////////////////////////////////////////////////////////////
/*! @file Trace.h   Отладочная трассировка.
- Part of RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 1994-2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef Trace_H
#define Trace_H
#include "Strings.h"
namespace RA {
//------------------------------------------------------------------------------

#ifdef RANET_DEBUG
  #define TRACE( Expression )    Trace(#Expression,Expression);
#else
  #define TRACE( Expression )    ;
#endif

#ifdef RANET_DEBUG
  #define TRACENOCR( Expression )    TraceNoCR(#Expression,Expression);
#else
  #define TRACENOCR( Expression )    ;
#endif

void RANet_EXPORT  Trace (literal  What ,rcsString  Value);
void RANet_EXPORT  Trace (literal  What ,literal    Value);
void RANet_EXPORT  Trace (literal  What ,long       Value);

void RANet_EXPORT  TraceNoCR (literal  What ,rcsString  Value);
void RANet_EXPORT  TraceNoCR (literal  What ,literal    Value);
void RANet_EXPORT  TraceNoCR (literal  What ,long       Value);

//------------------------------------------------------------------------------
}; //namespace RA
#endif

