////////////////////////////////////////////////////////////////////////////////
/*! @file BasicDevices.h   Пакет базовых драйверов.
- Part of BasicDevices - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef BasicDevices_H
#define BasicDevices_H
#include "RAPlugins.h"
namespace RA {
//------------------------------------------------------------------------------

#if defined(BasicDevices_PLUGIN_BUILD)
    #define BasicDevices_EXPORT Q_DECL_EXPORT
#elif defined(BasicDevices_PLUGIN_USE)
    #define BasicDevices_EXPORT Q_DECL_IMPORT
#else
    #define BasicDevices_EXPORT
#endif

//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sBasicDevices)

//------------------------------------------------------------------------------

class sBasicDevices : public QObject ,public sInstrumentalPackage
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "BursianSoft.RA.sInstrumentalPackage")
    Q_INTERFACES(RA::sInstrumentalPackage)
    ADAM(sBasicDevices)

  public:
    virtual sVersion          Version ();
    virtual sVersion          CoreVersionUsed ();
    virtual sVersion          CoreVersionMin ();
    virtual QString           UserFriendlyName ();
    virtual QString           About ();
                              sBasicDevices ();
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
