################################################################################
#
################################################################################
TEMPLATE = lib
CONFIG += plugin
CONFIG -= debug_and_release
QT += widgets

include( ../../RA_common_prefix.pri )

RA_PLUGIN_NAME = BasicDevices
#VER_PAT = 1-alpha   # = 1-alpha, 1-beta, 1, 2-alpha, 2-beta, 2, ...

TRANSLATIONS = $${RADIR}locales/$${RA_PLUGIN_NAME}.ru_RU.ts

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#______________________________________________use_RAGUI_library___
INCLUDEPATH += $${RADIR}RAGUI/
DEFINES += RAGUI_LIBRARY_USE
LIBS += -lRAGUI$${LIB_SUFFIX}
#______________________________________________use_RANet_library___
INCLUDEPATH += $${RADIR}RANet/
DEFINES += RANET_LIBRARY_USE
LIBS += -lRANet$${LIB_SUFFIX}

#___________________________sources_to_be_built_into_this_plugin___
HEADERS += BasicDevices.h
SOURCES += BasicDevices.cpp
# -------------------------------

HEADERS +=     Gauge.h
SOURCES +=     Gauge.cpp
OTHER_FILES += Gauge.state_graph

HEADERS +=     GaugeDisplay.h
SOURCES +=     GaugeDisplay.cpp
OTHER_FILES += GaugeDisplay.state_graph

HEADERS +=     GaugeLCD.h
SOURCES +=     GaugeLCD.cpp

HEADERS +=     FixedUnitsLCD.h
SOURCES +=     FixedUnitsLCD.cpp

HEADERS +=     Effectors.h
SOURCES +=     Effectors.cpp
#OTHER_FILES += Effector.state_graph

HEADERS +=     EffectorConsole.h
SOURCES +=     EffectorConsole.cpp
#OTHER_FILES += EffectorConsole.state_graph
HEADERS +=     TunedEffectorConsole.h
SOURCES +=     TunedEffectorConsole.cpp

HEADERS +=     Scanner.h
SOURCES +=     Scanner.cpp
OTHER_FILES += Scanner.state_graph

HEADERS +=     PeriodicGaugeRecorder.h
SOURCES +=     PeriodicGaugeRecorder.cpp
OTHER_FILES += PeriodicGaugeRecorder.state_graph

HEADERS +=     StepByStepScanner.h
SOURCES +=     StepByStepScanner.cpp
#OTHER_FILES += StepByStepScanner.state_graph

#HEADERS += ProtoAccumulator.h
#SOURCES += ProtoAccumulator.cpp

#HEADERS += FastPassMultiScanner.h     IndivisiblePassMultiScanner.h
#SOURCES += FastPassMultiScanner.cpp

#HEADERS += ClassicMultiScanner.h
#SOURCES += ClassicMultiScanner.cpp

#HEADERS += BackAndForthScanner.h
#SOURCES += BackAndForthScanner.cpp

HEADERS +=     TeleCom.h
SOURCES +=     TeleCom.cpp
#OTHER_FILES += TeleCom.state_graph

HEADERS += TController.h
SOURCES += TController.cpp

HEADERS += CCDDriver.h
SOURCES += CCDDriver.cpp
HEADERS += TunableCCDDriver.h
SOURCES += TunableCCDDriver.cpp

HEADERS += CCDScaner.h
SOURCES += CCDScaner.cpp

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
include( $${RADIR}RA_common_suffix.pri )
#^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
