////////////////////////////////////////////////////////////////////////////////
/*! @file TeleCom.cpp   Short message communicator.
- Part of BasicDevices - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface Library.
- Uses  Qt v.5.0.2  - http://qt-project.org/
- Uses  RANet - Research Assistant Net Library.
- Copyright(C) 2010-2013, Viktor E. Bursian, St.Petersburg, Russia.
                          Viktor.Bursian@mail.ioffe.ru
- Copyright(C) 2010-2013, Dmitry K. Nelson, St.Petersburg, Russia.
                          D.Nelson@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#include "TeleCom.h"
#include "attr.h"
#include "StringsAndQStrings.h"
namespace RA {
//------------------------------------------------------------------------------

DEFINE_CLASS_TAG(sTeleCom)

const sDirective<sTelex>      sTeleCom::cSendTelex("cSendTelex");

//------------------------------------------------------------------- sTelex ---

sTelex::~sTelex ()
{
}

sTelex::sTelex ()
    :QByteArray()
{
}

sTelex::sTelex (rcsTelex  T)
    :QByteArray(T)
{
}

sTelex::sTelex (const char *  S)
    :QByteArray(S)
{
}

//bool  sTelex::operator == (rcsTelex  T) const
//{
//  return ;
//}

sTelex::sTelex (const QString &  S)
    :QByteArray()
{
  //! @patch{Instruments} Надо разбирать визуализацию непечатных символов
  append(S);
}

sTelex::operator QString () const
{
  //! @patch{Instruments} Надо визуализировать непечатные символы
  return QString::fromLocal8Bit(constData());
}

//----------------------------------------------------------------- sTeleCom ---

sTeleCom::~sTeleCom ()
{
  if( DeviceSettings.IsCorrect() ){
//    DeviceSettings << attr("Timeout",TheTimeout);
  }
}


void  sTeleCom::Preconfigure (sNodePtr  DeviceCfg)
{
  sPtr<sFolderNode>              DeviceSettings;
  DeviceCfg |= "Settings";
  DeviceSettings = DeviceCfg >> "Settings";
  if( DeviceSettings.IsCorrect() ){
//    DeviceSettings |= attr("Timeout",sPhysValue(60.0,"s"));
  }
  sDriver::Preconfigure(DeviceCfg);
}


sTeleCom::sTeleCom (sString   DevicetId
                   ,sNodePtr  DeviceCfg)
    :sDriver(DevicetId,DeviceCfg)
//    ,TheTimeout(1.0,"s")
{
}


void  sTeleCom::PostConstructor ()
{
  sDriver::PostConstructor();
//  try{ //get config parameters
//    get_from<sPhysValueNode>(DeviceSettings>>"Timeout",TheTimeout);
//  }catch(...){
//    SetInvalid(tr("Something wrong in configuration."));
//  }
  //evolution of the inherited state machine (behaviour)
  {
    State_Operating()->AddReaction( cSendTelex ,SLOT(PutTelex(sTelex)) );
  }
}

//------------------------------------------------------------------------------
} //namespace RA

