////////////////////////////////////////////////////////////////////////////////
/*! @file  	TunableCCDDriver.h   Прототип драйвера ПЗС-линейки с перестройкой длины волны.
- Part of BasicDevices - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface Library.
- Uses  Qt v.5.0.2  - http://qt-project.org/
- Uses  RANet - Research Assistant Net Library.
- Copyright(C) 2017, Dmitrii Nelson, St.Petersburg, Russia.
                          d.nelson@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef TunableCCDDriver_H
#define TunableCCDDriver_H
#include "BasicDevices.h"
#include "CCDDriver.h"
#include "Effectors.h"
namespace RA {


//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sTunableCCDDriver)

//-------------------------------------------------------- sTunableCCDDriver ---
/*! Прототип драйвера ПЗС-линейки с перестройкой длины волны.

*/

class BasicDevices_EXPORT  sTunableCCDDriver : public sCCDDriver
{
  Q_OBJECT
  ABSTRACT_DRIVER(sTunableCCDDriver)

  public:
    virtual                  ~sTunableCCDDriver ();

  public: //evolution of the inherited state machine
    psState                   State_W_LinkToWLDriver;

  protected: //reimplementing inherited
    virtual void              PostConstructor ();

  protected slots: //reimplementing inherited

  protected slots:
    virtual void              ReportWLDriverError (QString  error_text);
    virtual void              ConnectWLDriver ();
    virtual void              AcceptWLPosition (sPhysValue _newWL);

  signals: //for internal needs
    void                      WLDriverWarmed ();
    void                      WLDriverError (QString = QString());
    void                      NewWL(sPhysValue);

  protected: //fields
    sEffector::sLink          WLDriver;
    sPhysValue                WLPosition;
    int                       MiddlePixel;

  private: //fields
};

//------------------------------------------------------------------------------
} //namespace RA

#endif
