////////////////////////////////////////////////////////////////////////////////
/*! @file TunedEffectorConsole.h   Консоль управления эффектором с инициализацией.
- Part of BasicDevices - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.5.0  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010-2013, Viktor E. Bursian, St.Petersburg, Russia.
                          Viktor.Bursian@mail.ioffe.ru
- Copyright(C) 2018, Dmitry K. Nelson, St.Petersburg, Russia.
                     D.Nelson@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef TunedEffectorConsole_H
#define TunedEffectorConsole_H
#include "BasicDevices.h"
#include "EffectorConsole.h"
#include "Effectors.h"
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sTunedEffectorConsole)

//------------------------------------------------------- sTunedEffectorConsole ---
/*! Консоль управления эффектором с инициализацией.

Имеет кнопку запуска инициализации.


*/
class  BasicDevices_EXPORT  sTunedEffectorConsole : public sEffectorConsole
{
  Q_OBJECT
  CONSOLE(sTunedEffectorConsole)
  public:
//    virtual                   ~sTunedEffectorConsole ();
  
  public: //reimplementing inherited

  protected:
    virtual void              AppearanceMakeUp ();

  protected: //evolution of the inherited state machine
    psState                   State_O_Initiating;

  signals: //for internal needs
    void                      EffectorReady ();
    void                      Init ();

  protected slots: //reimplementing inherited

  protected slots:
//    virtual void              ApplyRange (sPhysRange);

  protected: //fields
    QPushButton *             BtnInit;

  private slots:
    void                      ConnectReadySignal ();
    void                      OnInit();
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
