////////////////////////////////////////////////////////////////////////////////
/*! @file CCDLomo.cpp Drivers for installations with CCD detector.
- Part of CCDLomo - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2012-2014, Dmitry K. Nelson, St.Petersburg, Russia.
                          D.Nelson@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#include "CCDLomo.h"
#include "attr.h"
#include "LomoCCDDriver.h"
namespace RA {
//------------------------------------------------------------------------------

DEFINE_CLASS_TAG(sCCDLomo)

//------------------------------------------------------------------------------

sVersion  sCCDLomo::Version ()
{
  return sVersion(RAP_VERS_MAJOR
                 ,RAP_VERS_MINOR
                 ,ZAKAVYCH(RAP_VERS_PATCH)
                 ,__DATE__
                 );
}


sVersion  sCCDLomo::CoreVersionUsed ()
{
  return sVersion( RA_VERS_MAJOR , RA_VERS_MINOR );
}


sVersion  sCCDLomo::CoreVersionMin ()
{
  return sVersion( RA_VERS_MAJOR , RA_VERS_MINOR );
}


QString  sCCDLomo::UserFriendlyName ()
{
  return trUtf8("Drivers for installation with CCD detector made by LOMO");
}


QString  sCCDLomo::About ()
{
  return trUtf8(
      "Provides 1 driver:\n"
      "sLomoCCDDriver for MDR with LOMO CCD.\n\n"
      "Copyright (C) 2012, Dmitry K. Nelson, St.Petersburg, Russia.\n"
      "                    D.Nelson@mail.ioffe.ru\n"
      "Copyright (C) 2011, Viktor E. Bursian, St.Petersburg, Russia.\n"
      "                    Viktor.Bursian@mail.ioffe.ru"
                );
}


void  sCCDLomo::InstallDefaults (sPtr<sFolderNode>  /*DeviceList*/)
{
  try{
/*
    sPtr<sFolderNode>              DeviceCfg;

*/
  }catch(...){
    ;
  };

    /*________________________________________template for device
    DeviceList |= "__DEVICE_ID__";
    DeviceCfg = DeviceList >> "__DEVICE_ID__";
    DeviceCfg << attr("Class","__DRIVER_CLASS_NAME__");
    __DRIVER_CLASS_NAME__::Preconfigure(DeviceCfg);
    //if there are links:
    DeviceCfg >> "Links" >> "__LINK_NAME__"
        << attr("DeviceId","__DEVICE_ID__FOR_THE_LINK__");
    //if you wanna change some of the default settings:
    DeviceCfg >> "Settings" << attr("",);
    DeviceCfg >> "Settings" << attr("",);
    */
}


sCCDLomo::sCCDLomo ()
{

}

//------------------------------------------------------------------------------
} //namespace RA
