////////////////////////////////////////////////////////////////////////////////
/*! @file CCDLomo.h   Drivers for installations with CCD detector.
- Part of CCDLomo - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
- Copyright(C) 2014, Dmitrii K. Nelson, St.Petersburg, Russia.
                     d.nelson@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef CCDLomo_H
#define CCDLomo_H
#include "RAPlugins.h"
namespace RA {
//------------------------------------------------------------------------------

#if defined(CCDLomo_PLUGIN_BUILD)
    #define CCDLomo_EXPORT Q_DECL_EXPORT
#elif defined(CCDLomo_PLUGIN_USE)
    #define CCDLomo_EXPORT Q_DECL_IMPORT
#else
    #define CCDLomo_EXPORT
#endif

//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sCCDLomo)

//------------------------------------------------------------------------------

class sCCDLomo : public QObject ,public sInstrumentalPackage
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "BursianSoft.RA.sInstrumentalPackage")
    Q_INTERFACES(RA::sInstrumentalPackage)
    ADAM(sCCDLomo)

  public:
    virtual sVersion          Version ();
    virtual sVersion          CoreVersionUsed ();
    virtual sVersion          CoreVersionMin ();
    virtual QString           UserFriendlyName ();
    virtual QString           About ();
    virtual bool              HasDefaults ()
                                { return true; }
    virtual void              InstallDefaults (sPtr<sFolderNode>  DeviceList);
                              sCCDLomo ();
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
