////////////////////////////////////////////////////////////////////////////////
/*! @file COMPort.cpp COM-port-based devices.
- Part of COMPort - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010-2013, Viktor E. Bursian, St.Petersburg, Russia.
                          Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#include "COMPort.h"
#include "TeleCOMPort.h"
namespace RA {
//------------------------------------------------------------------------------

DEFINE_CLASS_TAG(sCOMPort)

//------------------------------------------------------------------------------

sVersion  sCOMPort::Version ()
{
  return sVersion(RAP_VERS_MAJOR
                 ,RAP_VERS_MINOR
                 ,ZAKAVYCH(RAP_VERS_PATCH)
                 ,__DATE__
                 );
}


sVersion  sCOMPort::CoreVersionUsed ()
{
  return sVersion( RA_VERS_MAJOR , RA_VERS_MINOR );
}


sVersion  sCOMPort::CoreVersionMin ()
{
  return sVersion( RA_VERS_MAJOR , RA_VERS_MINOR );
}


QString  sCOMPort::UserFriendlyName ()
{
  return tr("COM-port-based devices");
}


QString  sCOMPort::About ()
{
  return tr(
      "COM-port-based devices.\n\n"
      "Copyright (C) 2010-2013, Dmitry K. Nelson, St.Petersburg, Russia.\n"
      "                         D.Nelson@mail.ioffe.ru\n"
      "Copyright (C) 2010-2013, Viktor E. Bursian, St.Petersburg, Russia.\n"
      "                         Viktor.Bursian@mail.ioffe.ru"
           );
}


sCOMPort::sCOMPort ()
{
  qRegisterMetaType<RA::psSerialSequencer>("psSerialSequencer");
}

//------------------------------------------------------------------------------
} //namespace RA
