////////////////////////////////////////////////////////////////////////////////
/*! @file COMPort.h   COM-port-based devices.
- Part of COMPort - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010-2013, Viktor E. Bursian, St.Petersburg, Russia.
                          Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef COMPort_H
#define COMPort_H
#include "RAPlugins.h"
namespace RA {
//------------------------------------------------------------------------------

#if defined(COMPort_PLUGIN_BUILD)
    #define COMPort_EXPORT Q_DECL_EXPORT
#elif defined(COMPort_PLUGIN_USE)
    #define COMPort_EXPORT Q_DECL_IMPORT
#else
    #define COMPort_EXPORT
#endif

//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sCOMPort)

//------------------------------------------------------------------------------

class sCOMPort : public QObject ,public sInstrumentalPackage
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "BursianSoft.RA.sInstrumentalPackage")
    Q_INTERFACES(RA::sInstrumentalPackage)
    ADAM(sCOMPort)

  public:
    virtual sVersion          Version ();
    virtual sVersion          CoreVersionUsed ();
    virtual sVersion          CoreVersionMin ();
    virtual QString           UserFriendlyName ();
    virtual QString           About ();
                              sCOMPort ();
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
