////////////////////////////////////////////////////////////////////////////////
/*! @file Arithmetics.h   Arithmetics on functions.
- Part of CommonMath - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  RANet - Research Assistant Net Library.
- Copyright(C) 2015, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef Arithmetics_H
#define Arithmetics_H
#include "CommonMath.h"
#include "BasicMath.h"
namespace RA {
//------------------------------------------------------------------------------

CommonMath_EXPORT extern psMathValue  UnaryMinusDataFunction
                                      (pcsMathValue  arg1);

CommonMath_EXPORT extern psMathValue  DataFunctionPlusFunction
                                      (pcsMathValue  arg1 ,pcsMathValue  arg2);

CommonMath_EXPORT extern psMathValue  DataFunctionMinusFunction
                                      (pcsMathValue  arg1 ,pcsMathValue  arg2);

CommonMath_EXPORT extern psMathValue  DataFunctionMultFunction
                                      (pcsMathValue  arg1 ,pcsMathValue  arg2);

CommonMath_EXPORT extern psMathValue  DataFunctionDivFunction
                                      (pcsMathValue  arg1 ,pcsMathValue  arg2);



CommonMath_EXPORT extern psMathValue  DataFunctionPlusPhysValue
                                      (pcsMathValue  arg1 ,pcsMathValue  arg2);

CommonMath_EXPORT extern psMathValue  DataFunctionMinusPhysValue
                                      (pcsMathValue  arg1 ,pcsMathValue  arg2);

CommonMath_EXPORT extern psMathValue  DataFunctionMultPhysValue
                                      (pcsMathValue  arg1 ,pcsMathValue  arg2);

CommonMath_EXPORT extern psMathValue  DataFunctionDivPhysValue
                                      (pcsMathValue  arg1 ,pcsMathValue  arg2);



CommonMath_EXPORT extern psMathValue  PhysValuePlusDataFunction
                                      (pcsMathValue  arg1 ,pcsMathValue  arg2);

CommonMath_EXPORT extern psMathValue  PhysValueMinusDataFunction
                                      (pcsMathValue  arg1 ,pcsMathValue  arg2);

CommonMath_EXPORT extern psMathValue  PhysValueMultDataFunction
                                      (pcsMathValue  arg1 ,pcsMathValue  arg2);

CommonMath_EXPORT extern psMathValue  PhysValueDivDataFunction
                                      (pcsMathValue  arg1 ,pcsMathValue  arg2);

//------------------------------------------------------------------------------
} //namespace RA
#endif
