////////////////////////////////////////////////////////////////////////////////
/*! @file CommonMath.h   Common mathematical things.
- Part of CommonMath - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  RANet - Research Assistant Net Library.
- Copyright(C) 2015, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef CommonMath_H
#define CommonMath_H
#include "RAPlugins.h"
namespace RA {
//------------------------------------------------------------------------------

#if defined(CommonMath_PLUGIN_BUILD)
    #define CommonMath_EXPORT Q_DECL_EXPORT
#elif defined(CommonMath_PLUGIN_USE)
    #define CommonMath_EXPORT Q_DECL_IMPORT
#else
    #define CommonMath_EXPORT
#endif

//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sCommonMath)

//------------------------------------------------------------------------------

class sCommonMath : public QObject ,public sInstrumentalPackage
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "BursianSoft.RA.sInstrumentalPackage")
    Q_INTERFACES(RA::sInstrumentalPackage)
    ADAM(sCommonMath)

  public:
    virtual sVersion          Version ();
    virtual sVersion          CoreVersionUsed ();
    virtual sVersion          CoreVersionMin ();
    virtual QString           UserFriendlyName ();
    virtual QString           About ();
                              sCommonMath ();
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
