////////////////////////////////////////////////////////////////////////////////
/*! @file DemoDevices.h   Пакет фиктивных устройств для демонстрации.
- Part of DemoDevices - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef DemoDevices_H
#define DemoDevices_H
#include "RAPlugins.h"
namespace RA {
//------------------------------------------------------------------------------

#if defined(DemoDevices_PLUGIN_BUILD)
    #define DemoDevices_EXPORT Q_DECL_EXPORT
#elif defined(DemoDevices_PLUGIN_USE)
    #define DemoDevices_EXPORT Q_DECL_IMPORT
#else
    #define DemoDevices_EXPORT
#endif

//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sDemoDevices)

//------------------------------------------------------------------------------

class sDemoDevices : public QObject ,public sInstrumentalPackage
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "BursianSoft.RA.sInstrumentalPackage")
    Q_INTERFACES(RA::sInstrumentalPackage)
    ADAM(sDemoDevices)

  public:
    virtual sVersion          Version ();
    virtual sVersion          CoreVersionUsed ();
    virtual sVersion          CoreVersionMin ();
    virtual QString           UserFriendlyName ();
    virtual QString           About ();
    virtual bool              HasDefaults ()
                                { return true; }
    virtual void              InstallDefaults (sPtr<sFolderNode>  DeviceList);
                              sDemoDevices ();
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
