////////////////////////////////////////////////////////////////////////////////
/*! @file DummyCCDDriver.h   Имитатор драйвера ПЗС-линейки.
- Part of DemoDevices - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface Library.
- Uses  Qt v.5.0.2  - http://qt-project.org/
- Uses  RANet - Research Assistant Net Library.
- Copyright(C) 2017, Dmitrii Nelson, St.Petersburg, Russia.
                          d.nelson@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef DummyCCDDriver_H
#define DummyCCDDriver_H
#include "DemoDevices.h"
#include "CCDDriver.h"
namespace RA {

//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sDummyCCDDriver)

//----------------------------------------------------------- sDummyCCDDriver ---
/*! Имитатор драйвера ПЗС-линейки.

*/

class DemoDevices_EXPORT  sDummyCCDDriver : public sCCDDriver
{
  Q_OBJECT
  DRIVER(sDummyCCDDriver)

  public:
    virtual                  ~sDummyCCDDriver ();

  protected slots: //reimplementing inherited
    virtual void              ConnectUSBDevice ();
    virtual void              GetCCD_Data ();
    virtual void              CalculateWavelengths ();
    virtual void              StartCCD ();
    virtual void              StopCCD ();
    virtual void              SetCCD_Parameters (sCCDDriver::sParameters Params);

  private: //fields
    ushort                    Amplitude;
};

//------------------------------------------------------------------------------
} //namespace RA

#endif
