////////////////////////////////////////////////////////////////////////////////
/*! @file DummyTunableCCDDriver.h Имитатор драйвера ПЗС-линейки с перестройкой длины волны.
- Part of DemoDevices - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface Library.
- Uses  Qt v.5.0.2  - http://qt-project.org/
- Uses  RANet - Research Assistant Net Library.
- Copyright(C) 2017, Dmitrii Nelson, St.Petersburg, Russia.
                          d.nelson@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef DummyTunableCCDDriver_H
#define DummyTunableCCDDriver_H
#include "DemoDevices.h"
#include "CCDDriver.h"
#include "TunableCCDDriver.h"
namespace RA {

//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sDummyTunableCCDDriver)

//--------------------------------------------------- sDummyTunableCCDDriver ---
/*! Имитатор драйвера ПЗС-линейки с перестройкой длины волны.

*/

class DemoDevices_EXPORT  sDummyTunableCCDDriver : public sTunableCCDDriver
{
  Q_OBJECT
  DRIVER(sDummyTunableCCDDriver)

  public:
    virtual                  ~sDummyTunableCCDDriver ();

  protected: //reimplementing inherited
    virtual void              PostConstructor ();

  protected slots: //reimplementing inherited
    virtual void              ConnectUSBDevice ();
    virtual void              GetCCD_Data ();
    virtual void              CalculateWavelengths ();
    virtual void              StartCCD ();
    virtual void              StopCCD ();
    virtual void              SetCCD_Parameters (sCCDDriver::sParameters Params);

  private: //fields
    ushort                    Amplitude;
    sPhysValue                WL_0;
    sPhysValue                WL_k;
};

//------------------------------------------------------------------------------
} //namespace RA

#endif
