////////////////////////////////////////////////////////////////////////////////
/*! @file RAlgebraDemo.cpp Demo console showing simple math over physvalues.
- Part of DemoDevices - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.8  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2014, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#include "RAlgebraDemo.h"
#include "attr.h"
#include <QVBoxLayout>
namespace RA {
//------------------------------------------------------------------------------

DEFINE_CLASS_TAG(sRAlgebraDemo)

//------------------------------------------------------------ sRAlgebraDemo ---
/*! @class sRAlgebraDemo

Demonstrates:
- for users:
    - simple math over physvalues;
- for programmers:
    - using sPhysValueField and sPhysRangeField,
    - using layouts,
    - changing styles.

*/


void  sRAlgebraDemo::Preconfigure (sNodePtr  DeviceCfg)
{
  sConsole::Preconfigure(DeviceCfg);
}


sRAlgebraDemo::sRAlgebraDemo (sString    DeviceId
                           ,sNodePtr   DeviceCfg
                           ,sNodePtr   WidgetCfg
                           ,QWidget *  parent   )
    :sConsole(DeviceId,DeviceCfg,WidgetCfg,parent)
{
}


void  sRAlgebraDemo::AppearanceMakeUp ()
{
  sConsole::AppearanceMakeUp();

  setLayout(new QVBoxLayout);
  
  RAlgebraFrame = new sRAlgebraFrame(this);
  layout()->addWidget(RAlgebraFrame);
  RAlgebraFrame->Translate();
}

//------------------------------------------------------------------------------
} //namespace RA


