////////////////////////////////////////////////////////////////////////////////
/*! @file RAlgebraDemo.h   Demo console showing simple math over physvalues.
- Part of DemoDevices - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.8  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2014, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef RAlgebraDemo_H
#define RAlgebraDemo_H
#include "DemoDevices.h"
#include "Console.h"
#include "RAlgebraFrame.h"
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sRAlgebraDemo)

//------------------------------------------------------------ sRAlgebraDemo ---
/*! Demo console showing simple math over physvalues.
*/
class  DemoDevices_EXPORT  sRAlgebraDemo : public sConsole
{
  Q_OBJECT
  CONSOLE(sRAlgebraDemo)

  protected: //reimplementing inherited
    virtual void              AppearanceMakeUp ();
    virtual void              Retranslate ()
                                {
                                  sConsole::Retranslate();
                                  RAlgebraFrame->Translate();
                                }

  protected: //fields
    psRAlgebraFrame           RAlgebraFrame;
};


//------------------------------------------------------------------------------
} //namespace RA
#endif
