////////////////////////////////////////////////////////////////////////////////
/*! @file RAlgebraFrame.h   Widget, showing a simple math over physvalues.
- Part of DemoDevices - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.8  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2014, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef RAlgebraFrame_H
#define RAlgebraFrame_H
#include "DemoDevices.h"
#include "PhysValueField.h"
#include "PhysRangeField.h"
#include <QFrame>
#include <QTextEdit>
#include <QCheckBox>
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sRAlgebraFrame)

//----------------------------------------------------------- sRAlgebraFrame ---
/*! Widget, showing a simple math over physvalues.
*/
class  DemoDevices_EXPORT  sRAlgebraFrame : public QFrame
{
  Q_OBJECT
  public:
    explicit                  sRAlgebraFrame (QWidget *  parent = 0);
    void                      Translate ();

  public: //fields
    psPhysValueField          R1;
    psPhysValueField          R2;
    psPhysValueField          R3;
    psPhysValueField          R4;
    QCheckBox *               chkbxLimits12;
    psPhysRangeField          Limits12;
    QCheckBox *               chkbxLimits3;
    psPhysRangeField          Limits3;
    QCheckBox *               chkbxLimits4;
    psPhysRangeField          Limits4;
    QTextEdit *               Expr;

  private slots:
    void                      UpdateExpr ();
    void                      ApplyLimits12 ();
    void                      ApplyLimits3 ();
    void                      ApplyLimits4 ();
    
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
