////////////////////////////////////////////////////////////////////////////////
/*! @file DemoMicrosin.cpp Demo package showing work with MSDN boards.
- Part of DemoMicrosin - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  Qt v.5 - http://qt-project.org/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2016, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#include "DemoMicrosin.h"
#include "attr.h"
namespace RA {
//------------------------------------------------------------------------------

DEFINE_CLASS_TAG(sDemoMicrosin)

//------------------------------------------------------------------------------

sVersion  sDemoMicrosin::Version ()
{
  return sVersion(RAP_VERS_MAJOR
                 ,RAP_VERS_MINOR
                 ,ZAKAVYCH(RAP_VERS_PATCH)
                 ,__DATE__
                 );
}


sVersion  sDemoMicrosin::CoreVersionUsed ()
{
  return sVersion( RA_VERS_MAJOR , RA_VERS_MINOR );
}


sVersion  sDemoMicrosin::CoreVersionMin ()
{
  return sVersion( RA_VERS_MAJOR , RA_VERS_MINOR );
}


QString  sDemoMicrosin::UserFriendlyName ()
{
  return trUtf8("Demo devices");
}


QString  sDemoMicrosin::About ()
{
  return trUtf8(
      "The package includes some devices, based on MSDN boards.\n\n"
      "Copyright (C) 2016, Viktor E. Bursian, St.Petersburg, Russia.\n"
      "                    Viktor.Bursian@mail.ioffe.ru"
                );
}


//void  sDemoMicrosin::InstallDefaults (sPtr<sFolderNode>  DeviceList)
//{
//  try{
//    sPtr<sFolderNode>              DeviceCfg;

//    /*________________________________________template for device
//    DeviceList |= "__DEVICE_ID__";
//    DeviceCfg = DeviceList >> "__DEVICE_ID__";
//    DeviceCfg << attr("Class","__DRIVER_CLASS_NAME__");
//    __DRIVER_CLASS_NAME__::Preconfigure(DeviceCfg);
//    //if there are links:
//    DeviceCfg >> "Links" >> "__LINK_NAME__"
//        << attr("DeviceId","__DEVICE_ID__FOR_THE_LINK__");
//    //if you wanna change some of the default settings:
//    DeviceCfg >> "Settings" << attr("",);
//    DeviceCfg >> "Settings" << attr("",);
//    */
//  }catch(...){
//    ;
//  };
//}


sDemoMicrosin::sDemoMicrosin ()
{
}

//------------------------------------------------------------------------------
} //namespace RA
