////////////////////////////////////////////////////////////////////////////////
/*! @file DemoMicrosin.h   Demo package showing work with MSDN boards.
- Part of DemoMicrosin - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  Qt v.5 - http://qt-project.org/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2016, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef DemoMicrosin_H
#define DemoMicrosin_H
#include "RAPlugins.h"
namespace RA {
//------------------------------------------------------------------------------

#if defined(DemoMicrosin_PLUGIN_BUILD)
    #define DemoMicrosin_EXPORT Q_DECL_EXPORT
#elif defined(DemoMicrosin_PLUGIN_USE)
    #define DemoMicrosin_EXPORT Q_DECL_IMPORT
#else
    #define DemoMicrosin_EXPORT
#endif

//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sDemoMicrosin)

//------------------------------------------------------------------------------

class sDemoMicrosin : public QObject ,public sInstrumentalPackage
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "BursianSoft.RA.sInstrumentalPackage")
    Q_INTERFACES(RA::sInstrumentalPackage)
    ADAM(sDemoMicrosin)

  public:
    virtual sVersion          Version ();
    virtual sVersion          CoreVersionUsed ();
    virtual sVersion          CoreVersionMin ();
    virtual QString           UserFriendlyName ();
    virtual QString           About ();
//    virtual bool              HasDefaults ()
//                                { return true; }
//    virtual void              InstallDefaults (sPtr<sFolderNode>  DeviceList);
                              sDemoMicrosin ();
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
