////////////////////////////////////////////////////////////////////////////////
/*! @file MSDN2040.c  Firmware for Microsin Spare device for R&D.
- Part of the MSDN firmware.
- Part of the Research Assistant project.
- Uses  LUFA library written by
   - Copyright(C) 2012, Dean Camera, dean [at] fourwalledcubicle [dot] com,
                                     www.lufa-lib.org.

- Copyright(C) 2014, Dmitry K. Nelson, St.Petersburg, Russia.
                     D.Nelson@mail.ioffe.ru
- Copyright(C) 2016, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#include "Microsin_USB_IO.h"
#include "CommandParser.h"
#include <avr/wdt.h>
//#include <avr/power.h>
//#include <util/delay.h>
#include <avr/iousb162.h>
//#include <avr/interrupt.h>
//#include <avr/io.h>
//#include <stdio.h>
//#include <string.h>
//! @todo{MSDN} Неясная роль inttypes здесь
#include <inttypes.h>
//! @todo{MSDN} Неясная роль math
#include <math.h>


int32_t                       Z = 0;
int8_t                        L = 1;


int8_t  ExecuteCommand0 (const char  command)
{
  static uint32_t  U = 0xFFFFFFFF;
  switch( command ){
	case 'L':
        if( ! L ){
          MicrosinLEDTurnOn();
          L = 1;
        }else{
          return 2;
        }
        break;
	case 'l':
        if( L ){
          MicrosinLEDTurnOff();
          L = 0;
        }else{
          return 2;
        }
        break;
	case '0':
	    LeadingZeroes = 1 - LeadingZeroes;
        break;
	case '~':
        SendNumberToUSB(-1);
        Send_EOL_ToUSB();
        break;
	case '-':
        SendCharToUSB('Z');
        SendNumberToUSB(--Z);
        Send_EOL_ToUSB();
        break;
	case '+':
        SendCharToUSB('Z');
        SendNumberToUSB(++Z);
        Send_EOL_ToUSB();
        break;
	case '_':
        SendCharToUSB('U');
        SendNumberToUSB(--U);
        Send_EOL_ToUSB();
        break;
	case '^':
        SendCharToUSB('U');
        SendNumberToUSB(++U);
        Send_EOL_ToUSB();
        break;
	default:
        return 1;
  }
  return 0;
}


int8_t  ExecuteCommand2 (const char     command
                        ,const uint8_t  argument)
{
  return 1;
}


int8_t  ExecuteCommand4 (const char      command
                        ,const uint16_t  argument)
{
  return 1;
}


int8_t  ExecuteCommand8 (const char      command
                        ,const uint32_t  argument)
{
  switch( command ){
	case 'Z':
        Z = argument;
        SendCharToUSB('Z');
        SendNumberToUSB(Z);
        Send_EOL_ToUSB();
        break;
	default:
        return 1;
  }
  return 0;
}


void  SetupHardware (void)
{
  /* Disable watchdog if enabled by bootloader/fuses */
  MCUSR &= ~(1 << WDRF);
  wdt_disable();
}


void  BeforeLoop (void)
{
}


void  InLoop (void)
{
}
