////////////////////////////////////////////////////////////////////////////////
/*! @file DevelopmentTools.h   Пакет инструментов для разработчика.
- Part of DevelopmentTools - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2012-2013, Viktor E. Bursian, St.Petersburg, Russia.
                          Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef DevelopmentTools_H
#define DevelopmentTools_H
#include "RAPlugins.h"
namespace RA {
//------------------------------------------------------------------------------

#if defined(DevelopmentTools_PLUGIN_BUILD)
    #define DevelopmentTools_EXPORT Q_DECL_EXPORT
#elif defined(DevelopmentTools_PLUGIN_USE)
    #define DevelopmentTools_EXPORT Q_DECL_IMPORT
#else
    #define DevelopmentTools_EXPORT
#endif

//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sDevelopmentTools)

//------------------------------------------------------------------------------

class sDevelopmentTools : public QObject ,public sInstrumentalPackage
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "BursianSoft.RA.sInstrumentalPackage")
    Q_INTERFACES(RA::sInstrumentalPackage)
    ADAM(sDevelopmentTools)

  public:
    virtual sVersion          Version ();
    virtual sVersion          CoreVersionUsed ();
    virtual sVersion          CoreVersionMin ();
    virtual QString           UserFriendlyName ();
    virtual QString           About ();
    virtual bool              HasDefaults ()
                                { return true; }
    virtual void              InstallDefaults (sPtr<sFolderNode>  DeviceList);
                              sDevelopmentTools ();
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
