////////////////////////////////////////////////////////////////////////////////
/*! @file RadiofictivityTestboard.h   A testboard for sRadiofictivityGauge
                                      or its inheritor.
- Part of DevelopmentTools - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface Library.
- Uses  Qt v.5.0.2  - http://qt-project.org/
- Uses  RANet - Research Assistant Net Library.
- Copyright(C) 2012-2014, Viktor E. Bursian, St.Petersburg, Russia.
                          Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef RadiofictivityTestboard_H
#define RadiofictivityTestboard_H
#include "DevelopmentTools.h"
#include "GaugeTestboard.h"
#include "RadiofictivityGauge.h"
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sRadiofictivityTestboard)

//------------------------------------------------- sRadiofictivityTestboard ---
/*! A testboard for sRadiofictivityGauge.

Сделан для тестирования и демонстрации взаимодействия консоли с глючным
драйвером и его секретными свойствами.

Можно использовать как пример, в частности, того как расширять функциональность 
и внешний вид консоли, при этом сужая класс подчинённого драйвера.

*/
class  DevelopmentTools_EXPORT  sRadiofictivityTestboard : 
                                                       public sGaugeTestboard
{
  Q_OBJECT
  CONSOLE(sRadiofictivityTestboard)
  public:
    virtual                   ~sRadiofictivityTestboard ();

  protected: //evolution of the inherited state machine
    psState                   State_C_Pausing;

  signals: //for internal needs
    void                      CoolingClockAlarm ();

  protected: //reimplementing inherited
    virtual void              AppearanceMakeUp ();

  protected slots: //reimplementing inherited
    virtual void              OnEnterToOperatingState ();
    virtual void              OnExitFromOperatingState ();
    virtual void              OnEnterToCoolingState ();
    virtual void              LinkToGauge ();

  protected slots:
    void                      RunCoolingClock ();

  protected slots:
    virtual void              ReportGaugeInfo (QString);
    virtual void              SayMeow ();
    virtual void              Cheat ();
  
  protected: //fields
    sRadiofictivityGauge
                   ::sLink    RadiofictivityGauge;
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
