////////////////////////////////////////////////////////////////////////////////
/*! @file SerialPortFinder.h   Console showing available ports.
- Part of DevelopmentTools - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface Library.
- Uses  Qt v.5  - http://qt-project.org/
- Uses  RANet - Research Assistant Net Library.
- Copyright(C) 2017, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef SerialPortFinder_H
#define SerialPortFinder_H
#include "DevelopmentTools.h"
#include "Console.h"
#include "TeleCom.h"
#include <QCheckBox>
#include <QLabel>
#include <QTextEdit>
#include <QTimer>
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sSerialPortFinder)

//-------------------------------------------------------- sSerialPortFinder ---

class DevelopmentTools_EXPORT  sSerialPortFinder : public sConsole
{
  Q_OBJECT
  CONSOLE(sSerialPortFinder)
  public:
    virtual                   ~sSerialPortFinder ();

  protected:
    virtual void              AppearanceMakeUp ();

  protected slots: //reimplementing inherited
    virtual void              OnEnterToOperatingState ();
    virtual void              OnExitFromOperatingState ();

  private slots:
    void                      MustBeShown ();
    void                      ShowList ();

  private:
    QList<QString>            FormInfoStrList ();

  private: //fields
    bool                      ShowAnyway;
    QList<QString>            PrevInfoStrList;
    QCheckBox *               ShowChangesOnly;
    QLabel *                  Total;
    QTextEdit *               Screen;
    QTimer *                  RefreshClock;
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
