////////////////////////////////////////////////////////////////////////////////
/*! @file TelePipe.h   One end of a telecommunication pipe.
- Part of DevelopmentTools - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface Library.
- Uses  Qt v.5.0.2  - http://qt-project.org/
- Uses  RANet - Research Assistant Net Library.
- Copyright(C) 2013-2014, Viktor E. Bursian, St.Petersburg, Russia.
                          Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef TelePipe_H
#define TelePipe_H
#include "DevelopmentTools.h"
#include "TeleCom.h"
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_ABSTRACT_CLASS(sTelePipe)

//---------------------------------------------------------------- sTelePipe ---
/*! One end of a telecommunication pipe.
*/
class DevelopmentTools_EXPORT  sTelePipe : public sTeleCom
{
  Q_OBJECT
  DRIVER(sTelePipe)
  public:
    virtual                   ~sTelePipe ();

  signals: //for internal needs
    void                      MateLinked ();
    void                      MateError(QString = QString());

  signals: // a back-door for its Mate
    void                      PuttingTelex (sTelex);

  protected: //reimplementing inherited
    virtual void              PostConstructor ();

  protected slots: //reimplementing inherited
//    virtual void              OnEnterToOperatingState ();
//    virtual void              OnExitFromOperatingState ();
    virtual void              OnEnterToCoolingState ();

  protected slots:
    virtual void              PutTelex (sTelex);
    virtual void              ReportMateError (QString);

  protected: //fields
    sTelePipe::sLink          Mate;

  private slots:
    void                      LinkToMate ();

  private: //fields
    bool                      Mated;
    bool                      Submissive;
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
