////////////////////////////////////////////////////////////////////////////////
/*! @file FSDminispectro.h   FSD-10 minispectrometer devices.
- Part of FSDminispectro - a Research Assistant Plugin package.
- Uses  RAGUI - the Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
- Copyright(C) 2010-2018, Dmitry K. Nelson, St.Petersburg, Russia.
                          D.Nelson@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef FSDminispectro_H
#define FSDminispectro_H
#include "RAPlugins.h"
namespace RA {
//------------------------------------------------------------------------------

#if defined(FSDminispectro_PLUGIN_BUILD)
    #define FSDminispectro_EXPORT Q_DECL_EXPORT
#elif defined(FSDminispectro_PLUGIN_USE)
    #define FSDminispectro_EXPORT Q_DECL_IMPORT
#else
    #define FSDminispectro_EXPORT
#endif

//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sFSDminispectro)

//------------------------------------------------------------------------------

class sFSDminispectro : public QObject ,public sInstrumentalPackage
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "BursianSoft.RA.sInstrumentalPackage")
    Q_INTERFACES(RA::sInstrumentalPackage)
    ADAM(sFSDminispectro)

  public:
    virtual sVersion          Version ();
    virtual sVersion          CoreVersionUsed ();
    virtual sVersion          CoreVersionMin ();
    virtual QString           UserFriendlyName ();
    virtual QString           About ();
    virtual bool              HasDefaults ()
                                { return true; }
    virtual void              InstallDefaults (sPtr<sFolderNode>  DeviceList);
                              sFSDminispectro ();
};

//------------------------------------------------------------------------------
} //namespace RA
#endif 
