////////////////////////////////////////////////////////////////////////////////
/*! @file Feofilov.h   Feofilov's experimental setup.
- Part of Feofilov - a Research Assistant Plugin package.
- Uses  RAGUI - the Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef Feofilov_H
#define Feofilov_H
#include "RAPlugins.h"
namespace RA {
//------------------------------------------------------------------------------

#if defined(Feofilov_PLUGIN_BUILD)
    #define Feofilov_EXPORT Q_DECL_EXPORT
#elif defined(Feofilov_PLUGIN_USE)
    #define Feofilov_EXPORT Q_DECL_IMPORT
#else
    #define Feofilov_EXPORT
#endif

//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sFeofilov)

//------------------------------------------------------------------------------

class sFeofilov : public QObject ,public sInstrumentalPackage
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "BursianSoft.RA.sInstrumentalPackage")
    Q_INTERFACES(RA::sInstrumentalPackage)
    ADAM(sFeofilov)

  public:
    virtual sVersion          Version ();
    virtual sVersion          CoreVersionUsed ();
    virtual sVersion          CoreVersionMin ();
    virtual QString           UserFriendlyName ();
    virtual QString           About ();
    virtual bool              HasDefaults ()
                                { return true; }
    virtual void              InstallDefaults (sPtr<sFolderNode>  DeviceList);
                              sFeofilov ();
};

//------------------------------------------------------------------------------
} //namespace RA
#endif 
