////////////////////////////////////////////////////////////////////////////////
/*! @file Hamamatsu.h   Hamamatsu spectrometer devices.
- Part of Hamamatsu - a Research Assistant Plugin package.
- Uses  RAGUI - the Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
- Copyright(C) 2010-2014, Dmitry K. Nelson, St.Petersburg, Russia.
                          D.Nelson@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef Hamamatsu_H
#define Hamamatsu_H
#include "RAPlugins.h"
namespace RA {
//------------------------------------------------------------------------------

#if defined(Hamamatsu_PLUGIN_BUILD)
    #define Hamamatsu_EXPORT Q_DECL_EXPORT
#elif defined(Hamamatsu_PLUGIN_USE)
    #define Hamamatsu_EXPORT Q_DECL_IMPORT
#else
    #define Hamamatsu_EXPORT
#endif

//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sHamamatsu)

//------------------------------------------------------------------------------

class sHamamatsu : public QObject ,public sInstrumentalPackage
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "BursianSoft.RA.sInstrumentalPackage")
    Q_INTERFACES(RA::sInstrumentalPackage)
    ADAM(sHamamatsu)

  public:
    virtual sVersion          Version ();
    virtual sVersion          CoreVersionUsed ();
    virtual sVersion          CoreVersionMin ();
    virtual QString           UserFriendlyName ();
    virtual QString           About ();
    virtual bool              HasDefaults ()
                                { return true; }
    virtual void              InstallDefaults (sPtr<sFolderNode>  DeviceList);
                              sHamamatsu ();
};

//------------------------------------------------------------------------------
} //namespace RA
#endif 
