////////////////////////////////////////////////////////////////////////////////
/*! @file MagnetizationCalc.h   Calculator for magnetization and its effects.
- Part of MagnetizationCalc - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  RANet - Research Assistant Net Library.
- Copyright(C) 2017, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef MagnetizationCalc_H
#define MagnetizationCalc_H
#include "RAPlugins.h"
namespace RA {
//------------------------------------------------------------------------------

#if defined(MagnetizationCalc_PLUGIN_BUILD)
    #define MagnetizationCalc_EXPORT Q_DECL_EXPORT
#elif defined(MagnetizationCalc_PLUGIN_USE)
    #define MagnetizationCalc_EXPORT Q_DECL_IMPORT
#else
    #define MagnetizationCalc_EXPORT
#endif

//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sMagnetizationCalc)

//------------------------------------------------------------------------------

class sMagnetizationCalc : public QObject ,public sInstrumentalPackage
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "BursianSoft.RA.sInstrumentalPackage")
    Q_INTERFACES(RA::sInstrumentalPackage)
    ADAM(sMagnetizationCalc)

  public:
    virtual sVersion          Version ();
    virtual sVersion          CoreVersionUsed ();
    virtual sVersion          CoreVersionMin ();
    virtual QString           UserFriendlyName ();
    virtual QString           About ();
    virtual bool              HasDefaults ()
                                { return true; }
    virtual void              InstallDefaults (sPtr<sFolderNode>  DeviceList);
                              sMagnetizationCalc ();
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
