////////////////////////////////////////////////////////////////////////////////
/*! @file NIDAQmxDrivers.h   Пакет драйверов и консолей для работы
                             с платой NIDAQ.
- Part of NIDAQmxDrivers - a Research Assistant Plugin package.
- Uses  RAGUI - the Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef NIDAQmxDrivers_H
#define NIDAQmxDrivers_H
#include "RAPlugins.h"
namespace RA {
//------------------------------------------------------------------------------

#if defined(NIDAQmxDrivers_PLUGIN_BUILD)
    #define NIDAQmxDrivers_EXPORT Q_DECL_EXPORT
#elif defined(NIDAQmxDrivers_PLUGIN_USE)
    #define NIDAQmxDrivers_EXPORT Q_DECL_IMPORT
#else
    #define NIDAQmxDrivers_EXPORT
#endif

//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sNIDAQmxDrivers)

//------------------------------------------------------------------------------

class sNIDAQmxDrivers : public QObject ,public sInstrumentalPackage
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "BursianSoft.RA.sInstrumentalPackage")
    Q_INTERFACES(RA::sInstrumentalPackage)
    ADAM(sNIDAQmxDrivers)

  public:
    virtual sVersion          Version ();
    virtual sVersion          CoreVersionUsed ();
    virtual sVersion          CoreVersionMin ();
    virtual QString           UserFriendlyName ();
    virtual QString           About ();
    virtual bool              HasDefaults ()
                                { return true; }
    virtual void              InstallDefaults (sPtr<sFolderNode>  DeviceList);
                              sNIDAQmxDrivers  ();
};

//------------------------------------------------------------------------------
} //namespace RA
#endif //NIDAQmxDrivers_H
