////////////////////////////////////////////////////////////////////////////////
/*! @file StartStopNIDAQ.h  Измеритель кинетики NIDAQ методом Старт-Стоп.
- Part of NIDAQmxDrivers - a Research Assistant Plugin package.
- Uses  RAGUI - the Research Assistant Graphical User Interface.
- Uses  QtGui v.5.0  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010-2014, Dmitry K. Nelson, St.Petersburg, Russia.
                          D.Nelson@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef StartStopNIDAQ_H
#define StartStopNIDAQ_H
#include "KineticsNIDAQ.h"
#include "NIDAQCounter.h"
#include <QComboBox>
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sStartStopNIDAQ)

//------------------------------------------------------------------ sStartStopNIDAQ ---
/*! Консоль накопителя данных кинетики методом Старт-Стоп.
*/
class NIDAQmxDrivers_EXPORT  sStartStopNIDAQ : public sKineticsNIDAQ
{
  Q_OBJECT
  CONSOLE(sStartStopNIDAQ)
  public:
    virtual                   ~sStartStopNIDAQ ();
    virtual void              RestoreState ();
    virtual void              StoreState ();

  protected: //reimplementing inherited
    virtual void              AppearanceMakeUp ();
    virtual void              Retranslate ()
                                {
                                  sKineticsNIDAQ::Retranslate();
                                  Translate();
                                }

  protected slots: //reimplementing inherited
    virtual void              StartScanning ();

  protected slots:
    void                      OnModeChanged(int NewIndex);
    void                      OnNumOfCountsChanged(int NewIndex);

  private:
    void                      Translate ();

  private: //fields
    QLabel *                  LblMode;
    QComboBox *               FldMode;
    QLabel *                  LblNumOfCounts;
    QComboBox *               FldNumOfCounts;
    int                       NumOfCNo;
    int                       TimeBases[2];
    int                       Mode;
    int                       NumOfCounts[3];
};

//------------------------------------------------------------------------------
} //namespace RA
#endif //StartStopNIDAQ_H
