////////////////////////////////////////////////////////////////////////////////
/*! @file FixedWLDriver.h Driver for the spectrometer with fixed wavelength position.
- Part of Nelson - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.5.0  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010-2013, Viktor E. Bursian, St.Petersburg, Russia.
                          Viktor.Bursian@mail.ioffe.ru
- Copyright(C) 2020, Dmitry K. Nelson, St.Petersburg, Russia.
                     D.Nelson@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef FixedWLDriver_H
#define FixedWLDriver_H
#include "Nelson.h"
#include "Effectors.h"
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sFixedWLDriver)

//------------------------------------------------------------- FixedWLDriver ---
/*!

*/
class  Nelson_EXPORT  sFixedWLDriver : public sEffector
{
  Q_OBJECT
  DRIVER(sFixedWLDriver)
  
  public:
    virtual                   ~sFixedWLDriver ();

  protected: //evolution of the inherited state machine
    psState                   State_O_M_Pausing;

  protected: //reimplementing inherited
    virtual void              PostConstructor ();

  signals: //for internal needs

  protected slots: //reimplementing inherited

  protected slots:
    void                      SayPosition();

  protected:

  protected: //fields
    sPhysValue                WavelengthPosition;

  private slots:

  private:
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
