////////////////////////////////////////////////////////////////////////////////
/*! @file MDRSpectroScanner.h   Спектрометр МДР непрерывного сканирования.
- Снабжен драйвером шагового двигателя, сообщающим свое положение.
- Имеет индикацию установленной решетки
- Part of Nelson - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.5.0  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010-2013, Viktor E. Bursian, St.Petersburg, Russia.
                          Viktor.Bursian@mail.ioffe.ru
- Copyright(C) 2014, Dmitry K. Nelson, St.Petersburg, Russia.
                     D.Nelson@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef MDRSpectroScanner_H
#define MDRSpectroScanner_H
#include "Nelson.h"
#include "DNSpectroScanner.h"
#include "StepperMDR.h"
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sMDRSpectroScanner)

//--------------------------------------------------- sMDRSpectroScanner --
/*! Сканер МДР с шаговым двигателем.
*/
class Nelson_EXPORT  sMDRSpectroScanner : public sDNSpectroScanner
{
  Q_OBJECT
  CONSOLE(sMDRSpectroScanner)
  public:

  signals: //for internal needs
    void                      GratingNoValue (char);

  protected: //reimplementing inherited
    virtual void              AppearanceMakeUp ();
    virtual void              Retranslate ()
                                {
                                  sDNSpectroScanner::Retranslate();
                                  Translate();
                                }

  protected slots: //reimplementing inherited
    virtual void              EarlySetAttributes ();
    virtual void              LinkToStepper ();

  protected slots:
    virtual void              ShowGratingNo(char GrNo);

  protected: //fields

  private:
    void                      Translate ();

      private: //fields
    QLabel *                  LblGrTitle;
    QLabel *                  LblGrIndicator;
    int                       WLCoefStore;
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
