////////////////////////////////////////////////////////////////////////////////
/*! @file ManualWLDriver.h Driver for the spectrometer with manual wavelength setting.
- Part of Nelson - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.5.0  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010-2013, Viktor E. Bursian, St.Petersburg, Russia.
                          Viktor.Bursian@mail.ioffe.ru
- Copyright(C) 2020, Dmitry K. Nelson, St.Petersburg, Russia.
                     D.Nelson@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef ManualWLDriver_H
#define ManualWLDriver_H
#include "Nelson.h"
#include "Effectors.h"
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sManualWLDriver)

//------------------------------------------------------------- ManualWLDriver ---
/*!

*/
class  Nelson_EXPORT  sManualWLDriver : public sEffector
{
  Q_OBJECT
  DRIVER(sManualWLDriver)
  
  public:
    virtual                   ~sManualWLDriver ();

  protected: //evolution of the inherited state machine
    psState                   State_W_Initiating;
    psState                   State_W_SendingWL;
    psState                   State_O_Initiating;
    psState                   State_O_M_Pausing;
    psState                   State_O_SettingTo;

  protected: //reimplementing inherited
    virtual void              PostConstructor ();

  signals: //for internal needs
    void                      Initiated ();

  protected slots: //reimplementing inherited

  protected slots:
    void                      AskInitialPosition();
    void                      SetDestination (sPhysValue);
    void                      SayPosition();
    void                      SayDone();

  protected:

  protected: //fields
    sPhysValue                InitValuePar;

  private slots:
    void                      SendingReady();

  private:
    sPhysValue                CurrentPosition;
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
