////////////////////////////////////////////////////////////////////////////////
/*! @file Nelson.h   Drivers for installations in 429 room.
- Part of Nelson - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
- Copyright(C) 2012, Dmitrii K. Nelson, St.Petersburg, Russia.
                     d.nelson@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef Nelson_H
#define Nelson_H
#include "RAPlugins.h"
namespace RA {
//------------------------------------------------------------------------------

#if defined(Nelson_PLUGIN_BUILD)
    #define Nelson_EXPORT Q_DECL_EXPORT
#elif defined(Nelson_PLUGIN_USE)
    #define Nelson_EXPORT Q_DECL_IMPORT
#else
    #define Nelson_EXPORT
#endif

//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sNelson)

//------------------------------------------------------------------------------

class sNelson : public QObject ,public sInstrumentalPackage
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "BursianSoft.RA.sInstrumentalPackage")
    Q_INTERFACES(RA::sInstrumentalPackage)
    ADAM(sNelson)

  public:
    virtual sVersion          Version ();
    virtual sVersion          CoreVersionUsed ();
    virtual sVersion          CoreVersionMin ();
    virtual QString           UserFriendlyName ();
    virtual QString           About ();
    virtual bool              HasDefaults ()
                                { return true; }
    virtual void              InstallDefaults (sPtr<sFolderNode>  DeviceList);
                              sNelson ();
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
