////////////////////////////////////////////////////////////////////////////////
/*! @file APRI_TController.cpp Контроллер термостата с приборами APRI.
- Part of BursiPan - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2012, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#include "APRI_TController.h"
#include "attr.h"
namespace RA {
//------------------------------------------------------------------------------

DEFINE_CLASS_TAG(sAPRI_TController)

//-------------------------------------------------------- sAPRI_TController ---

void  sAPRI_TController::Preconfigure (sNodePtr  DeviceCfg)
{
  sPtr<sFolderNode>              DeviceSettings;
  sPtr<sFolderNode>              DeviceLinks;
  DeviceCfg |= "Links";
  DeviceLinks = DeviceCfg >> "Links";
  if( DeviceLinks.IsCorrect() ){
    DeviceLinks |= "Communicator";
    DeviceLinks >> "Communicator" |= attr("Class","sTelecom");
  };
  DeviceCfg |= "Settings";
  DeviceSettings = DeviceCfg >> "Settings";
  if( DeviceSettings.IsCorrect() ){
//    DeviceSettings |= attr("Period",sPhysValue(0.1,"s"));
  };
  sTController::Preconfigure(DeviceCfg);
}


sAPRI_TController::~sAPRI_TController()
{
  Communicator.SetToNULL();
  if( DeviceSettings.IsCorrect() ){
//    DeviceSettings << attr("Period",ThePeriod);
  };
}


sAPRI_TController::sAPRI_TController (sString   DevicetId
                                     ,sNodePtr  DeviceCfg)
    :sTController(DevicetId,DeviceCfg)
    ,Communicator(this)
{
  Preconfigure(DeviceConfig);
  if( DeviceSettings.IsCorrect() ){
//    sPtr<sPhysValueNode>        PV;
//    PV = DeviceSettings >> "Period";
//    if( PV.IsCorrect() )  ThePeriod=(sPhysValue)(*PV);
  };
  sPtr<sTextNode>             CommunicatorId(DeviceLinks >> "Communicator"
                                                              >> "DeviceId");
  if( CommunicatorId.IsCorrect() ){
    Communicator.SetTo(sString(*CommunicatorId));
  };
  if( Communicator.IsCorrect() ){
    //! @todo{Instruments} review!!!
//    connect(Communicator.operator ->() ,SIGNAL(GotMessage (QByteArray))
//           ,this                       ,SLOT(on_MessageReceived(QByteArray)));
//    TimeoutTimer = new QTimer(this);
//    TimeoutTimer->setInterval(300);
//    TimeoutTimer->setSingleShot(true);
//    connect(TimeoutTimer, SIGNAL(timeout()), this, SLOT(SendErrorMessage()));
//    connect(this ,SIGNAL(ErrorMessage (QByteArray))
//           ,this ,SLOT(on_MessageReceived(QByteArray)));
  }else{
    //! @todo{Instruments} review!!!
    //!!!!!!!!!!!!!!!!!!!!! вот на этом она и сваливалась
    //!!!!!!!!!!!!!!!!!!!!! точнее на отсутствии проверок в дальнейшем
    //
    //вообще, надо будет обратить внимание на нелогично разную логику:
    // для sRigakuScan сигналы подчинённых устройств коннектятся не в конструкторе,
    // как здесь, а в  sRigakuScan.Connect()
  };
}

sPhysValue  sAPRI_TController::Period ()
{
  return ThePeriod;
}


void  sAPRI_TController::SetPeriod (sPhysValue  period)
{
  ThePeriod=period;
}


void  sAPRI_TController::ChangeHeaterPower (real  power)
{
}


void  sAPRI_TController::ChangeSecondHeaterPower (real  power)
{
}

//------------------------------------------------------------------------------
} //namespace RA




