////////////////////////////////////////////////////////////////////////////////
/*! @file BursiPanSignal.h   BursiPan signal gauge.
- Part of PanBursian - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface Library.
- Uses  RANet - Research Assistant Net Library.
- Uses  Qt v.5  -  http://qt-project.org/
- Copyright(C) 2014, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef BursiPanSignal_H
#define BursiPanSignal_H
#include "PanBursian.h"
#include "Gauge.h"
#include "BursiPan.h"
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sBursiPanSignal)

//---------------------------------------------------------- sBursiPanSignal ---
/*! BursiPan signal gauge.
*/
class PanBursian_EXPORT  sBursiPanSignal : public sGauge
{
  Q_OBJECT
  DRIVER(sBursiPanSignal)

  public:
    virtual                   ~sBursiPanSignal ();

  protected: //evolution of the inherited state machine
    psState                   State_W_BursiPan;
    psState                   State_W_BursiPan_Linking;

  signals: //for internal needs
    void                      BursiPanLinked ();
    void                      BursiPanError (QString = QString());

  protected: //reimplementing inherited
    virtual void              PostConstructor ();

  protected slots: //reimplementing inherited
    virtual void              OnEnterToCoolingState ();
//    virtual void              SetWantedAutoRepeatMode ();
    virtual void              SetWantedPeriod ();

  protected slots:
    virtual void              ReportBursiPanError (QString);

  protected: //fields
    sBursiPan::sLink          BursiPan;

  private slots:
    void                      LinkToBursiPan ();
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
