////////////////////////////////////////////////////////////////////////////////
/*! @file PanBursian.h   Instrumental package (plugin) for the Bursian's
                         experimental setup.
- Part of PanBursian - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface Library.
- Uses  RANet - Research Assistant Net Library.
- Uses  Qt v.5  -  http://qt-project.org/
- Copyright(C) 2012-2014, Viktor E. Bursian, St.Petersburg, Russia.
                          Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef PanBursian_H
#define PanBursian_H
#include "RAPlugins.h"
namespace RA {
//------------------------------------------------------------------------------

#if defined(PanBursian_PLUGIN_BUILD)
    #define PanBursian_EXPORT Q_DECL_EXPORT
#elif defined(PanBursian_PLUGIN_USE)
    #define PanBursian_EXPORT Q_DECL_IMPORT
#else
    #define PanBursian_EXPORT
#endif

//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sPanBursian)

//------------------------------------------------------------------------------
namespace Symbol {
const literal  Theta = "Θ";
                              //"Θ" = ""
                              //U+0398 Greek Capital Letter Theta
                              //UTF-8:   UTF-16: 0x0398
                              //bigger in DeJaVu:
                              //"ϴ" = "\317\264"
                              //U+03F4 GREEK CAPITAL THETA SYMBOL
                              //UTF-8: 0xCF 0xB4   UTF-16: 0x03F4   &#1012;
const literal  Phi   = "Φ";
                              //"Φ" = ""
                              //U+03A6 Greek Capital Letter Phi
                              //UTF-8:   UTF-16: 0x03A6
}
//------------------------------------------------------------------------------

class sPanBursian : public QObject ,public sInstrumentalPackage
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "BursianSoft.RA.sInstrumentalPackage")
    Q_INTERFACES(RA::sInstrumentalPackage)
    ADAM(sPanBursian)

  public:
    virtual sVersion          Version ();
    virtual sVersion          CoreVersionUsed ();
    virtual sVersion          CoreVersionMin ();
    virtual QString           UserFriendlyName ();
    virtual QString           About ();
    virtual bool              HasDefaults ()
                                { return true; }
    virtual void              InstallDefaults (sPtr<sFolderNode>  DeviceList);
                              sPanBursian ();
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
