// ImportSOS.cpp   (RA_SOS)
// Copyright(C) 2000-2006, Viktor E. Bursian, St.Petersburg, Russia
////////////////////////////////////////////////////////////////////////////////
#include "ImportSOS.h"


typedef enum{FileTypeSOP
            ,FileTypeSOS
            }                 eFileType;

typedef enum{SOSRelease_None
            ,SOSRelease_Unknown
            ,SOSRelease_Bursian
            ,SOSRelease_Nelson
            }                 eSOSRelease;

sLongString  Load_SOS_Item (psStream S);
sAttribute  Load_SOS_Remark (psStream S);
sAttribute  Load_SOS_Field (psStream S);
sAttribute  Load_SOS_IntegerField (psStream S);
sAttribute  Load_SOS_LongintField (psStream S);
sAttribute  Load_SOS_StringField (psStream S);
sAttribute  Load_SOS_FixedField (psStream S);
sAttribute  Load_SOS_FloatField (psStream S);
sAttribute  Load_SOS_Figure (psStream S
                            ,bool PreserveColors
                            ,eFileType FType
                            ,rcsFileLocation FileLocation);
sAttribute  Load_SOS_Window (psStream S
                            ,bool PreserveColors
                            ,eFileType FType
                            ,rcsFileLocation FileLocation);
sAttribute  Load_SOS_Line (psStream S ,bool PreserveColors);
sAttribute  Load_SOS_Curve (psStream S ,bool PreserveColors);
sAttribute  Load_SOS_Picture (psStream S
                             ,bool PreserveColors
                             ,eFileType FType
                             ,rcsFileLocation FileLocation);
sAttribute  Load_SOS_ColorIndicator (psStream S);
sAttribute  Load_SOS_Spectrum (psStream S
                              ,bool PreserveColors
                              ,eFileType FType
                              ,rcsFileLocation FileLocation);

eSOSRelease SOSRelease = SOSRelease_None;


sAttribute  Get_SOS_Object (psStream S
                           ,bool PreserveColors
                           ,eFileType FType
                           ,rcsFileLocation FileLocation)
{
  word                        IOC;
  sAttribute                  A(sAttributeName(),NullNodePtr,sNode::Type);

  S->READ_INTO(IOC);
  if( IOC <= 0 ){
//    A= new sAttribute("",NULL);
  }else if( IOC <= 25 ){
    switch( IOC ){
      //case  0:   A= new sAttribute("",NULL);  break;
      //case  1:   A=Load_SOS_AnalogField(S);  break;
      case  2:   A=Load_SOS_Spectrum(S,PreserveColors,FType,FileLocation);  break;
      case  3:   A=Load_SOS_Figure(S,PreserveColors,FType,FileLocation);  break;
      case  4:   A=Load_SOS_Window(S,PreserveColors,FType,FileLocation);  break;
      //case  5:   A=Load_SOS_Panel(S);  break;
      //case  6:   A=Load_SOS_Cross(S);  break;
      case  7:   A=Load_SOS_Curve(S,PreserveColors);  break;
      //case  8:   A=Load_SOS_FileString(S);  break;
      //case  9:   A=Load_SOS_FileViewer(S);  break;
      //case 10:   A=Load_SOS_Relief(S);  break;
      case 11:   A=Load_SOS_Remark(S);  break;
      case 12:   A=Load_SOS_Field(S);  break;
      case 13:   A=Load_SOS_IntegerField(S);  break;
      case 14:   A=Load_SOS_LongintField(S);  break;
      case 15:   A=Load_SOS_StringField(S);  break;
      case 16:   A=Load_SOS_FixedField(S);  break;
      case 17:   A=Load_SOS_FloatField(S);  break;
      //case 18:   A=Load_SOS_CommandProcessor(S);  break;
      //case 19:   A=Load_SOS_Macro(S);  break;
      //case 20:   A=Load_SOS_Variable(S);  break;
      //case 21:   A=Load_SOS_Command(S);  break;
      //case 22:   A=Load_SOS_MemoryField(S);  break;
      //case 23:   A=Load_SOS_Cartridge(S);  break;
      //case 24:   A=Load_SOS_Cartridge(S);  break;
      //case 25:   A=Load_SOS_Cartridge(S);  break;
    };
  }else if( (IOC <= 28) && (SOSRelease == SOSRelease_Bursian ) ){
    switch( IOC ){
      //case 26:   A=Load_SOS_MagneticFieldDriver(S);  break;
      //case 27:   A=Load_SOS_ESRMeter(S);  break;
      //case 28:   A=Load_SOS_SEX(S);  break;
    };
  }else if( (IOC <= 28) && (SOSRelease == SOSRelease_Nelson ) ){
    switch( IOC ){
      //case 26:   A=Load_SOS_WaveLengthDriver(S);  break;
      //case 27:   A=Load_SOS_DigitalVoltmeter(S);  break;
      //case 28:   A=Load_SOS_MDR(S);  break;
    };
  }else if( IOC <= 31 ){
    switch( IOC ){
      case 29:   A=Load_SOS_Picture(S,PreserveColors,FType,FileLocation);  break;
      //case 30:   A=Load_SOS_PicturesList(S);  break;
      case 31:   A=Load_SOS_ColorIndicator(S);  break;
    };
  }else if( SOSRelease == SOSRelease_Bursian ){
    switch( IOC ){
      //default:   A= new sAttribute("",NULL);  break;
    };
  }else if( SOSRelease == SOSRelease_Nelson ){
    switch( IOC ){
      //case 32:   A=Load_SOS_GratingNo(S);  break;
      //case 33:   A=Load_SOS_FreqMeter(S);  break;
      //case 34:   A=Load_SOS_Fitter(S);  break;
      //case 35:   A=Load_SOS_Fitter(S);  break;
      //case 36:   A=Load_SOS_Fitter(S);  break;
      //case 37:   A=Load_SOS_DFSWLDriver(S);  break;
      //case 38:   A=Load_SOS_DFS(S);  break;
      //case 39:   A=Load_SOS_DifMeter(S);  break;
      //default:   A= new sAttribute("",NULL);  break;
    };
  }else{
//    A= new sAttribute("",NULL);
  };
  return A;
};


sLongString  Load_SOS_Item (psStream S)
{
  const int                   CartNameSize = 24;
  byte                        L;
  char                        N[CartNameSize+1];
  for( int i=0 ; i < CartNameSize+1 ; i++ )  N[i]='\0';
  S->ReadInto(&L,1);
  if(  L < 0x40  ){
    S->ReadInto(N,CartNameSize);
  }else{
    #pragma warn -sig
    L-=0x40;
    #pragma warn .sig
    S->ReadInto(N,L);
  };
  S->Skip(8+1);
  return sLongString(N);
};


sAttribute  Load_SOS_Remark (psStream S)
{
  sLongString                 AName = Load_SOS_Item(S);
  short int                   Size;
  byte                        L;
  char                        PictureBody[256];

  for( int i=0 ; i < 256 ; i++ )  PictureBody[i]='\0';
  S->READ_INTO(Size);
  S->READ_INTO(L);
  S->ReadInto(PictureBody,L);
  S->Skip(8+16+4);
  return attr(AName,new nStr(PictureBody),sNode::Type);
};


sAttribute  Load_SOS_Field (psStream S)
{
  sAttribute                  A = Load_SOS_Remark(S);
  S->Skip(2+1);
  return A;
};


sAttribute  Load_SOS_StringField (psStream S)
{
  sAttribute                  A = Load_SOS_Field(S);
  byte                        L;
  char                        Value[256];

  for( int i=0 ; i < 256 ; i++ )  Value[i]='\0';
  S->READ_INTO(L);
  if( L == 0xFF ){
    S->READ_INTO(L);
    S->ReadInto(Value,L);
  }else{
    S->ReadInto(Value,255);
  };
  return sAttribute( A.Name() ,sNode::sPtr(new nStr(Value)) ,sNode::Type);
};


sAttribute  Load_SOS_IntegerField (psStream S)
{
  sAttribute                  A = Load_SOS_Field(S);
  short int                   Value;

  S->READ_INTO(Value);
  return sAttribute( A.Name() ,sNode::sPtr(new nInt(Value)) ,sNode::Type);
};


sAttribute  Load_SOS_LongintField (psStream S)
{
  sAttribute                  A = Load_SOS_Field(S);
  int                         Value;

  S->READ_INTO(Value);
  return sAttribute( A.Name() ,sNode::sPtr(new nInt(Value)) ,sNode::Type);
};


sAttribute  Load_SOS_FixedField (psStream S)
{
  sAttribute                  A = Load_SOS_Field(S);
  Double                      Value;
  short int                   Decimals;

  S->READ_INTO(Value);
  S->READ_INTO(Decimals);
  return sAttribute( A.Name() ,sNode::sPtr(new nFloat(Value)) ,sNode::Type);
};


sAttribute  Load_SOS_FloatField (psStream S)
{
  sAttribute                  A = Load_SOS_Field(S);
  Double                      Value;

  S->READ_INTO(Value);
  return sAttribute( A.Name() ,sNode::sPtr(new nFloat(Value)) ,sNode::Type);
};


sAttribute  Load_SOS_Figure (psStream S
                            ,bool PreserveColors
                            ,eFileType FType
                            ,rcsFileLocation FileLocation)
{
  sNode::sPtr                 Cluster(new sEasyCluster);
  sLongString                 CName = Load_SOS_Item(S);
  sAttribute                  A = Get_SOS_Object(S,PreserveColors
                                                ,FType,FileLocation);
  while( ! A.Value().IsNULL() ){
    Cluster->SetAttr(A);
    A=Get_SOS_Object(S,PreserveColors,FType,FileLocation);
  };
  return attr(CName,Cluster);
};


sAttribute  Load_SOS_Window (psStream S
                            ,bool PreserveColors
                            ,eFileType FType
                            ,rcsFileLocation FileLocation)
{
  sAttribute                  A = Load_SOS_Figure(S,PreserveColors
                                                 ,FType,FileLocation);
  S->Skip(4*4+2*2+2);
  return A;
};


sAttribute  Load_SOS_Line (psStream S ,bool PreserveColors)
{
  sLongString                 AName = Load_SOS_Item(S);
  sNode::sPtr                 LineAttrs(new sEasyCluster);
  word                        Color,Style,Width;
  tColor                      LineColor;
  psCurveAppearance           CA;
  S->READ_INTO(Color);
  S->READ_INTO(Style);
  S->READ_INTO(Width);
  if( PreserveColors ){
    switch( Color ){
        case  1:  LineColor=clBlue;  break;
        case  2:  LineColor=clGreen;  break;
        case  3:  LineColor=clAqua;  break;
        case  4:  LineColor=clRed;  break;
        case  5:  LineColor=clPurple;  break;
        case  6:  LineColor=clMaroon;  break;
        case  7:  LineColor=clLtGray;  break;
        case  8:  LineColor=clDkGray;  break;
        case  9:  LineColor=clBlue;  break;
        case 10:  LineColor=clLime;  break;
        case 11:  LineColor=clAqua;  break;
        case 12:  LineColor=clRed;  break;
        case 13:  LineColor=clPurple;  break;
        case 14:  LineColor=clYellow;  break;
        default:  LineColor=clBlack;  break;
    };
    CA=new sCurveAppearance;
    CA->Line.Color=LineColor;
    *LineAttrs<<sAttribute(cSysAttrCurveAppearance,CA,sNode::Type);
  };
  return sAttribute((AName.Empty() ? sAttributeName() : sAttributeName(AName))
                   ,LineAttrs,sNode::Type);
};


sAttribute  Load_SOS_Curve (psStream S ,bool PreserveColors)
{
  sAttribute                  A = Load_SOS_Line(S,PreserveColors);
  short int                   Size;
  bool                        Press;
  Single                      MultiplierX;
  Single                      MultiplierY;
  Single                      OriginX;
  Single                      Quantum,Shift;
  Single                      Val;
  short int                   V;
  psArrayFunction             C;
  sNode::sPtr                 CPtr;

  S->READ_INTO(Size);
  Press=(Size < 0);
  #pragma warn -sig
  if( Press )
    Size=-Size;
  #pragma warn .sig
  S->READ_INTO(MultiplierX);
  S->READ_INTO(MultiplierY);
  C= new sArrayFunction(Size,0,MultiplierX);
  if( ! Press ){
    for( int x=0 ; x < Size ; x++ ){
      S->READ_INTO(Val);
      C->Values[x]=double(MultiplierY)*Val;
    };
  }else{
    S->READ_INTO(Shift);
    S->READ_INTO(Quantum);
    for( int x=0 ; x < Size ; x++ ){
      S->READ_INTO(V);
      C->Values[x]=double(MultiplierY)*(Shift + V * Quantum);
    };
  };
  S->READ_INTO(OriginX);
  C->X0=OriginX;
  CPtr=sNode::sPtr(C);
  (*CPtr) |= (A.Value());
  return sAttribute(A.Name(),CPtr,sNode::Type);
};


sAttribute  Load_SOS_Picture (psStream S
                              ,bool PreserveColors
                              ,eFileType FType
                              ,rcsFileLocation FileLocation)
{
  sAttribute                  Window = Load_SOS_Window(S,PreserveColors
                                                      ,FType,FileLocation);
  sAttribute                  Body = Get_SOS_Object(S,PreserveColors
                                                   ,FType,FileLocation);

  (*(Body.Value())) |= (Window.Value());
  return sAttribute(Window.Name(),Body.Value(),sNode::Type);
};


sAttribute  Load_SOS_ColorIndicator (psStream S)
{
  return Load_SOS_Window(S,false,FileTypeSOS,sFileLocation(""));
};


sAttribute  Load_SOS_Spectrum (psStream S
                              ,bool PreserveColors
                              ,eFileType FType
                              ,rcsFileLocation FileLocation)
{
  sAttribute                  A(sAttributeName(),NullNodePtr,sNode::Type);
  sLongString                 FormatName;
  sAttribute                  Body(sAttributeName(),NullNodePtr,sNode::Type);
  sNode::sPtr                 Spectrum;
  byte                        L;
  short int                   I;
  Double                      X;
  char                        SV [256];
  gTinyString<3>              DummyString = "$%Z";
  //Double                      DummyValue = 123456789e123;

  if( FType == FileTypeSOS ){
    A=Load_SOS_Picture(S,PreserveColors,FType,FileLocation);
    S->ReadInto(&L,1);  S->ReadInto(SV,L); SV[L]='\0';
    if( ! A.Value().IsNULL() )
      *(A.Value()) << sAttribute("FormatName" ,new nStr(SV) ,sNode::Type);
  }else{
    S->ReadInto(&L,1);  S->ReadInto(SV,L); SV[L]='\0';
    FormatName=SV;
    Body=Get_SOS_Object(S,PreserveColors,FType,FileLocation);
    Spectrum=Body.Value();
    A=sAttribute(FileLocation.Name,Spectrum,sNode::Type);
    if( FormatName == "MDR-format" ){
      S->ReadInto(&L,1);  S->ReadInto(SV,L); SV[L]='\0';
                        *Spectrum<<attr("Title",SV);
      S->READ_INTO(I);  *Spectrum<<attr("GratingNo",I);
      S->READ_INTO(X);  *Spectrum<<attr("Slit",X);
      S->READ_INTO(X);  *Spectrum<<attr("StWL",X);
      S->READ_INTO(X);  *Spectrum<<attr("FinWL",X);
      S->READ_INTO(X);  *Spectrum<<attr("Step",X);
      S->READ_INTO(X);  *Spectrum<<attr("Termostat",X);
      S->ReadInto(&L,1);  S->ReadInto(SV,L); SV[L]='\0';
                        *Spectrum<<attr("Type",SV);
      S->READ_INTO(I);  *Spectrum<<attr("Counts",I);
      S->ReadInto(&L,1);  S->ReadInto(SV,L); SV[L]='\0';
                        *Spectrum<<attr("Matter",SV);
      S->ReadInto(&L,1);  S->ReadInto(SV,L); SV[L]='\0';
                        *Spectrum<<attr("Sample",SV);
      S->ReadInto(&L,1);  S->ReadInto(SV,L); SV[L]='\0';
                        *Spectrum<<attr("Comment",SV);
    }else if( FormatName == "FitFormat" ){
      S->ReadInto(&L,1);  S->ReadInto(SV,L); SV[L]='\0';
                        *Spectrum<<attr("Title",SV);
      S->READ_INTO(X);  *Spectrum<<attr("From",X);
      S->READ_INTO(X);  *Spectrum<<attr("Til",X);
      S->READ_INTO(I);  *Spectrum<<attr("Points",I);
      for( int i=1 ; i<=8 ; i++ ){
        S->ReadInto(&L,1);  S->ReadInto(SV,L); SV[L]='\0';
        S->READ_INTO(X);
        if( X < 1e131 ){
          if( DummyString == SV ){
            switch( i ){
              case 1:  *Spectrum<<attr("Par1",X);
              case 2:  *Spectrum<<attr("Par2",X);
              case 3:  *Spectrum<<attr("Par3",X);
              case 4:  *Spectrum<<attr("Par4",X);
              case 5:  *Spectrum<<attr("Par5",X);
              case 6:  *Spectrum<<attr("Par6",X);
              case 7:  *Spectrum<<attr("Par7",X);
              case 8:  *Spectrum<<attr("Par8",X);
            };
          }else{
            *Spectrum<<attr(SV,X);
          };
        };
      };
    }else{
      //throw       A = new sAttribute("",NULL);
    };
  };
  return A;
};
/* Nelson
/////////////////////////
  constructor Spectrum.Load (var S : Stream);
    var
      I  : RefLoadStoreItem;
      P  : RefPicture;
      D  : DirStr;
      N  : NameStr;
      E  : ExtStr;
      Nm : string;
  begin
    if SaveAsPicture then begin
      Picture.Load(S);
      S.Read(FormatName,1);
      S.Read(FormatName[1], Length(FormatName));
    end else begin
      Window.Gen;
      S.Read(FormatName,1);
      S.Read(FormatName[1], Length(FormatName));
      Body:=RefItem(S.Get);
      if  Body <> nil  then
        Body^.Host:=@Self;
      P:=RefPicture(PicList^.RefTo(FormatName));
      I:=RefLoadStoreItem(LoadStoreList.RefTo(FormatName));
      if P = nil then begin
        P:=RefPicture(PicList^.RefTo('- format -'));
        I:=RefLoadStoreItem(LoadStoreList.RefTo('- format -'));
      end;
      if  (P = nil) or (I = nil)  then begin
        Message(12,'There is no format !!!');
        exit;
      end;
      Site.X:=P^.Site.X;  Site.Y:=P^.Site.Y;
      Status:=P^.Status;
      with  Boundaries  do begin
        XL:=P^.Boundaries.XL; XR:=P^.Boundaries.XR;
        YB:=P^.Boundaries.YB; YT:=P^.Boundaries.YT;
      end;
      with  Back  do begin
        Color:=P^.Back.Color; Style:=P^.Back.Style;
      end;
      with  Border  do begin
        Color:=P^.Border.Color; Width:=P^.Border.Width;
      end;
      ItemsListCopy (P,@Self);
      FSplit(RefBasicStream(@S)^.Name,D,N,E);
      Name:=N; Nm:=N;
      RefRemark( RefTo('Identifier') )^.Put(Nm);
      I^.LoadProc(S,@Self);
      LetProcessable;
    end;
  end;


/////////////////////////"MDR-format"
  procedure MDRLoad(var S : Stream;RS : RefSpectrum);
    var
      I  : integer;
      X  : double;
      SV : string;
  begin
    S.Read(SV,1); S.Read(SV[1], Length(SV));
    RefStringField(RS^.RefTo('Title'))^.Value:=SV;
    S.Read(I,SizeOf(I));
    RefIntegerField(RS^.RefTo('GratingNo'))^.Value:=I;
    S.Read(X,SizeOf(X));
    RefFixedField(RS^.RefTo('Slit'))^.Value:=X;
    S.Read(X,SizeOf(X));
    RefFixedField(RS^.RefTo('StWL'))^.Value:=X;
    S.Read(X,SizeOf(X));
    RefFixedField(RS^.RefTo('FinWL'))^.Value:=X;
    S.Read(X,SizeOf(X));
    RefFixedField(RS^.RefTo('Step'))^.Value:=X;
    S.Read(X,SizeOf(X));
    RefFixedField(RS^.RefTo('Termostat'))^.Value:=X;
    S.Read(SV,1); S.Read(SV[1], Length(SV));
    RefRemark(RS^.RefTo('Type'))^.Put(SV);
    S.Read(I,SizeOf(I));
    RefIntegerField(RS^.RefTo('Counts'))^.Value:=I;
    S.Read(SV,1); S.Read(SV[1], Length(SV));
    RefStringField(RS^.RefTo('Matter'))^.Value:=SV;
    S.Read(SV,1); S.Read(SV[1], Length(SV));
    RefStringField(RS^.RefTo('Sample'))^.Value:=SV;
    S.Read(SV,1); S.Read(SV[1], Length(SV));
    RefStringField(RS^.RefTo('Comment'))^.Value:=SV;
    with RefLine(RS^.Body)^.Mode do begin
      Color:=ColorsNumber-1;  Style:=SolidLn;  Width:=NormWidth;
    end;
  end;

//////////////////////////////////////"FitFormat"
  const
    DummyString = '$%Z';
    DummyValue : double = 123456789E123;

  procedure FitLoad(var S : Stream;RS : RefSpectrum);
    var
      I  : integer;
      X  : double;
      SV : string;
  begin
    S.Read(SV,1); S.Read(SV[1], Length(SV));
    RefStringField(RS^.RefTo('Title'))^.Value:=SV;
    S.Read(X,SizeOf(X));
    RefFixedField(RS^.RefTo('From'))^.Value:=X;
    S.Read(X,SizeOf(X));
    RefFixedField(RS^.RefTo('Til'))^.Value:=X;
    S.Read(I,SizeOf(I));
    RefIntegerField(RS^.RefTo('Points'))^.Value:=I;
    for I:=1 to 8 do begin
      S.Read(SV,1); S.Read(SV[1], Length(SV));
      if SV = DummyString then
        RefStringField(RS^.RefTo('Par'+Integer2String(I,1)+'Title'))^.Value:=
                      'Par'+Integer2String(I,1)+' ='
      else begin
        RefStringField(RS^.RefTo('Par'+Integer2String(I,1)+'Title'))^.Value:=SV;
        RS^.RefTo('Par'+Integer2String(I,1)+'Title')^.LetVisible;
      end;
      S.Read(X,SizeOf(X));
      if X = DummyValue then
        RefFixedField(RS^.RefTo('Par'+Integer2String(I,1)))^.Value:=1
      else begin
        RefFixedField(RS^.RefTo('Par'+Integer2String(I,1)))^.Value:=X;
        RS^.RefTo('Par'+Integer2String(I,1))^.LetVisible;
      end;
    end;
    with RefLine(RS^.Body)^.Mode do begin
      Color:=ColorsNumber-1;  Style:=SolidLn;  Width:=NormWidth;
    end;
  end;

*/


sNode::sPtr  Modify_SOP (sNode::sPtr C
                        ,sNode::sPtr //Config
                        )
{
  if(    ((*C>>"Rem0") <= nStr::Type)
      && ((*C>>"Rem1") <= nStr::Type)
      && ((*C>>"Rem2") <= nStr::Type)
      && ((*C>>"Rem3") <= nStr::Type)
      && ((*C>>"FreqTitle") <= nStr::Type)
      && ((*C>>"Freq") <= nFloat::Type)
      && ((*C>>"ATitle") <= nStr::Type)
      && ((*C>>"A") <= nFloat::Type)
      && ((*C>>"GTitle") <= nStr::Type)
      && ((*C>>"G") <= nFloat::Type)
      && ((*C>>"MATitle") <= nStr::Type)
      && ((*C>>"MA") <= nFloat::Type)
      && ((*C>>"MFTitle") <= nStr::Type)
      && ((*C>>"MF") <= nStr::Type)
      && ((*C>>"HoTitle") <= nStr::Type)
      && ((*C>>"Ho") <= nFloat::Type)
      && ((*C>>"dHTitle") <= nStr::Type)
      && ((*C>>"dH") <= nFloat::Type)
      && ((*C>>"StepTitle") <= nStr::Type)
      && ((*C>>"Step") <= nFloat::Type)
      && ((*C>>"TimesTitle") <= nStr::Type)
      && ((*C>>"Times") <= nInt::Type)
      && ((*C>>"Identifier") <= nStr::Type)
      && ((*C>>"ColorInd") <= sCluster::Type)
      ){
    C->DelAttr("FreqTitle");
    C->DelAttr("ATitle");
    C->DelAttr("GTitle");
    C->DelAttr("MATitle");
    C->DelAttr("MFTitle");
    C->DelAttr("HoTitle");
    C->DelAttr("dHTitle");
    C->DelAttr("StepTitle");
    C->DelAttr("TimesTitle");
    C->DelAttr("Identifier");
    C->DelAttr("ColorInd");
  };
  return C;
};


void Import_SOP_Setup (sNode::sPtr Config)
{
  *Config |= attr("SOSRelease","Bursian");
  *Config |= attr("PreserveColors",0);
  if( rnStr(*Config>>"SOSRelease") == "Bursian" ){
    SOSRelease=SOSRelease_Bursian;
  }else if( rnStr(*Config>>"SOSRelease") == "Nelson" ){
    SOSRelease=SOSRelease_Nelson;
  }else{
    SOSRelease=SOSRelease_Unknown;
  };
};


sNode::sPtr  Import_SOP (psStream S
                        ,sNode::sPtr Config
                        ,rcsFileLocation FileLocation)
{
  sNode::sPtr                 C;
  bool                        PreserveColors;
  sLongString                 FormatName;

  if( SOSRelease == SOSRelease_None )
    Import_SOP_Setup(Config);
  PreserveColors=( rnInt(*Config>>"PreserveColors") == 1 );

  C=Get_SOS_Object(S,PreserveColors,FileTypeSOP,FileLocation).Value();
  if( ! C.IsNULL() ){
    C=Modify_SOP(C,Config);
  };
  return C;
};


sNode::sPtr  Import_SOS (psStream S
                        ,sNode::sPtr Config
                        ,rcsFileLocation FileLocation)
{
  sNode::sPtr                 C;
  bool                        PreserveColors;

  PreserveColors=( rnInt(*Config>>"PreserveColors") == 1 );
  throw xNotImplemented("Import_SOS(...)");
  //return C;
};

