////////////////////////////////////////////////////////////////////////////////
/*! @file SOS2RA.h   SOS to RA transitional package.
- Part of SOS2RA - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  RANet - Research Assistant Net Library.
- Uses  Qt v.5  - http://qt-project.org/
- Copyright(C) 2015, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor_dot_Bursian_at_mail_dot_ioffe_dot_ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef SOS2RA_H
#define SOS2RA_H
#include "RAPlugins.h"
namespace RA {
//------------------------------------------------------------------------------

#if defined(SOS2RA_PLUGIN_BUILD)
    #define SOS2RA_EXPORT Q_DECL_EXPORT
#elif defined(SOS2RA_PLUGIN_USE)
    #define SOS2RA_EXPORT Q_DECL_IMPORT
#else
    #define SOS2RA_EXPORT
#endif

//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sSOS2RA)

//------------------------------------------------------------------------------

class sSOS2RA : public QObject ,public sInstrumentalPackage
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "BursianSoft.RA.sInstrumentalPackage")
    Q_INTERFACES(RA::sInstrumentalPackage)
    ADAM(sSOS2RA)

  public:
    virtual sVersion          Version ();
    virtual sVersion          CoreVersionUsed ();
    virtual sVersion          CoreVersionMin ();
    virtual QString           UserFriendlyName ();
    virtual QString           About ();
    virtual bool              HasDefaults ()
                                { return true; }
    virtual void              InstallDefaults (sPtr<sFolderNode>  DeviceList);
                              sSOS2RA ();
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
