////////////////////////////////////////////////////////////////////////////////
/*! @file SR400Drivers.cpp Drivers for SR400 Counter device.
- Part of SR400Drivers - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2012-2016, Dmitry K. Nelson, St.Petersburg, Russia.
                          D.Nelson@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#include "SR400Drivers.h"
#include "attr.h"
namespace RA {
//------------------------------------------------------------------------------

DEFINE_CLASS_TAG(sSR400Drivers)

//------------------------------------------------------------------------------

sVersion  sSR400Drivers::Version ()
{
  return sVersion(RAP_VERS_MAJOR
                 ,RAP_VERS_MINOR
                 ,ZAKAVYCH(RAP_VERS_PATCH)
                 ,__DATE__
                 );
}


sVersion  sSR400Drivers::CoreVersionUsed ()
{
  return sVersion( RA_VERS_MAJOR , RA_VERS_MINOR );
}


sVersion  sSR400Drivers::CoreVersionMin ()
{
  return sVersion( RA_VERS_MAJOR , RA_VERS_MINOR );
}


QString  sSR400Drivers::UserFriendlyName ()
{
  return trUtf8("Drivers for SR400 Counter device");
}


QString  sSR400Drivers::About ()
{
  return trUtf8(
      "Copyright (C) 2016, Dmitry K. Nelson, St.Petersburg, Russia.\n"
      "                    D.Nelson@mail.ioffe.ru\n"
      "Copyright (C) 2011, Viktor E. Bursian, St.Petersburg, Russia.\n"
      "                    Viktor.Bursian@mail.ioffe.ru"
                );
}


void  sSR400Drivers::InstallDefaults (sPtr<sFolderNode>  /*DeviceList*/)
{
  try{
/*
    sPtr<sFolderNode>              DeviceCfg;

    DeviceList |= "SR400COM";
    DeviceCfg = DeviceList >> "SR400COM";
    DeviceCfg << attr("Class","sTeleCOMPort");
    sTeleCOMPort::Preconfigure(DeviceCfg);
    DeviceCfg >> "Settings" << attr("PortName","COM1");
    DeviceCfg >> "Settings" << attr("BaudRate",115200);
    DeviceCfg >> "Settings" << attr("Timeout",sPhysValue(10.0,"s"));

    DeviceList |= "SR400Counter";
    DeviceCfg = DeviceList >> "SR400Counter";
    DeviceCfg << attr("Class","sSR400Counter");
    sSR400Counter::Preconfigure(DeviceCfg);
    DeviceCfg >> "Links" >> "CounterCom"
        << attr("DeviceId","SR400COM");

*/
  }catch(...){
    ;
  };

    /*________________________________________template for device
    DeviceList |= "__DEVICE_ID__";
    DeviceCfg = DeviceList >> "__DEVICE_ID__";
    DeviceCfg << attr("Class","__DRIVER_CLASS_NAME__");
    __DRIVER_CLASS_NAME__::Preconfigure(DeviceCfg);
    //if there are links:
    DeviceCfg >> "Links" >> "__LINK_NAME__"
        << attr("DeviceId","__DEVICE_ID__FOR_THE_LINK__");
    //if you wanna change some of the default settings:
    DeviceCfg >> "Settings" << attr("",);
    DeviceCfg >> "Settings" << attr("",);
    */
}


sSR400Drivers::sSR400Drivers ()
{
  sUnit::Register("photon");
  sUnit::Register("s");
}

//------------------------------------------------------------------------------
} //namespace RA
