////////////////////////////////////////////////////////////////////////////////
/*! @file SR400Drivers.h   Drivers for SR400 Counter device.
- Part of SR400Drivers - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
- Copyright(C) 2016, Dmitrii K. Nelson, St.Petersburg, Russia.
                     d.nelson@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef SR400Drivers_H
#define SR400Drivers_H
#include "RAPlugins.h"
namespace RA {
//------------------------------------------------------------------------------

#if defined(SR400Drivers_PLUGIN_BUILD)
    #define SR400Drivers_EXPORT Q_DECL_EXPORT
#elif defined(SR400Drivers_PLUGIN_USE)
    #define SR400Drivers_EXPORT Q_DECL_IMPORT
#else
    #define SR400Drivers_EXPORT
#endif

//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sSR400Drivers)

//------------------------------------------------------------------------------

class sSR400Drivers : public QObject ,public sInstrumentalPackage
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "BursianSoft.RA.sInstrumentalPackage")
    Q_INTERFACES(RA::sInstrumentalPackage)
    ADAM(sSR400Drivers)

  public:
    virtual sVersion          Version ();
    virtual sVersion          CoreVersionUsed ();
    virtual sVersion          CoreVersionMin ();
    virtual QString           UserFriendlyName ();
    virtual QString           About ();
    virtual bool              HasDefaults ()
                                { return true; }
    virtual void              InstallDefaults (sPtr<sFolderNode>  DeviceList);
                              sSR400Drivers ();
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
