////////////////////////////////////////////////////////////////////////////////
/*! @file UTMeters.h   Drivers for Multimeters of UT60 series.
- Part of UTMeters - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface.
- Uses  QtGui v.4.6  -  http://qt.nokia.com/
- Uses  RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
- Copyright(C) 2016, Dmitrii K. Nelson, St.Petersburg, Russia.
                     d.nelson@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef UTMeters_H
#define UTMeters_H
#include "RAPlugins.h"
namespace RA {
//------------------------------------------------------------------------------

#if defined(UTMeters_PLUGIN_BUILD)
    #define UTMeters_EXPORT Q_DECL_EXPORT
#elif defined(UTMeters_PLUGIN_USE)
    #define UTMeters_EXPORT Q_DECL_IMPORT
#else
    #define UTMeters_EXPORT
#endif

//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sUTMeters)

//------------------------------------------------------------------------------

class sUTMeters : public QObject ,public sInstrumentalPackage
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "BursianSoft.RA.sInstrumentalPackage")
    Q_INTERFACES(RA::sInstrumentalPackage)
    ADAM(sUTMeters)

  public:
    virtual sVersion          Version ();
    virtual sVersion          CoreVersionUsed ();
    virtual sVersion          CoreVersionMin ();
    virtual QString           UserFriendlyName ();
    virtual QString           About ();
    virtual bool              HasDefaults ()
                                { return false; }
//                                { return true; }
//    virtual void              InstallDefaults (sPtr<sFolderNode>  DeviceList);
                              sUTMeters ();
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
