// StorableExample.cpp ---
// Copyright(C) 1994-2010, Viktor E. Bursian, St.Petersburg, Russia
//                         Viktor.Bursian@mail.ioffe.ru
////////////////////////////////////////////////////////////////////////////////
#include "StorableExample.h"
namespace RA {
//------------------------------------------------------------------------------

DEFINE_CLASS_TAG( sSelective )
DEFINE_CLASS_TAG( sSwitchable )
DEFINE_CLASS_TAG( sReciever )
DEFINE_CLASS_TAG( sTransmitter )
DEFINE_CLASS_TAG( sRadio )
DEFINE_CLASS_TAG( sVokiToki )

//--------------------------------------------------------------- sSelective ---

void sSelective::Store (std::ostream &  stream) const
{
  sStorable::Store(stream);
  stream.WRITE_FROM(Frequency);
}

sSelective::sSelective (std::istream &  stream)
  :sStorable(stream)
{
  stream.READ_INTO(Frequency);
}

//------------------------------------------------------------------- sRadio ---

void sRadio::Store (std::ostream &  stream) const
{
  sSelective::Store(stream);
  stream << Model;
}

sRadio::sRadio (std::istream &  stream)
  :sSelective(stream)
{
  stream >> Model;
}

//-------------------------------------------------------------- sSwitchable ---

void sSwitchable::Store (std::ostream &  stream) const
{
  sStorable::Store(stream);
  stream.WRITE_FROM(ChanelNumber);
}

sSwitchable::sSwitchable (std::istream &  stream)
  :sStorable(stream)
{
  stream.READ_INTO(ChanelNumber);
}

//---------------------------------------------------------------- sReciever ---

void sReciever::Store (std::ostream &  stream) const
{
  sSwitchable::Store(stream);
}

sReciever::sReciever (std::istream &  stream)
  :sSwitchable(stream)
{
}

//------------------------------------------------------------- sTransmitter ---

void sTransmitter::Store (std::ostream &  stream) const
{
  sSwitchable::Store(stream);
}

sTransmitter::sTransmitter (std::istream &  stream)
  :sSwitchable(stream)
{
}

//---------------------------------------------------------------- sVokiToki ---

void sVokiToki::Store (std::ostream &  stream) const
{
  sReciever::Store(stream);
  sTransmitter::Store(stream);
}

sVokiToki::sVokiToki (std::istream &  stream)
  :sReciever(stream)
  ,sTransmitter(stream)
{
}

//------------------------------------------------------------------------------
} //namespace RA
