// StorableExample.h   ---
// Copyright(C) 1994-2010, Viktor E. Bursian, St.Petersburg, Russia
//                         Viktor.Bursian@mail.ioffe.ru
////////////////////////////////////////////////////////////////////////////////
#ifndef StorableExample_H
#define StorableExample_H
#include "../RANet/General.h"
#include "../RANet/Storable.h"
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sSelective)
ANNOUNCE_CLASS(sRadio)
ANNOUNCE_CLASS(sSwitchable)
ANNOUNCE_CLASS(sReciever)
ANNOUNCE_CLASS(sTransmitter)
ANNOUNCE_CLASS(sVokiToki)

//--------------------------------------------------------------- sSelective ---

class sSelective : public sStorable //not virtual inheritance here
                                    //(which is generally not a good practice)
{
  ABSTRACT_STORABLE(sSelective)
  public:
                              sSelective (float frequency)
                                  :Frequency(frequency)
                                {}
    void virtual              TuneToFavoriteStation () =0;
    float                     Frequency;
};

//------------------------------------------------------------------- sRadio ---

class sRadio : public sSelective
{
  STORABLE(sRadio)
  public:
                              sRadio (literal model)
                                :sSelective(98.3),Model(model)
                                {}
    void virtual              TuneToFavoriteStation ()
                                { Frequency=102.4; }
    sString                   Model;
};

//-------------------------------------------------------------- sSwitchable ---

class sSwitchable : public virtual sStorable
{
  STORABLE(sSwitchable)
  public:
                              sSwitchable (int chanel_number)
                                  :ChanelNumber(chanel_number)
                                {}
    int                       ChanelNumber;
};

//---------------------------------------------------------------- sReciever ---

class sReciever : public sSwitchable
{
  STORABLE(sReciever)
  public:
                              sReciever (int chanel_number)
                                  :sSwitchable(chanel_number)
                                {}
};

//------------------------------------------------------------- sTransmitter ---

class sTransmitter : public sSwitchable
{
  STORABLE(sTransmitter)
  public:
                              sTransmitter (int chanel_number)
                                  :sSwitchable(chanel_number)
                                {}
};

//---------------------------------------------------------------- sVokiToki ---

class sVokiToki : public sReciever ,public sTransmitter
{
  STORABLE(sVokiToki)
  public:
                              sVokiToki (int in_chanel ,int out_chanel)
                                  :sReciever(in_chanel)
                                  ,sTransmitter(out_chanel)
                                {}
    bool                      FullDuplex ()
                                { return sReciever::ChanelNumber
                                         != sTransmitter::ChanelNumber; }
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
