// TestGen.cpp ---
// Uses  RANet - Research Assistant Net Library (based on ANSI C++)
// Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia
//                         Viktor.Bursian@mail.ioffe.ru
////////////////////////////////////////////////////////////////////////////////
#include "TestGen.h"
#include "attr.h"
namespace RA {
//------------------------------------------------------------------------------


sNodePtr  GenerateHouseTree(sNodePtr Host)
{
  sNodePtr                    House = Host >= "House";
  (House >= "rooms" >= "Entrance Hall") << attr("клик<b><i>у</i></b>ха"
                                               ,"прихожая<sub>(сени)</sub>");
  House >> "rooms" >> "Entrance Hall" >= "doors";
  (House >= "rooms" >= "Living Room") << attr("name","тусовка")
                                      << attr("official name","гостиная");
  (House >= "rooms" >= "Living Room" >= "size")
                                          << attr("x",sPhysValue(5.0,0.1,"m"))
                                          << attr("y",sPhysValue(3.0,0.1,"m"));
  House >> "rooms" >= "Kitchen";
  House>>"rooms">>"Kitchen"<<attr("name","кухня");
  House>>"rooms">>"Kitchen"|=attr("area",sIntegerNode::Type());
  //try{
  //  House>>"rooms">>"Kitchen"<<attr("area",7.1); // => exception
  //}catch(...){
    House>>"rooms">>"Kitchen"<<attr("area",7); // OK
  //};
  House>>"rooms">>"Kitchen"|="doors";
  House>>"rooms">>"Kitchen"|="Furniture";
  House>>"rooms">>"Kitchen">>"Furniture"|="Fridge";
  House>>"rooms">>"Kitchen">>"Furniture"|="Пенал";
  House>>"rooms">>"Kitchen">>"Furniture">>"Пенал"<<attr("width",0.50);
  House>>"rooms"|="Master Bedroom";
  House>>"rooms">>"Master Bedroom"<<attr("name","большая спальня");
  House>>"rooms">>"Master Bedroom"<<attr("area",19);
  House>>"rooms">>"Master Bedroom"|="doors";
  House>>"rooms"|="Master Closet";
  House>>"rooms">>"Master Closet"<<attr("name","гардеробная");
  House>>"rooms">>"Master Closet"|="doors";
  House>>"rooms"|="Daughter's Bedroom";
  House>>"rooms">>"Daughter's Bedroom"<<attr("name","хламовник");
  House>>"rooms">>"Daughter's Bedroom"|="doors";
  House>>"rooms"|="Daughter's Closet";
  House>>"rooms">>"Daughter's Closet"<<attr("name","захламник");
  House>>"rooms">>"Daughter's Closet"|="doors";
  return House;
}


void  AddMergedBranches2House(sNodePtr  House)
{
  sNodePtr                    D;

  D = (House >= "doors" >= folder());
  D << attr("comment","из прихожей в большую комнату");
  D << attr("width",0.8);
  House>>"rooms">>"Master Bedroom">>"doors"<<D;
  House>>"rooms">>"Entrance Hall">>"doors"<<D;

  D = House >= "doors" >= folder();
  D << attr("comment","из прихожей в Ритину комнату");
  D << attr("width",0.8);
  House>>"rooms">>"Daughter's Bedroom">>"doors"<<D;
  House>>"rooms">>"Entrance Hall">>"doors"<<D;

  D = House >= "doors" >= folder();
  D << attr("comment","в большую гардеробную");
  D << attr("width",0.6);
  House>>"rooms">>"Master Bedroom">>"doors"<<D;
  House>>"rooms">>"Master Closet">>"doors"<<D;

  D = House >= "doors" >= folder();
  D << attr("comment","в Ритину гардеробную");
  D << attr("width",0.6);
  House>>"rooms">>"Daughter's Bedroom">>"doors"<<D;
  House>>"rooms">>"Daughter's Closet">>"doors"<<D;
}


void  AddCycles2House(sNodePtr  House)
{
  sString                     Comment;
  for_each_nameless_attribute( N , House>>"doors" ){
    if( get_from<sTextNode>(N >> "comment" ,Comment) ){
      if( Comment == "из прихожей в большую комнату" ){
        N << attr("opens from",House>>"rooms">>"Master Bedroom" );
        N << attr("opens to",House>>"rooms">>"Entrance Hall");
      }else if( Comment == "из прихожей в Ритину комнату" ){
        N << attr("opens from",House>>"rooms">>"Daughter's Bedroom");
        N << attr("opens to" ,House>>"rooms">>"Entrance Hall");
      }else if( Comment == "в большую гардеробную" ){
        N << attr("opens from" ,House>>"rooms">>"Master Closet");
        N << attr("opens to" ,House>>"rooms">>"Master Bedroom");
      }else if( Comment == "в Ритину гардеробную" ){
        N << attr("opens from",House>>"rooms">>"Daughter's Closet");
        N << attr("opens to",House>>"rooms">>"Daughter's Bedroom");
      }
    }
  }end_attr_loop()
  House << attr("cycles",true);
}


//sNodePtr          Make_V_E_Bursian (sNodePtr Host)
//{
//  sNodePtr               VEB;
//  sNodePtr               D;
//  if( Host.IsNULL() ){
//    VEB = new sFolderNode;
//  }else{
//    Host |= "VEB";
//    VEB=Host >> sAttrName("VEB");
//  };

//  *VEB<<attr("Name","Bursian");
//  *VEB<<attr("FirstName","Victor E.");
//  *VEB<<"birth-date";
//  *VEB>>"birth-date"<<attr("year",1959)
//                    <<attr("month",5)
//                    <<attr("day",20);
//  //(rsIntegerNode)(*VEB>>"birth-date">>"day")=32;  //error
//  *VEB<<"wife";
//  *VEB<<"daughters";
//  *VEB>>"wife"<<"birth-date";
//  *VEB>>"wife">>"birth-date"<<attr("year",1962)
//                            <<attr("month",3)
//                            <<attr("day",26);
//  D = (*VEB>>"daughters").MakeSubcluster();
//  (*VEB>>"daughters")<<attr("quantity",1);
//  *D<<attr("Name","Rita");
//  *D<<"birth-date";
//  *D>>"birth-date"<<attr("year",1988)
//                  <<attr("month",7)
//                  <<attr("day",21);
//  D = (*VEB>>"daughters").MakeSubcluster();
//  (*VEB>>"daughters")<<attr("quantity",2);
//  *D<<attr("Name","Olga");
//  *D<<"birth-date";
//  *D>>"birth-date"<<attr("year",1980)
//                  <<attr("month",6)
//                  <<attr("day",27);

//  return VEB;
//};


//void              Print_V_E_Bursian (sNodePtr VEB)
//{
//  TRACE( (rsTextNode)(*VEB>>"Name") )
//  TRACE( (rsTextNode)(*VEB>>"FirstName") )
//
//  int Y = (rsIntegerNode)(*VEB>>"birth-date">>"year");  TRACE( Y )
//  int M = (rsIntegerNode)(*VEB>>"birth-date">>"month");  TRACE( M )
//  int D = (rsIntegerNode)(*VEB>>"birth-date">>"day");  TRACE( D )
//
//  TRACE( (rsIntegerNode)(*VEB>>"wife">>"birth-date">>"year") )
//  TRACE( (rsIntegerNode)(*VEB>>"wife">>"birth-date">>"month") )
//  //psIntegerNode LidasBirthDay = (psIntegerNode)
//  //                          &( *VEB>>"wife">>"birth-date">>"day" ); //error
//  //TRACE(*LidasBirthDay)
//  TRACE( (rsIntegerNode)(*VEB>>"wife">>"birth-date">>"day") )
//
//  sAttributeFinger            AF( *VEB>>"daughters" );
//  AF.SetToFirstNameless();
//  while( ! AF.IsNULL() ){
//    if( AF->Value()->IsNullNode() ){
//      TRACE( "Value==NULL" );
//    }else if( *(AF->Value()) <= sFolderNode::Type ){
//      TRACE( (rsTextNode)(*(AF->Value())>>"Name") )
//      TRACE( (rsIntegerNode)(*(AF->Value())>>"birth-date">>"day") )
//    }else{
//      TRACE( AF->Name().Text() );
//    };
//    ++AF;
//  };
//  TRACE( (rsIntegerNode)(*VEB>>"daughters">>"quantity") )
//}

//------------------------------------------------------------------------------
} //namespace RA
