// testNet.cpp ---
// Copyright(C) 2010, Viktor E. Bursian, St.Petersburg, Russia
//                         Viktor.Bursian@mail.ioffe.ru
////////////////////////////////////////////////////////////////////////////////
#include "Log.h"
#include "Environment.h"
#include "DB_SQL_Net.h"
#include "BasicNodes.h"
#include "TestGen.h"
#include "attr.h"
#include "NetExceptions.h"
#include "TestMemUsage.h"
#include "Trace.h"
#include <QApplication>
#include <typeinfo>

using namespace RA;
using namespace std;


int main(int argc, char *argv[])
{
//  TRACE( typeid(RA::sStorable).name() );
////  TRACE( typeid(RA::sStorable).hash() );
  RANet::Log.OpenBlock(sLog::Conditionless,"testNet"
                      ,"#####################################################");
  RANet::Log.SetShowSeverity(sLog::Debug);
  TestMemoryUsage("initially");

  try{

    { sEnvironment(argc,argv); }; //initiates sEnvironment's static members

    QApplication                A(argc,argv);

    sDB_SQL_Net                 Net ("root.RANet.sqlight");

    if( sEnvironment::Param("install") ){
      if( ! Net.CreateNew() )
        return 11;
    };
    if( ! Net.Open() )
      return 12;

    TestMemoryUsage("1");

//    sNodePtr                    MyHouse = GenerateHouseTree(Net.Root());
//    Net.Root()>>"House">>"rooms">>"Kitchen">>"Furniture">>"Пенал"
//        <<attr("hight",sPhysValue(2.02,"m"));

//    TRACE( (MyHouse>>"rooms">>"Kitchen">>"name")->Text(Plain) );

    TRACE( (Net.Root()>>"House">>"rooms">>"Kitchen">>"name")->Text(Plain) );
    TRACE( (Net.Root()>>"House">>"rooms">>"Kitchen">>"Furniture">>"Пенал"
        >>"hight")->Text(Plain) );

    TestMemoryUsage("2");
    TRACE(Net.SaveAll());
    TestMemoryUsage("3");

  }catch( rxNet E ){
    RANet::Log.Put(sLog::Debug,"testNet","net exception");
  }catch( rxProgramError E ){
    E.Report();
  };
  TestMemoryUsage("finally");

  RANet::Log.CloseBlock(sLog::Conditionless,"testNet");
  return 0;
}
