################################################################################
#
################################################################################

#_________Version_______________________________________________________________
                                 # common for all targets (exe,lib,plugin),
                                 # indicates their compatibility
VER_MAJ = 1   # = 0, 1, 2,..
VER_MIN = 5   # = 0, 1, 2,..

#_________Release/patch version_________________________________________________
CORE_VER_PAT = 0
                                 # can be reassigned for particular target
VER_PAT = 0   # = 0-alpha, 0-beta, 0, 1-alpha, 1-beta, 1, ...

#_______________________________________________________________________________
CONFIG += c++11

# The following define makes your compiler emit warnings if you use
# any Qt feature that has been marked deprecated (the exact warnings
# depend on your compiler). Please consult the documentation of the
# deprecated API in order to know how to port your code away from it.
#DEFINES += QT_DEPRECATED_WARNINGS
#DEFINES -= QT_DEPRECATED_WARNINGS

# You can also make your code fail to compile if it uses deprecated APIs.
# In order to do so, uncomment the following line.
# You can also select to disable deprecated APIs only up to a certain version of Qt.
#DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x060000    # disables all the APIs deprecated before Qt 6.0.0

#Сочетание Qt5.12 и GCC 9 генерит тучу предупреждений. 
#Некоторые по делу, но многие - не моя вина. Это помогает избавиться:
equals(QT_MAJOR_VERSION,5){
  equals(QT_MINOR_VERSION,12){
    QMAKE_CXXFLAGS_WARN_ON += -Wno-deprecated-copy
  }
}

# А с этими опциями надо играть осторожно. Меняют соглашения о вызовах.
# См.: https://stackoverflow.com/questions/29730626/how-to-define-a-80-bit-size-variable
# Вроде бы, эти опции влияют на размер в памяти
# (включая заполненные нулями лишние биты),
# но не на точность представления:
#       -m96bit-long-double    -- default for 32bit
#       -m128bit-long-double
# А эти на точность (должны, но не обязаны):
#       -mlong-double-64
#       -mlong-double-80
#       -mlong-double-128    -- makes long double = __float128;
#                               default for Bionic C library
#QMAKE_CXXFLAGS += -mlong-double-80 # compiles, works, no effect
#QMAKE_CXXFLAGS += -mlong-double-80  -mno-align-double # same
#QMAKE_CXXFLAGS += -mlong-double-80 -m96bit-long-double # compilation fails
#QMAKE_CXXFLAGS += -mlong-double-80 -mno-align-double -m96bit-long-double # same

DEFINES += RA_VERS_MAJOR=$${VER_MAJ}
DEFINES += RA_VERS_MINOR=$${VER_MIN}
contains( CONFIG, plugin ){
    DEFINES += RAP_VERS_MAJOR=$${VER_MAJ}
    DEFINES += RAP_VERS_MINOR=$${VER_MIN}
}

RADIR = $$clean_path($$PWD)/

CONFIG(release, debug|release) {
    #message( "_____________________ release" )
    DESTDIR     = $${RADIR}bin/
}else{
    #message( "_____________________ debug" )
    DEFINES += RANET_DEBUG
    DESTDIR = $${RADIR}bin-debug/
    DEBUG_SUFFIX = d
}
LIB_SUFFIX = $${DEBUG_SUFFIX}
win32: LIB_SUFFIX = $${LIB_SUFFIX}$${VER_MAJ}
LIBS	+= -L$${DESTDIR}

CODECFORTR = UTF-8
#^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
