////////////////////////////////////////////////////////////////////////////////
/*! @file AdminJob.h   Background job execution for RAdmin.
- Part of RAdmin project.
- Uses  RANet - Research Assistant Net Library.
- Uses  Qt v.5  - http://qt.io/
- Copyright(C) 2020, Viktor E. Bursian, St.Petersburg, Russia.
                     VBursian AT gmail DOT com
*///////////////////////////////////////////////////////////////////////////////
#ifndef AdminJob_H
#define AdminJob_H
#include "ScriptJob.h"
#include "DB_Link.h"
namespace RA {
//------------------------------------------------------------------------------
//---------------------------------------------------------------- sAdminJob ---

class sAdminJob : public sScriptJob
{
  Q_OBJECT
  public:
    explicit                  sAdminJob (const QString &  script
                                        ,QObject *        parent = nullptr)
                                  :sScriptJob(script,parent)
                                {}

  protected:
    virtual void              FindAndExecute (const QString &  job_name
                                             ,QStringList &    params
                                             ) /*override*/;

  private: //the jobs
    void                      DummyJob (QStringList &  params);
    void                      AvailableSQLDrivers (QStringList &  params);
    void                      CreateNewPartition (QStringList &  params);
    void                      ReplicatePartition (QStringList &  params);
    void                      AbsorbAllRelatedPartitions (QStringList & params);
    void                      CureRelatedPartitionsTable (QStringList & params);


  private: //utilized in jobs
    bool                      ReplicatePartNodes (rcsDB_Link  source
                                                 ,rcsDB_Link  destination);
    bool                      ReplicatePartAttrs (rcsDB_Link  source
                                                 ,rcsDB_Link  destination);
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
