////////////////////////////////////////////////////////////////////////////////
/*! @file ProtoNet.h   Примитивнейшая реализация сети RANet.
- Part of RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2006-2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef ProtoNet_H
#define ProtoNet_H
#include "Net.h"
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sProtoNet)

//------------------------------------------------------------------------------

class RANet_EXPORT  sProtoNet : public sNet
{
  public:
                              sProtoNet ()
                                {};
  public:
    virtual tNodeUID          GetNewNodeUID ();
    virtual psNode            GetNode (psNodeLocation);
    virtual void              ReleaseNode (tNodeUID)
                                {};
    virtual void              Allocate (rcsAttribute ,psNode)
                                {};
    virtual void              AllocateMandatory (psNode
                                                ,sNodeLocation::eType
                                                ,rcsString  /*Path*/)
                                {};
    virtual void              Allocate (psNode)
                                {};
    virtual void              PreallocateNode (psNode          /*Node*/
                                              ,sNodePtr        /*Host*/
                                              ,sAttributeName )
                                {};
    virtual bool              SaveNode (psNode)
                                { return false; };
    virtual bool              GetReadingAccess (sNodePtr)
                                { return true; };
    virtual void              ReleaseReadingAccess (sNodePtr)
                                {};
    virtual bool              GetFullAccess (sNodePtr)
                                { return true; };
    virtual void              ReleaseFullAccess (sNodePtr)
                                {};
    virtual bool              TooLongWaiting ()
                                { return false; };
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
