////////////////////////////////////////////////////////////////////////////////
/*! @file SingleFileNet.cpp Реализация сети RANet, размещающая всю сеть в
                            одном файле, загружаемом целиком в начале работы и
                            выгружаемом только в самом конце.
- Part of RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2006-2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#include "SingleFileNet.h"
#include "FolderNode.h"
namespace RA {
//------------------------------------------------------------------------------
//----------------------------------------------------------- sSingleFileNet ---

sSingleFileNet::~sSingleFileNet ()
{
  RootFile.Open(sObjectFile::Writing);
  RootFile.WRITE_FROM(LastUsedNodeUID);
  Root.Store(RootFile);
  RootFile.Close();
};


sSingleFileNet::sSingleFileNet (sPath  ARootFilePath)
    :RootFilePath(ARootFilePath)
{
  RootFile.Assign(RootFilePath.PathStr());
  try{
    RootFile.Open(sObjectFile::Reading);
    RootFile.READ_INTO(LastUsedNodeUID);
    Root=sNodePtr(RootFile);
    RootFile.Close();
  }catch(...){
  };
  if( Root.IsNULL() ){
    LastUsedNodeUID=LastReservedNodeUID;
    Root=sNodePtr(new sFolderNode);
  };
};

//------------------------------------------------------------------------------
}; //namespace RA
