////////////////////////////////////////////////////////////////////////////////
/*! @file SingleFileNet.h   Реализация сети RANet, размещающая всю сеть в
                            одном файле, загружаемом целиком в начале работы и
                            выгружаемом только в самом конце.
- Part of RANet - Research Assistant Net Library (based on ANSI C++).
- Copyright(C) 2006-2010, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef SingleFileNet_H
#define SingleFileNet_H
#include "Net.h"
#include "Environment.h"
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sSingleFileNet)

//------------------------------------------------------------------------------

class RANet_EXPORT  sSingleFileNet : public sProtoNet
{
  public:
    virtual                   ~sSingleFileNet ();
                              sSingleFileNet (sPath);
  public:
    virtual tNodeUID          GetNewNodeUID ()
                                { return ++LastUsedNodeUID; };
  private: //fields
    sPath                     RootFilePath;
    sObjectFile               RootFile;
};

//------------------------------------------------------------------------------
}; //namespace RA
#endif // SingleFileNet_H
