////////////////////////////////////////////////////////////////////////////////
/*! @file MSDNSpy.h   Шпион-диверсант для отладки устройств MSDN.
- Part of DevelopmentTools - Research Assistant Plugin package.
- Uses  RAGUI - Research Assistant Graphical User Interface Library.
- Uses  Qt v.5.0.2  - http://qt-project.org/
- Uses  RANet - Research Assistant Net Library.
- Copyright(C) 2013, Viktor E. Bursian, St.Petersburg, Russia.
                     Viktor.Bursian@mail.ioffe.ru
*///////////////////////////////////////////////////////////////////////////////
#ifndef MSDNSpy_H
#define MSDNSpy_H
#include "DevelopmentTools.h"
#include "TeleSpy.h"
namespace RA {
//------------------------------------------------------------------------------

ANNOUNCE_CLASS(sMSDNSpy)

//----------------------------------------------------------------- sMSDNSpy ---
/*! Шпион-диверсант для отладки устройств MSDN: отличается от своего базового
    класса sTeleSpy тем, что с учётом принятого для MSDN синтаксиса команд и
    сообщений распознаёт и преобразовывает числа из шестнадцатиричной системы
    в десятичную и наоборот.


*/
class  DevelopmentTools_EXPORT  sMSDNSpy : public sTeleSpy
{
  Q_OBJECT
  CONSOLE(sMSDNSpy)
  public:
    static void               Translate2Hex (rsTelex);

  protected: //reimplementing inherited
    virtual void              Show (literal,sTelex);

  protected slots: //reimplementing inherited
    virtual void              OnTypedInLeft (sTelex);
    virtual void              OnTypedInRight (sTelex);
};

//------------------------------------------------------------------------------
} //namespace RA
#endif
